/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2012, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2012, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("component/smartnames/encoding/smartnamestringpart",["require","exports","module"],function(i,e){var l=function(){};(function(){this.isSmartNamePart=function(){return null!==this._smartName};this.isTextPart=function(){return null!==this._text};this.getAsSmartName=function(){return this._smartName};this.getAsText=function(){return this._text}}).call(l.prototype);e.makeSmartNamePart=function(f){if(null==f)throw'A "SmartName" part of a SmartName string can not be null.';var e=new l;e._smartName=
f;e._text=null;return e};e.makePlainTextPart=function(f){if(null==f)throw'A "Text" part of a SmartName string can not be null.';var e=new l;e._smartName=null;e._text=f;return e}});
define("utils/wcrerror",[],function(){var i=function(e,l){Error.call(this);this.errormessage=l;this.langTag=e;this.message=(this.errormessage?this.errormessage+" ":"")+(this.langTag?"(langTag: "+this.langTag+")":"")};i.prototype=Object.create(Error.prototype);i.prototype.constructor=i;i.prototype.name="WCRError";i.prototype.getTag=function(){return this.langTag};return i});
define("utils/extendedstring",[],function(){String.prototype.replaceAll=function(i,e){return void 0===e?this.toString():this.split(i).join(e)};return null});
define("component/smartnames/encoding/smartnameargumentencoding",["utils/wcrerror","utils/extendedstring"],function(i){var e={},l=function(f,e){this._delimeterChar=f;this._escapeChar=e};(function(){this.encodeSmartName=function(f,e){for(var j=f,h=0;h<e.length;h++)var d=e[h].replaceAll(this._escapeChar,this._escapeChar+this._escapeChar).replaceAll(this._delimeterChar,this._escapeChar+this._delimeterChar),j=j+this._delimeterChar,j=j+d;return j.toString()};this.decodeSmartNameArguments=function(f){for(var e=
[],j=!1,h="",d=0;d<f.length;d++){var c=f.charAt(d);if(c===this._escapeChar)j&&(h+=this._escapeChar),j=!j;else if(c===this._delimeterChar)j?(h+=this._delimeterChar,j=!1):(e.push(h),h="");else{if(j)throw new i("SMARTNAME_ARGUMENT_PARSING_ILLEGAL_ESCAPE_CHARACTER","Parsing of arguments of SmartName failed. Found a single escape character in the string.");h+=c}}e.push(h);if(j)throw new i("SMARTNAME_ARGUMENT_PARSING_ILLEGAL_ESCAPE_CHARACTER","Parsing of arguments of SmartName failed. Found a single escape character in the string.");
return e}}).call(l.prototype);e.DEFAULT=new l(":","\\");e.constructor=l;return e});
define("component/smartnames/encoding/smartname",["../encoding/smartnameargumentencoding"],function(i){var e=function(){if(1===arguments.length){var e=i.DEFAULT.decodeSmartNameArguments(arguments[0]);this._name=e[0];this._arguments=1<e.length?e.slice(1,e.length):[]}else if(1<arguments.length)this._name=arguments[0],2==arguments.length&&arguments[1].constructor==Array?this._arguments=arguments[1]:(this._arguments=Array.prototype.slice.call(arguments),this._arguments=this._arguments.slice(1,this._arguments.length));
else if(1>arguments.length)throw Error("A SmartName requires at least one 'name' parameter.");};(function(){this.getName=function(){return this._name};this.getArguments=function(){return this._arguments};this.getFullName=function(){return i.DEFAULT.encodeSmartName(this._name,this._arguments)};this.equals=function(i){if(i instanceof e){var f=i.getName()===this.getName(),i=this._compareArguments(i);return f&&i}return!1};this._compareArguments=function(e){if(this._arguments.length===e.getArguments().length){for(var f=
0;f<this._arguments.length;f++)if(this._arguments[f]!==e.getArguments()[f])return!1;return!0}return!1};this.getDisplayName=function(){return"ProjAttr"==this._name?this._arguments[0]+" (Project)":"DocAttr"==this._name?this._arguments[0]+" (Document)":this.getFullName()}}).call(e.prototype);return e});
define("component/smartnames/encoding/smartnameencoding",["./smartnamestringpart","./smartname","utils/wcrerror","underscore","utils/extendedstring"],function(i,e,l,f){function m(d){if(!1===d)throw Error("Something is wrong in the implementation of the SmartNameEncoding. Assert failed.");}var j={},h=function(d,c,g){this._startOfSmartName=d;this._endOfSmartName=c;this._escapeChar=g;this._charactersToEscape=[];for(var a=g+d+c,b=0;b<a.length;b++){var h=a.charAt(b);f.contains(this._charactersToEscape,
h)||this._charactersToEscape.push(h)}m(-1===d.indexOf(g));m(-1===c.indexOf(g))};(function(){this.escapeString=function(d){for(var c=0;c<this._charactersToEscape.length;c++)d=d.replaceAll(""+this._charactersToEscape[c],""+this._escapeChar+this._charactersToEscape[c]);return d};this.unescapeString=function(d){for(var c=this._charactersToEscape.length-1;0<=c;c--)d=d.replaceAll(""+this._escapeChar+this._charactersToEscape[c],""+this._charactersToEscape[c]);return d};this.encodeSmartNameString=function(d){for(var c=
"",g="",a=0;a<d.length;a++){var b=d[a];b.isTextPart()?g+=b.getAsText():(c+=this.escapeString(g),g="",c+=this._startOfSmartName,c+=this.escapeString(b.getAsSmartName().getFullName()),c+=this._endOfSmartName)}return c+=this.escapeString(g)};this.decodeSmartNameString=function(d){for(var c=[],g=!1,a="",b=0;b<d.length;b++){var h=d.charAt(b);if(h===this._escapeChar)if(b+1<d.length){h=d.charAt(b+1);if(!f.contains(this._charactersToEscape,h))throw new l("SMARTNAME_PARSING_ILLEGAL_ESCAPE_CHARACTER","Parsing of string with SmartNames failed. Found a single escape character in the string.");
a+=h;b++}else throw new l("SMARTNAME_PARSING_ILLEGAL_ESCAPE_CHARACTER","Parsing of string with SmartNames failed. Found a single escape character in the string.");else if(b+this._startOfSmartName.length<=d.length&&this._startOfSmartName===d.substring(b,b+this._startOfSmartName.length)){if(g)throw new l("SMARTNAME_PARSING_SMARTNAME_ALREADY_OPEN","Parsing of string with SmartNames failed. SmartName started within a SmartName.");0<a.length&&c.push(i.makePlainTextPart(a));a="";g=!0;b+=this._startOfSmartName.length-
1}else if(b+this._endOfSmartName.length<=d.length&&this._endOfSmartName===d.substring(b,b+this._endOfSmartName.length)){if(g)c.push(i.makeSmartNamePart(new e(a))),a="",g=!1;else throw new l("SMARTNAME_PARSING_SMARTNAME_NOT_OPEN","Parsing of string with SmartNames failed. SmartName was closed before the SmartName was opened.");b+=this._endOfSmartName.length-1}else a+=h}if(g)throw new l("SMARTNAME_PARSING_SMARTNAME_NEVER_CLOSED","Parsing of string with SmartNames failed. SmartName was never closed.");
0<a.length&&c.push(i.makePlainTextPart(a));return c};this.containsSmartName=function(d){for(var d=this.decodeSmartNameString(d),c=0;c<d.length;c++)if(d[c].isSmartNamePart())return!0;return!1};this.modifySmartNameEncodedString=function(d,c,g){if(void 0===c||null===c)c=function(a){return a};if(void 0===g||null===g)g=function(a){return a};for(var d=this.decodeSmartNameString(d),a=0;a<d.length;a++){var b=d[a];b.isSmartNamePart()?(b=b.getAsSmartName(),b=g(b),d[a]=i.makeSmartNamePart(b)):(b=b.getAsText(),
b=c(b),d[a]=i.makePlainTextPart(b))}return this.encodeSmartNameString(d)}}).call(h.prototype);j.SAVEDSEARCH=new h("{","}","!");j.AUTONAMING=new h("[","]","\u00a7");j.UNIVERSALCOPYPASTEENCODING=new h("[","]","\\");j.constructor=h;return j});
define("lib/ace/snippets","require exports module ./lib/oop ./lib/event_emitter ./lib/lang ./range ./anchor ./keyboard/hash_handler ./tokenizer ./lib/dom ./editor".split(" "),function(i,e){var l=i("./lib/oop"),f=i("./lib/event_emitter").EventEmitter,m=i("./lib/lang"),j=i("./range").Range;i("./anchor");var h=i("./keyboard/hash_handler").HashHandler,d=i("./tokenizer").Tokenizer,c=j.comparePoints,g=function(){this.snippetMap={};this.snippetNameMap={}};(function(){l.implement(this,f);this.getTokenizer=
function(){function k(k,a,b){k=k.substr(1);return/^\d+$/.test(k)&&!b.inFormatString?[{tabstopId:parseInt(k,10)}]:[{text:k}]}function a(k){return"(?:[^\\\\"+k+"]|\\\\.)"}g.$tokenizer=new d({start:[{regex:/:/,onMatch:function(k,a,b){return b.length&&b[0].expectIf?(b[0].expectIf=!1,b[0].elseBranch=b[0],[b[0]]):":"}},{regex:/\\./,onMatch:function(k,a,b){a=k[1];"}"==a&&b.length?k=a:-1!="`$\\".indexOf(a)?k=a:b.inFormatString&&("n"==a?k="\n":"t"==a?k="\n":-1!="ulULE".indexOf(a)&&(k={changeCase:a,local:"a"<
a}));return[k]}},{regex:/}/,onMatch:function(k,a,b){return[b.length?b.shift():k]}},{regex:/\$(?:\d+|\w+)/,onMatch:k},{regex:/\$\{[\dA-Z_a-z]+/,onMatch:function(a,b,c){a=k(a.substr(1),b,c);c.unshift(a[0]);return a},next:"snippetVar"},{regex:/\n/,token:"newline",merge:!1}],snippetVar:[{regex:"\\|"+a("\\|")+"*\\|",onMatch:function(k,a,b){b[0].choices=k.slice(1,-1).split(",")},next:"start"},{regex:"/("+a("/")+"+)/(?:("+a("/")+"*)/)(\\w*):?",onMatch:function(k,a,b){a=b[0];a.fmtString=k;k=this.splitRegex.exec(k);
a.guard=k[1];a.fmt=k[2];a.flag=k[3];return""},next:"start"},{regex:"`"+a("`")+"*`",onMatch:function(k,a,b){b[0].code=k.splice(1,-1);return""},next:"start"},{regex:"\\?",onMatch:function(k,a,b){b[0]&&(b[0].expectIf=!0)},next:"start"},{regex:"([^:}\\\\]|\\\\.)*:?",token:"",next:"start"}],formatString:[{regex:"/("+a("/")+"+)/",token:"regex"},{regex:"",onMatch:function(k,a,b){b.inFormatString=!0},next:"start"}]});g.prototype.getTokenizer=function(){return g.$tokenizer};return g.$tokenizer};this.tokenizeTmSnippet=
function(k,a){return this.getTokenizer().getLineTokens(k,a).tokens.map(function(k){return k.value||k})};this.$getDefaultValue=function(k,a){if(/^[A-Z]\d+$/.test(a)){var b=a.substr(1);return(this.variables[a[0]+"__"]||{})[b]}if(/^\d+$/.test(a))return(this.variables.__||{})[a];a=a.replace(/^TM_/,"");if(k)switch(b=k.session,a){case "CURRENT_WORD":var c=b.getWordRange();case "SELECTION":case "SELECTED_TEXT":return b.getTextRange(c);case "CURRENT_LINE":return b.getLine(k.getCursorPosition().row);case "PREV_LINE":return b.getLine(k.getCursorPosition().row-
1);case "LINE_INDEX":return k.getCursorPosition().column;case "LINE_NUMBER":return k.getCursorPosition().row+1;case "SOFT_TABS":return b.getUseSoftTabs()?"YES":"NO";case "TAB_SIZE":return b.getTabSize();case "FILENAME":case "FILEPATH":return"";case "FULLNAME":return"Ace"}};this.variables={};this.getVariableValue=function(k,a){return this.variables.hasOwnProperty(a)?this.variables[a](k,a)||"":this.$getDefaultValue(k,a)||""};this.tmStrFormat=function(a,b,c){var d=b.guard,d=RegExp(d,(b.flag||"").replace(/[^gi]/,
"")),g=this.tokenizeTmSnippet(b.fmt,"formatString"),f=this,a=a.replace(d,function(){f.variables.__=arguments;for(var a=f.resolveVariables(g,c),k="E",b=0;b<a.length;b++){var d=a[b];if("object"==typeof d)if(a[b]="",d.changeCase&&d.local){var p=a[b+1];p&&"string"==typeof p&&(a[b]="u"==d.changeCase?p[0].toUpperCase():p[0].toLowerCase(),a[b+1]=p.substr(1))}else d.changeCase&&(k=d.changeCase);else"U"==k?a[b]=d.toUpperCase():"L"==k&&(a[b]=d.toLowerCase())}return a.join("")});this.variables.__=null;return a};
this.resolveVariables=function(a,b){function d(b){b=a.indexOf(b,g+1);-1!=b&&(g=b)}for(var c=[],g=0;g<a.length;g++){var f=a[g];if("string"==typeof f)c.push(f);else if("object"==typeof f)if(f.skip)d(f);else if(!(f.processed<g))if(f.text){var h=this.getVariableValue(b,f.text);h&&f.fmtString&&(h=this.tmStrFormat(h,f));f.processed=g;null==f.expectIf?h&&(c.push(h),d(f)):h?f.skip=f.elseBranch:d(f)}else null!=f.tabstopId?c.push(f):null!=f.changeCase&&c.push(f)}return c};this.insertSnippetForSelection=function(b,
d){var c=b.getCursorPosition(),g=b.session.getLine(c.row),f=b.session.getTabString(),h=g.match(/^\s*/)[0];c.column<h.length&&(h=h.slice(0,c.column));var e=this.tokenizeTmSnippet(d),e=this.resolveVariables(e,b),e=e.map(function(a){return"\n"==a?a+h:"string"==typeof a?a.replace(/\t/g,f):a}),n=[];e.forEach(function(a,b){if("object"==typeof a){var k=a.tabstopId,c=n[k];c||(c=n[k]=[],c.index=k,c.value="");if(-1===c.indexOf(a)&&(c.push(a),k=e.indexOf(a,b+1),-1!==k))if(k=e.slice(b+1,k),k.some(function(a){return"object"===
typeof a})&&!c.value)c.value=k;else if(k.length&&(!c.value||"string"!==typeof c.value))c.value=k.join("")}});n.forEach(function(a){a.length=0});c={};for(g=0;g<e.length;g++){var q=e[g];if("object"==typeof q){var j=q.tabstopId,i=e.indexOf(q,g+1);if(c[j])c[j]===q&&(c[j]=null);else{var m=n[j],l;if("string"==typeof m.value)l=[m.value];else{l=m.value;for(var w=[],t=0;t<l.length;t++){var s=l[t];if("object"==typeof s){if(c[s.tabstopId])continue;var A=l.lastIndexOf(s,t-1),s=w[A]||{tabstopId:s.tabstopId}}w[t]=
s}l=w}l.unshift(g+1,Math.max(0,i-g));l.push(q);c[j]=q;e.splice.apply(e,l);-1===m.indexOf(q)&&m.push(q)}}}var x=0,u=0,y="";e.forEach(function(a){"string"===typeof a?("\n"===a[0]?(u=a.length-1,x++):u+=a.length,y+=a):a.start?a.end={row:x,column:u}:a.start={row:x,column:u}});c=b.getSelectionRange();g=b.session.replace(c,y);(new a(b)).addTabstops(n,c.start,g,b.inVirtualSelectionMode&&b.selection.index)};this.insertSnippet=function(a,b){var c=this;if(a.inVirtualSelectionMode)return c.insertSnippetForSelection(a,
b);a.forEachSelection(function(){c.insertSnippetForSelection(a,b)},null,{keepOrder:!0});a.tabstopManager&&a.tabstopManager.tabNext()};this.$getScope=function(a){var b=a.session.$mode.$id||"",b=b.split("/").pop();if("html"===b||"php"===b){"php"===b&&!a.session.$mode.inlinePhp&&(b="html");var c=a.getCursorPosition(),a=a.session.getState(c.row);"object"===typeof a&&(a=a[0]);a.substring&&("js-"==a.substring(0,3)?b="javascript":"css-"==a.substring(0,4)?b="css":"php-"==a.substring(0,4)&&(b="php"))}return b};
this.getActiveScopes=function(a){var a=this.$getScope(a),b=[a],c=this.snippetMap;c[a]&&c[a].includeScopes&&b.push.apply(b,c[a].includeScopes);b.push("_");return b};this.expandWithTab=function(a,b){var c=this,d=a.forEachSelection(function(){return c.expandSnippetForSelection(a,b)},null,{keepOrder:!0});d&&a.tabstopManager&&a.tabstopManager.tabNext();return d};this.expandSnippetForSelection=function(a,b){var c=a.getCursorPosition(),d=a.session.getLine(c.row),g=d.substring(0,c.column),f=d.substr(c.column),
h=this.snippetMap,e;this.getActiveScopes(a).some(function(a){(a=h[a])&&(e=this.findMatchingSnippet(a,g,f));return!!e},this);if(!e)return!1;if(b&&b.dryRun)return!0;a.session.doc.removeInLine(c.row,c.column-e.replaceBefore.length,c.column+e.replaceAfter.length);this.variables.M__=e.matchBefore;this.variables.T__=e.matchAfter;this.insertSnippetForSelection(a,e.content);this.variables.M__=this.variables.T__=null;return!0};this.findMatchingSnippet=function(a,b,c){for(var d=a.length;d--;){var g=a[d];if(!g.startRe||
g.startRe.test(b))if(!g.endRe||g.endRe.test(c))if(g.startRe||g.endRe)return g.matchBefore=g.startRe?g.startRe.exec(b):[""],g.matchAfter=g.endRe?g.endRe.exec(c):[""],g.replaceBefore=g.triggerRe?g.triggerRe.exec(b)[0]:"",g.replaceAfter=g.endTriggerRe?g.endTriggerRe.exec(c)[0]:"",g}};this.snippetMap={};this.snippetNameMap={};this.register=function(a,b){function c(a){a&&!/^\^?\(.*\)\$?$|^\\b$/.test(a)&&(a="(?:"+a+")");return a||""}function g(a,b,k){a=c(a);b=c(b);k?(a=b+a)&&"$"!=a[a.length-1]&&(a+="$"):
(a+=b)&&"^"!=a[0]&&(a="^"+a);return RegExp(a)}function d(a){a.scope||(a.scope=b||"_");b=a.scope;f[b]||(f[b]=[],h[b]={});var c=h[b];if(a.name){var k=c[a.name];k&&e.unregister(k);c[a.name]=a}f[b].push(a);a.tabTrigger&&!a.trigger&&(!a.guard&&/^\w/.test(a.tabTrigger)&&(a.guard="\\b"),a.trigger=m.escapeRegExp(a.tabTrigger));a.startRe=g(a.trigger,a.guard,!0);a.triggerRe=RegExp(a.trigger,"",!0);a.endRe=g(a.endTrigger,a.endGuard,!0);a.endTriggerRe=RegExp(a.endTrigger,"",!0)}var f=this.snippetMap,h=this.snippetNameMap,
e=this;a||(a=[]);a&&a.content?d(a):Array.isArray(a)&&a.forEach(d);this._signal("registerSnippets",{scope:b})};this.unregister=function(a,b){function c(a){var k=d[a.scope||b];k&&k[a.name]&&(delete k[a.name],a=(k=g[a.scope||b])&&k.indexOf(a),0<=a&&k.splice(a,1))}var g=this.snippetMap,d=this.snippetNameMap;a.content?c(a):Array.isArray(a)&&a.forEach(c)};this.parseSnippetFile=function(a){for(var a=a.replace(/\r/g,""),b=[],c={},g=/^#.*|^({[\s\S]*})\s*$|^(\S+) (.*)$|^((?:\n*\t.*)+)/gm,d;d=g.exec(a);){if(d[1])try{c=
JSON.parse(d[1]),b.push(c)}catch(f){}if(d[4])c.content=d[4].replace(/^\t/gm,""),b.push(c),c={};else{var h=d[2];d=d[3];"regex"==h?(h=/\/((?:[^\/\\]|\\.)*)|$/g,c.guard=h.exec(d)[1],c.trigger=h.exec(d)[1],c.endTrigger=h.exec(d)[1],c.endGuard=h.exec(d)[1]):"snippet"==h?(c.tabTrigger=d.match(/^\S*/)[0],c.name||(c.name=d)):c[h]=d}}return b};this.getSnippetByName=function(a,b){var c=this.snippetNameMap,d;this.getActiveScopes(b).some(function(b){(b=c[b])&&(d=b[a]);return!!d},this);return d}}).call(g.prototype);
var a=function(a){if(a.tabstopManager)return a.tabstopManager;a.tabstopManager=this;this.$onChange=this.onChange.bind(this);this.$onChangeSelection=m.delayedCall(this.onChangeSelection.bind(this)).schedule;this.$onChangeSession=this.onChangeSession.bind(this);this.$onAfterExec=this.onAfterExec.bind(this);this.attach(a)};(function(){this.attach=function(a){this.index=0;this.ranges=[];this.tabstops=[];this.selectedTabstop=this.$openTabstops=null;this.editor=a;this.editor.on("change",this.$onChange);
this.editor.on("changeSelection",this.$onChangeSelection);this.editor.on("changeSession",this.$onChangeSession);this.editor.commands.on("afterExec",this.$onAfterExec);this.editor.keyBinding.addKeyboardHandler(this.keyboardHandler)};this.detach=function(){this.tabstops.forEach(this.removeTabstopMarkers,this);this.selectedTabstop=this.tabstops=this.ranges=null;this.editor.removeListener("change",this.$onChange);this.editor.removeListener("changeSelection",this.$onChangeSelection);this.editor.removeListener("changeSession",
this.$onChangeSession);this.editor.commands.removeListener("afterExec",this.$onAfterExec);this.editor.keyBinding.removeKeyboardHandler(this.keyboardHandler);this.editor=this.editor.tabstopManager=null};this.onChange=function(a){var b=a.data.range,a="r"==a.data.action[0],d=b.start,g=b.end,b=d.row,f=g.row-b,h=g.column-d.column;a&&(f=-f,h=-h);if(!this.$inChange&&a){var e=this.selectedTabstop;if(e&&!e.some(function(a){return 0>=c(a.start,d)&&0<=c(a.end,g)}))return this.detach()}for(var e=this.ranges,
n=0;n<e.length;n++){var j=e[n];j.end.row<d.row||(a&&0>c(d,j.start)&&0<c(g,j.end)?(this.removeRange(j),n--):(j.start.row==b&&j.start.column>d.column&&(j.start.column+=h),j.end.row==b&&j.end.column>=d.column&&(j.end.column+=h),j.start.row>=b&&(j.start.row+=f),j.end.row>=b&&(j.end.row+=f),0<c(j.start,j.end)&&this.removeRange(j)))}e.length||this.detach()};this.updateLinkedFields=function(){var a=this.selectedTabstop;if(a&&a.hasLinkedRanges){this.$inChange=!0;for(var b=this.editor.session,c=b.getTextRange(a.firstNonLinked),
d=a.length;d--;){var g=a[d];if(g.linked){var f=e.snippetManager.tmStrFormat(c,g.original);b.replace(g,f)}}this.$inChange=!1}};this.onAfterExec=function(a){a.command&&!a.command.readOnly&&this.updateLinkedFields()};this.onChangeSelection=function(){if(this.editor){for(var a=this.editor.selection.lead,b=this.editor.selection.anchor,c=this.editor.selection.isEmpty(),d=this.ranges.length;d--;)if(!this.ranges[d].linked){var g=this.ranges[d].contains(a.row,a.column),f=c||this.ranges[d].contains(b.row,b.column);
if(g&&f)return}this.detach()}};this.onChangeSession=function(){this.detach()};this.tabNext=function(a){var b=this.tabstops.length,a=this.index+(a||1),a=Math.min(Math.max(a,1),b);a==b&&(a=0);this.selectTabstop(a);0===a&&this.detach()};this.selectTabstop=function(a){this.$openTabstops=null;var b=this.tabstops[this.index];b&&this.addTabstopMarkers(b);this.index=a;if((b=this.tabstops[this.index])&&b.length){this.selectedTabstop=b;if(this.editor.inVirtualSelectionMode)this.editor.selection.setRange(b.firstNonLinked);
else{a=this.editor.multiSelect;a.toSingleRange(b.firstNonLinked.clone());for(var c=b.length;c--;)(!b.hasLinkedRanges||!b[c].linked)&&a.addRange(b[c].clone(),!0);a.ranges[0]&&a.addRange(a.ranges[0].clone())}this.editor.keyBinding.addKeyboardHandler(this.keyboardHandler)}};this.addTabstops=function(a,c,d){this.$openTabstops||(this.$openTabstops=[]);a[0]||(d=j.fromPoints(d,d),b(d.start,c),b(d.end,c),a[0]=[d],a[0].index=0);var g=[this.index+1,0],f=this.ranges;a.forEach(function(a,b){for(var d=this.$openTabstops[b]||
a,h=a.length;h--;){var k=a[h],e=j.fromPoints(k.start,k.end||k.start),n=e.start,o=c;0==n.row&&(n.column+=o.column);n.row+=o.row;n=e.end;o=c;0==n.row&&(n.column+=o.column);n.row+=o.row;e.original=k;e.tabstop=d;f.push(e);d!=a?d.unshift(e):d[h]=e;k.fmtString?(e.linked=!0,d.hasLinkedRanges=!0):d.firstNonLinked||(d.firstNonLinked=e)}d.firstNonLinked||(d.hasLinkedRanges=!1);d===a&&(g.push(d),this.$openTabstops[b]=d);this.addTabstopMarkers(d)},this);2<g.length&&(this.tabstops.length&&g.push(g.splice(2,1)[0]),
this.tabstops.splice.apply(this.tabstops,g))};this.addTabstopMarkers=function(a){var b=this.editor.session;a.forEach(function(a){a.markerId||(a.markerId=b.addMarker(a,"ace_snippet-marker","text"))})};this.removeTabstopMarkers=function(a){var b=this.editor.session;a.forEach(function(a){b.removeMarker(a.markerId);a.markerId=null})};this.removeRange=function(a){var b=a.tabstop.indexOf(a);a.tabstop.splice(b,1);b=this.ranges.indexOf(a);this.ranges.splice(b,1);this.editor.session.removeMarker(a.markerId);
a.tabstop.length||(b=this.tabstops.indexOf(a.tabstop),-1!=b&&this.tabstops.splice(b,1),this.tabstops.length||this.detach())};this.keyboardHandler=new h;this.keyboardHandler.bindKeys({Tab:function(a){(!e.snippetManager||!e.snippetManager.expandWithTab(a))&&a.tabstopManager.tabNext(1)},"Shift-Tab":function(a){a.tabstopManager.tabNext(-1)},Esc:function(a){a.tabstopManager.detach()},Return:function(){return!1}})}).call(a.prototype);var b=function(a,b){a.row==b.row&&(a.column-=b.column);a.row-=b.row};
i("./lib/dom").importCssString(".ace_snippet-marker {    -moz-box-sizing: border-box;    box-sizing: border-box;    background: rgba(194, 193, 208, 0.09);    border: 1px dotted rgba(211, 208, 235, 0.62);    position: absolute;}");e.snippetManager=new g;var n=i("./editor").Editor;(function(){this.insertSnippet=function(a,b){return e.snippetManager.insertSnippet(this,a,b)};this.expandSnippet=function(a){return e.snippetManager.expandWithTab(this,a)}}).call(n.prototype)});
define("lib/ace/autocomplete/popup","require exports module ../edit_session ../virtual_renderer ../editor ../range ../lib/event ../lib/lang ../lib/dom".split(" "),function(i,e){i("../edit_session");var l=i("../virtual_renderer").VirtualRenderer,f=i("../editor").Editor,m=i("../range").Range,j=i("../lib/event"),h=i("../lib/lang"),d=i("../lib/dom"),c=function(c){c=new l(c);c.$maxLines=4;c=new f(c);c.setHighlightActiveLine(!1);c.setShowPrintMargin(!1);c.renderer.setShowGutter(!1);c.renderer.setHighlightGutterLine(!1);
c.$mouseHandler.$focusWaitTimout=0;c.$highlightTagPending=!0;return c};d.importCssString(".ace_editor.ace_autocomplete .ace_marker-layer .ace_active-line {    background-color: #CAD6FA;    z-index: 1;}.ace_editor.ace_autocomplete .ace_line-hover {    border: 1px solid #abbffe;    margin-top: -1px;    background: rgba(233,233,253,0.4);}.ace_editor.ace_autocomplete .ace_line-hover {    position: absolute;    z-index: 2;}.ace_editor.ace_autocomplete .ace_scroller {   background: none;   border: none;   box-shadow: none;}.ace_rightAlignedText {    color: gray;    display: inline-block;    position: absolute;    right: 4px;    text-align: right;    z-index: -1;}.ace_editor.ace_autocomplete .ace_completion-highlight{    color: #000;    text-shadow: 0 0 0.01em;}.ace_editor.ace_autocomplete {    width: 280px;    z-index: 200000;    background: #fbfbfb;    color: #444;    border: 1px lightgray solid;    position: fixed;    box-shadow: 2px 3px 5px rgba(0,0,0,.2);    line-height: 1.4;}");
e.AcePopup=function(g){var a=d.createElement("div"),b=new c(a);g&&g.appendChild(a);a.style.display="none";b.renderer.content.style.cursor="default";b.renderer.setStyle("ace_autocomplete");b.setOption("displayIndentGuides",!1);b.setOption("dragDelay",150);g=function(){};b.focus=g;b.$isFocused=!0;b.renderer.$cursorLayer.restartTimer=g;b.renderer.$cursorLayer.element.style.opacity=0;b.renderer.$maxLines=8;b.renderer.$keepTextAreaAtCursor=!1;b.setHighlightActiveLine(!1);b.session.highlight("");b.session.$searchHighlight.clazz=
"ace_highlight-marker";b.on("mousedown",function(a){var c=a.getDocumentPosition();b.selection.moveToPosition(c);i.start.row=i.end.row=c.row;a.stop()});var f,e=new m(-1,0,-1,Infinity),i=new m(-1,0,-1,Infinity);i.id=b.session.addMarker(i,"ace_active-line","fullLine");b.setSelectOnHover=function(a){a?e.id&&(b.session.removeMarker(e.id),e.id=null):e.id=b.session.addMarker(e,"ace_line-hover","fullLine")};b.setSelectOnHover(!1);b.on("mousemove",function(a){f?f.x==a.x&&f.y==a.y||(f=a,f.scrollTop=b.renderer.scrollTop,
a=f.getDocumentPosition().row,e.start.row!=a&&(e.id||b.setRow(a),o(a))):f=a});b.renderer.on("beforeRender",function(){if(f&&-1!=e.start.row){f.$pos=null;var a=f.getDocumentPosition().row;e.id||b.setRow(a);o(a,!0)}});b.renderer.on("afterRender",function(){var a=b.getRow(),c=b.renderer.$textLayer,a=c.element.childNodes[a-c.config.firstRow];a!=c.selectedNode&&(c.selectedNode&&d.removeCssClass(c.selectedNode,"ace_selected"),(c.selectedNode=a)&&d.addCssClass(a,"ace_selected"))});var a=function(){o(-1)},
o=function(a,c){a!==e.start.row&&(e.start.row=e.end.row=a,c||b.session._emit("changeBackMarker"),b._emit("changeHoverMarker"))};b.getHoveredRow=function(){return e.start.row};j.addListener(b.container,"mouseout",a);b.on("hide",a);b.on("changeSelection",a);b.session.doc.getLength=function(){return b.data.length};b.session.doc.getLine=function(a){a=b.data[a];return"string"==typeof a?a:a&&a.value||""};a=b.session.bgTokenizer;a.$tokenizeRow=function(a){var a=b.data[a],c=[];if(!a)return c;"string"==typeof a&&
(a={value:a});a.caption||(a.caption=a.value||a.name);for(var d=-1,g,f,h=0;h<a.caption.length;h++)f=a.caption[h],g=a.matchMask&1<<h?1:0,d!==g?(c.push({type:a.className||""+(g?"completion-highlight":""),value:f}),d=g):c[c.length-1].value+=f;a.meta&&a.meta.length+a.caption.length<b.renderer.$size.scrollerWidth/b.renderer.layerConfig.characterWidth-2&&c.push({type:"rightAlignedText",value:a.meta});return c};a.$updateOnChange=g;a.start=g;b.session.$computeWidth=function(){return this.screenWidth=0};b.$blockScrolling=
Infinity;b.isOpen=!1;b.isTopdown=!1;b.data=[];b.setData=function(a){b.data=a||[];b.setValue(h.stringRepeat("\n",a.length),-1);b.setRow(0)};b.getData=function(a){return b.data[a]};b.getRow=function(){return i.start.row};b.setRow=function(a){a=Math.max(-1,Math.min(this.data.length,a));i.start.row!=a&&(b.selection.clearSelection(),i.start.row=i.end.row=a||0,b.session._emit("changeBackMarker"),b.moveCursorTo(a||0,0),b.isOpen&&b._signal("select"))};b.on("changeSelection",function(){b.isOpen&&b.setRow(b.selection.lead.row);
b.renderer.scrollCursorIntoView()});b.hide=function(){this.container.style.display="none";this._signal("hide");b.isOpen=!1};b.show=function(a,c,d){var g=this.container,h=window.innerHeight,e=window.innerWidth,k=a.top+this.$borderSize;k+1.4*this.renderer.$maxLines*c>h-c&&!d?(g.style.top="",g.style.bottom=h-k+"px",b.isTopdown=!1):(g.style.top=k+c+"px",g.style.bottom="",b.isTopdown=!0);g.style.display="";this.renderer.$textLayer.checkForSizeChanges();a=a.left;a+g.offsetWidth>e&&(a=e-g.offsetWidth);g.style.left=
a+"px";this._signal("show");f=null;b.isOpen=!0};b.getTextLeftOffset=function(){return this.$borderSize+this.renderer.$padding+this.$imageSize};b.$imageSize=0;b.$borderSize=1;return b}});
define("lib/ace/autocomplete/util",["require","exports","module"],function(i,e){e.parForEach=function(f,e,j){var h=0,d=f.length;0===d&&j();for(var c=0;c<d;c++)e(f[c],function(c,a){h++;h===d&&j(c,a)})};var l=/[a-zA-Z_0-9\$\-\u00A2-\uFFFF]/;e.retrievePrecedingIdentifier=function(f,e,j){for(var j=j||l,h=[],e=e-1;0<=e;e--)if(j.test(f[e]))h.push(f[e]);else break;return h.reverse().join("")};e.retrieveFollowingIdentifier=function(f,e,j){for(var j=j||l,h=[];e<f.length;e++)if(j.test(f[e]))h.push(f[e]);else break;
return h}});
define("lib/ace/autocomplete","require exports module ./keyboard/hash_handler ./autocomplete/popup ./autocomplete/util ./lib/event ./lib/lang ./lib/dom ./snippets".split(" "),function(i,e){var l=i("./keyboard/hash_handler").HashHandler,f=i("./autocomplete/popup").AcePopup,m=i("./autocomplete/util");i("./lib/event");var j=i("./lib/lang"),h=i("./lib/dom"),d=i("./snippets").snippetManager,c=function(){this.autoSelect=this.autoInsert=!0;this.exactMatch=!1;this.keyboardHandler=new l;this.keyboardHandler.bindKeys(this.commands);this.blurListener=
this.blurListener.bind(this);this.changeListener=this.changeListener.bind(this);this.mousedownListener=this.mousedownListener.bind(this);this.mousewheelListener=this.mousewheelListener.bind(this);this.changeTimer=j.delayedCall(function(){this.updateCompletions(!0)}.bind(this));this.tooltipTimer=j.delayedCall(this.updateDocTooltip.bind(this),50)};(function(){this.gatherCompletionsId=0;this.$init=function(){this.popup=new f(document.body||document.documentElement);this.popup.on("click",function(a){this.insertMatch();
a.stop()}.bind(this));this.popup.focus=this.editor.focus.bind(this.editor);this.popup.on("show",this.tooltipTimer.bind(null,null));this.popup.on("select",this.tooltipTimer.bind(null,null));this.popup.on("changeHoverMarker",this.tooltipTimer.bind(null,null));return this.popup};this.getPopup=function(){return this.popup||this.$init()};this.openPopup=function(a,b,c){this.popup||this.$init();this.popup.setData(this.completions.filtered);var d=a.renderer;this.popup.setRow(this.autoSelect?0:-1);if(c)c&&
!b&&this.detach();else{this.popup.setTheme(a.getTheme());this.popup.setFontSize(a.getFontSize());b=d.layerConfig.lineHeight;c=d.$cursorLayer.getPixelPosition(this.base,!0);c.left-=this.popup.getTextLeftOffset();var g=a.container.getBoundingClientRect();c.top+=g.top-d.layerConfig.offset;c.left+=g.left-a.renderer.scrollLeft;c.left+=d.$gutterLayer.gutterWidth;this.popup.show(c,b)}};this.detach=function(){this.editor.keyBinding.removeKeyboardHandler(this.keyboardHandler);this.editor.off("changeSelection",
this.changeListener);this.editor.off("blur",this.blurListener);this.editor.off("mousedown",this.mousedownListener);this.editor.off("mousewheel",this.mousewheelListener);this.changeTimer.cancel();this.hideDocTooltip();this.popup&&this.popup.isOpen&&(this.gatherCompletionsId+=1,this.popup.hide());this.base&&this.base.detach();this.activated=!1;this.completions=this.base=null};this.changeListener=function(){var a=this.editor.selection.lead;(a.row!=this.base.row||a.column<this.base.column)&&this.detach();
this.activated?this.changeTimer.schedule():this.detach()};this.blurListener=function(a){var b=document.activeElement,c=this.editor.textInput.getElement();b!=c&&(b.parentNode!=this.popup.container&&b!=this.tooltipNode&&a.relatedTarget!=this.tooltipNode&&a.relatedTarget!=c)&&this.detach()};this.mousedownListener=function(){this.detach()};this.mousewheelListener=function(){this.detach()};this.goTo=function(a){var b=this.popup.getRow(),c=this.popup.session.getLength()-1;switch(a){case "up":b=0>=b?c:b-
1;break;case "down":b=b>=c?-1:b+1;break;case "start":b=0;break;case "end":b=c}this.popup.setRow(b)};this.insertMatch=function(a){a||(a=this.popup.getData(this.popup.getRow()));if(!a)return!1;if(a.completer&&a.completer.insertMatch)a.completer.insertMatch(this.editor,a);else{if(this.completions.filterText)for(var b=this.editor.selection.getAllRanges(),c=0,g;g=b[c];c++)g.start.column-=this.completions.filterText.length,this.editor.session.remove(g);a.snippet?d.insertSnippet(this.editor,a.snippet):this.editor.execCommand("insertstring",
a.value||a)}this.detach()};this.commands={Up:function(a){a.completer.goTo("up")},Down:function(a){a.completer.goTo("down")},"Ctrl-Up|Ctrl-Home":function(a){a.completer.goTo("start")},"Ctrl-Down|Ctrl-End":function(a){a.completer.goTo("end")},Esc:function(a){a.completer.detach()},Space:function(a){a.completer.detach();a.insert(" ")},Return:function(a){return a.completer.insertMatch()},"Shift-Return":function(a){a.completer.insertMatch(!0)},Tab:function(a){var b=a.completer.insertMatch();if(!b&&!a.tabstopManager)a.completer.goTo("down");
else return b},PageUp:function(a){a.completer.popup.gotoPageUp()},PageDown:function(a){a.completer.popup.gotoPageDown()}};this.gatherCompletions=function(a,b){var c=a.getSession(),d=a.getCursorPosition(),g=c.getLine(d.row),f=m.retrievePrecedingIdentifier(g,d.column);this.base=c.doc.createAnchor(d.row,d.column-f.length);this.base.$insertRight=!0;var e=[],h=a.completers.length;a.completers.forEach(function(g){g.getCompletions(a,c,d,f,function(d,g){d||(e=e.concat(g));var f=a.getCursorPosition(),k=c.getLine(f.row);
b(null,{prefix:m.retrievePrecedingIdentifier(k,f.column,g[0]&&g[0].identifierRegex),matches:e,finished:0===--h})})});return!0};this.showPopup=function(a){this.editor&&this.detach();this.activated=!0;this.editor=a;a.completer!=this&&(a.completer&&a.completer.detach(),a.completer=this);a.keyBinding.addKeyboardHandler(this.keyboardHandler);a.on("changeSelection",this.changeListener);a.on("blur",this.blurListener);a.on("mousedown",this.mousedownListener);a.on("mousewheel",this.mousewheelListener);this.updateCompletions()};
this.updateCompletions=function(a){if(a&&this.base&&this.completions){var b=this.editor.getCursorPosition(),b=this.editor.session.getTextRange({start:this.base,end:b});if(b!=this.completions.filterText){this.completions.setFilter(b);if(!this.completions.filtered.length||1==this.completions.filtered.length&&this.completions.filtered[0].value==b&&!this.completions.filtered[0].snippet)return this.detach();this.openPopup(this.editor,b,a)}}else{var c=this.gatherCompletionsId;this.gatherCompletions(this.editor,
function(b,d){var f=function(){if(d.finished)return this.detach()}.bind(this),e=d.prefix,h=d&&d.matches;if(!h||!h.length)return f();if(!(0!==e.indexOf(d.prefix)||c!=this.gatherCompletionsId)){this.completions=new g(h);this.exactMatch&&(this.completions.exactMatch=!0);this.completions.setFilter(e);h=this.completions.filtered;if(!h.length||1==h.length&&h[0].value==e&&!h[0].snippet)return f();if(this.autoInsert&&1==h.length&&d.finished)return this.insertMatch(h[0]);this.openPopup(this.editor,e,a)}}.bind(this))}};
this.cancelContextMenu=function(){this.editor.$mouseHandler.cancelContextMenu()};this.updateDocTooltip=function(){var a=this.popup,b=a.data,c=b&&(b[a.getHoveredRow()]||b[a.getRow()]),d=null;if(!c||!this.editor||!this.popup.isOpen)return this.hideDocTooltip();this.editor.completers.some(function(a){a.getDocTooltip&&(d=a.getDocTooltip(c));return d});d||(d=c);"string"==typeof d&&(d={docText:d});if(!d||!d.docHTML&&!d.docText)return this.hideDocTooltip();this.showDocTooltip(d)};this.showDocTooltip=function(a){this.tooltipNode||
(this.tooltipNode=h.createElement("div"),this.tooltipNode.className="ace_tooltip ace_doc-tooltip",this.tooltipNode.style.margin=0,this.tooltipNode.style.pointerEvents="auto",this.tooltipNode.tabIndex=-1,this.tooltipNode.onblur=this.blurListener.bind(this));var b=this.tooltipNode;a.docHTML?b.innerHTML=a.docHTML:a.docText&&(b.textContent=a.docText);b.parentNode||document.body.appendChild(b);var a=this.popup,c=a.container.getBoundingClientRect();b.style.top=a.container.style.top;b.style.bottom=a.container.style.bottom;
320>window.innerWidth-c.right?(b.style.right=window.innerWidth-c.left+"px",b.style.left=""):(b.style.left=c.right+1+"px",b.style.right="");b.style.display="block"};this.hideDocTooltip=function(){this.tooltipTimer.cancel();if(this.tooltipNode){var a=this.tooltipNode;!this.editor.isFocused()&&document.activeElement==a&&this.editor.focus();this.tooltipNode=null;a.parentNode&&a.parentNode.removeChild(a)}}}).call(c.prototype);c.startCommand={name:"startAutocomplete",exec:function(a){a.completer||(a.completer=
new c);a.completer.autoInsert=a.completer.autoSelect=!0;a.completer.showPopup(a);a.completer.cancelContextMenu()},bindKey:"Ctrl-Space|Ctrl-Shift-Space|Alt-Space"};var g=function(a,b){this.filtered=this.all=a;this.filterText=b||"";this.exactMatch=!1};(function(){this.setFilter=function(a){var b=a.length>this.filterText&&0===a.lastIndexOf(this.filterText,0)?this.filtered:this.all;this.filterText=a;var b=this.filterCompletions(b,this.filterText),b=b.sort(function(a,b){return b.exactMatch-a.exactMatch||
b.score-a.score}),c=null;this.filtered=b=b.filter(function(a){a=a.snippet||a.caption||a.value;if(a===c)return!1;c=a;return!0})};this.filterCompletions=function(a,b){var c=[],d=b.toUpperCase(),g=b.toLowerCase(),f=0,h;a:for(;h=a[f];f++){var e=h.value||h.caption||h.snippet;if(e){var j=-1,i=0,l=0,m,r;if(this.exactMatch){if(b!==e.substr(0,b.length))continue a}else for(var v=0;v<b.length;v++){m=e.indexOf(g[v],j+1);r=e.indexOf(d[v],j+1);m=0<=m?0>r||m<r?m:r:r;if(0>m)continue a;r=m-j-1;0<r&&(-1===j&&(l+=10),
l+=r);i|=1<<m;j=m}h.matchMask=i;h.exactMatch=l?0:1;h.score=(h.score||0)-l;c.push(h)}}return c}}).call(g.prototype);e.Autocomplete=c;e.FilteredList=g});
define("lib/ace/autocomplete/text_completer",["require","exports","module","../range"],function(i,e){var l=i("../range").Range,f=/[^a-zA-Z_0-9\$\-\u00C0-\u1FFF\u2C00-\uD7FF\w]+/;e.getCompletions=function(e,j,h,d,c){var g=j.getTextRange(l.fromPoints({row:0,column:0},h)).split(f).length-1,a=j.getValue().split(f),b=Object.create(null),i=a[g];a.forEach(function(c,d){if(c&&c!==i){var f=Math.abs(g-d),f=a.length-f;b[c]=b[c]?Math.max(f,b[c]):f}});e=Object.keys(b);c(null,e.map(function(a){return{caption:a,
value:a,score:b[a],meta:"local"}}))}});
define("lib/ace/ext/language_tools","require exports module ../snippets ../autocomplete ../config ../lib/lang ../autocomplete/util ../autocomplete/text_completer ../editor ../config".split(" "),function(i,e){function l(a){var b=a.getCursorPosition(),c=a.session.getLine(b.row),g=d.retrievePrecedingIdentifier(c,b.column);a.completers.forEach(function(a){a.identifierRegexps&&a.identifierRegexps.forEach(function(a){!g&&a&&(g=d.retrievePrecedingIdentifier(c,b.column,a))})});return g}var f=i("../snippets").snippetManager,
m=i("../autocomplete").Autocomplete,j=i("../config"),h=i("../lib/lang"),d=i("../autocomplete/util"),c=i("../autocomplete/text_completer"),g={getCompletions:function(a,b,c,d,g){if(b.$mode.completer)return b.$mode.completer.getCompletions(a,b,c,d,g);a=a.session.getState(c.row);b=b.$mode.getCompletions(a,b,c,d);g(null,b)}},a={getCompletions:function(a,b,c,d,g){var h=f.snippetMap,e=[];f.getActiveScopes(a).forEach(function(a){for(var a=h[a]||[],b=a.length;b--;){var c=a[b],d=c.name||c.tabTrigger;d&&e.push({caption:d,
snippet:c.content,meta:c.tabTrigger&&!c.name?c.tabTrigger+"\u21e5 ":"snippet",type:"snippet"})}},this);g(null,e)},getDocTooltip:function(a){"snippet"==a.type&&!a.docHTML&&(a.docHTML=["<b>",h.escapeHTML(a.caption),"</b><hr></hr>",h.escapeHTML(a.snippet)].join(""))}},b=[a,c,g];e.setCompleters=function(a){b=a||[]};e.addCompleter=function(a){b.push(a)};e.textCompleter=c;e.keyWordCompleter=g;e.snippetCompleter=a;var n={name:"expandSnippet",exec:function(a){return f.expandWithTab(a)},bindKey:"Tab"},k=function(a,
b){p(b.session.$mode)},p=function(a){var b=a.$id;f.files||(f.files={});o(b);a.modes&&a.modes.forEach(p)},o=function(a){if(a&&!f.files[a]){var b=a.replace("mode","snippets");f.files[a]={};j.loadModule(b,function(b){b&&(f.files[a]=b,!b.snippets&&b.snippetText&&(b.snippets=f.parseSnippetFile(b.snippetText)),f.register(b.snippets||[],b.scope),b.includeScopes&&(f.snippetMap[b.scope].includeScopes=b.includeScopes,b.includeScopes.forEach(function(a){o("ace/mode/"+a)})))})}},z=function(a){var b=a.editor,
c=b.completer&&b.completer.activated;"backspace"===a.command.name?c&&!l(b)&&b.completer.detach():"insertstring"===a.command.name&&(l(b)&&!c)&&(b.completer||(b.completer=new m),b.completer.autoSelect=!1,b.completer.autoInsert=!1,b.completer.showPopup(b))},c=i("../editor").Editor;i("../config").defineOptions(c.prototype,"editor",{enableBasicAutocompletion:{set:function(a){a?(this.completers||(this.completers=Array.isArray(a)?a:b),this.commands.addCommand(m.startCommand)):this.commands.removeCommand(m.startCommand)},
value:!1},enableLiveAutocompletion:{set:function(a){a?(this.completers||(this.completers=Array.isArray(a)?a:b),this.commands.on("afterExec",z)):this.commands.removeListener("afterExec",z)},value:!1},enableSnippets:{set:function(a){a?(this.commands.addCommand(n),this.on("changeMode",k),k(null,this)):(this.commands.removeCommand(n),this.off("changeMode",k))},value:!1}})});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/smartnameinfo",[],function(){var i=function(e){this._name=e};(function(){this.getFullName=function(){return this._name}}).call(i.prototype);return i});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/smartnameanchor",["lib/ace/anchor","lib/ace/lib/oop"],function(i,e){var l=i.Anchor,f=function(f,e,h,d){this._info=d;l.call(this,f,e,h)};e.inherits(f,i.Anchor);(function(){this.getSmartNameInfo=function(){return this._info};this.applyDeltas=function(f){if(("removeText"===f.action||"removeLines"===f.action)&&f.range.start.column<=this.column&&f.range.end.column>this.column)return!1;l.prototype.onChange.call(this,{data:f});return!0};
this.onChange=function(){}}).call(f.prototype);return f});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/smartnameanchorcontrol",["./smartnameanchor","./smartnameinfo","lib/ace/range"],function(i,e,l){function f(d){void 0===d.smartnameanchors&&(d.smartnameanchors=[]);return d.smartnameanchors}var m=l.Range,j={},h=new e("?");h.unresolved=!0;j.getSmartNameInfoAt=function(d,c,g){for(var d=f(d),a=0;a<d.length;a++){var b=d[a],e=b.getPosition();if(e.row===c&&e.column===g)return b.getSmartNameInfo()}return h};j.setSmartNameInfoAt=function(d,
c,g,a){var b=new i(d,c,g,a);f(d).push(b);c={action:"addSmartName",range:new m(c,g,c,g+1),smartname:{row:c,column:g,info:a}};d._signal("change",{data:c})};j.applyDelta=function(d,c){for(var g=f(d),a=[],b=0;b<g.length;b++){var e=g[b];e.applyDeltas(c)||(a.push(e),g.splice(b,1),b--)}for(b=0;b<a.length;b++){var e=a[b],g=e.row,h=e.column,e=e._info,e={action:"removeSmartName",range:new m(g,h,g,h+1),smartname:{row:g,column:h,info:e}};d._signal("change",{data:e})}};j.undoRedo=function(d,c,g){var a=c.action;
("addSmartName"===a||"removeSmartName"===a)&&g!==("addSmartName"===a)&&j.setSmartNameInfoAt(d,c.smartname.row,c.smartname.column,c.smartname.info)};return j});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/smartnameextensionutils",["component/smartnames/encoding/smartname","component/smartnames/encoding/smartnamestringpart","component/smartnames/encoding/smartnameencoding","./smartnameinfo","./smartnameanchorcontrol"],function(i,e,l,f,m){var j={SMARTNAMECHAR:"\u0010",getSmartNameDisplayString:function(f,d){return void 0!==f.displayFunction?f.displayFunction(d):"["+d.getFullName()+"]"},parseText:function(e,d,c){if(e.isSmartNamesEnabled()){for(var g=
{text:"",smartnames:[]},d=d.replaceAll("\n","").replaceAll("\r",""),e=(!0===c?l.UNIVERSALCOPYPASTEENCODING:e.getSmartNameEncoding()).decodeSmartNameString(d),d=0;d<e.length;d++)c=e[d],c.isTextPart()?g.text+=c.getAsText():(g.smartnames.push({index:g.text.length,info:new f(c.getAsSmartName().getFullName())}),g.text+=j.SMARTNAMECHAR);return g}return{text:d,smartnames:[]}},tryParseText:function(f,d,c){if(f.isSmartNamesEnabled())try{return j.parseText(f,d,c)}catch(g){return{text:d.replaceAll("\n","").replaceAll("\r",
"").replaceAll(""+j.SMARTNAMECHAR,"?"),smartnames:[]}}else return{text:d,smartnames:[]}},recompileText:function(f,d,c,g,a){if(f.isSmartNamesEnabled()){for(var b=[],n=0;n<g.length;n++)if(g.charAt(n)===j.SMARTNAMECHAR){var k=m.getSmartNameInfoAt(d,0,c+n);b.push(e.makeSmartNamePart(new i(k.getFullName())))}else b.push(e.makePlainTextPart(""+g.charAt(n)));return(!0===a?l.UNIVERSALCOPYPASTEENCODING:f.getSmartNameEncoding()).encodeSmartNameString(b)}return g},addSmartNameAnchors:function(f,d,c){for(var g=
0;g<c.length;g++)m.setSmartNameInfoAt(f,0,c[g].index+d.start.column,c[g].info)},startSmartNameChangeGroup:function(f){void 0==f.smartnamechangeready&&(f.smartnamechangeready=0);f.smartnamechangeready++},stopSmartNameChangeGroup:function(f,d){f.smartnamechangeready--;f._signal("change",{data:{action:"changeAfterSmartNames",range:d}})},isInSmartNameChangeReady:function(f){return void 0==f.smartnamechangeready?!0:0===f.smartnamechangeready}};return j});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/mod-ace-editor",["lib/ace/editor","lib/ace/range","./smartnameinfo","./smartnameextensionutils","utils/extendedstring"],function(i,e,l,f){var m=e.Range;(function(){this.insertSmartName=function(e){f.startSmartNameChangeGroup(this.getSession().getDocument());this.insert(f.SMARTNAMECHAR);var d=this.getCursorPosition().column-1,d=new m(0,d,0,d+1);f.addSmartNameAnchors(this.getSession().getDocument(),d,[{index:0,info:new l(e)}]);
f.stopSmartNameChangeGroup(this.getSession().getDocument(),d)};this.getSmartNameEncodedValue=function(){return f.recompileText(this.getSession(),this.getSession().getDocument(),0,this.getValue())};this.isChangeReady=function(){return f.isInSmartNameChangeReady(this.getSession().getDocument())};this.setSmartNameEncodedValue=function(e){e=f.parseText(this.getSession(),e);f.startSmartNameChangeGroup(this.getSession().getDocument());this.setValue(e.text);var d=new m(0,0,0,e.text.length);f.addSmartNameAnchors(this.getSession().getDocument(),
d,e.smartnames);f.stopSmartNameChangeGroup(this.getSession().getDocument(),d);this.navigateFileEnd()};this.insertBase=this.insert;this.insert=function(f,d){this.getSession().isSmartNamesEnabled()&&(f=f.replaceAll("\r","").replaceAll("\n",""));this.insertBase(f,d)};var e=this.onPaste;this.onPaste=function(h){h=f.tryParseText(this.session,h,!0);f.startSmartNameChangeGroup(this.session.getDocument());e.call(this,h.text);var d=this.getCursorPosition().column-h.text.length,d=new m(0,d,0,d+h.text.length);
f.addSmartNameAnchors(this.session.getDocument(),d,h.smartnames);f.stopSmartNameChangeGroup(this.session.getDocument(),d)};this.getCopyText=function(){var e=this.getSelectionRange().start.column,d=this.getSelectedText(),d=f.recompileText(this.getSession(),this.getSession().getDocument(),e,d,!0);this._signal("copy",d);return d}}).call(i.Editor.prototype)});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/mod-ace-edit_session",["lib/ace/edit_session","lib/ace/range","./smartnameanchorcontrol","./smartnameextensionutils"],function(i,e,l,f){(function(){var i=e.Range,j=f.SMARTNAMECHAR;this.isSmartNamesEnabled=function(){return void 0===this._smartNamesEnabled?!1:this._smartNamesEnabled};this.enableSmartNames=function(f){void 0!==f&&(this._smartNamesEnabled=!0,this._smartNameEncoding=f)};this.getSmartNameEncoding=function(){return this._smartNameEncoding};
this.$getStringScreenWidth=function(e,d,c){function g(b){if(9==b)c+=a.getScreenTabSize(c);else{var d;if(d=4352<=b)d=4352>b?!1:4352<=b&&4447>=b||4515<=b&&4519>=b||4602<=b&&4607>=b||9001<=b&&9002>=b||11904<=b&&11929>=b||11931<=b&&12019>=b||12032<=b&&12245>=b||12272<=b&&12283>=b||12288<=b&&12350>=b||12353<=b&&12438>=b||12441<=b&&12543>=b||12549<=b&&12589>=b||12593<=b&&12686>=b||12688<=b&&12730>=b||12736<=b&&12771>=b||12784<=b&&12830>=b||12832<=b&&12871>=b||12880<=b&&13054>=b||13056<=b&&19903>=b||19968<=
b&&42124>=b||42128<=b&&42182>=b||43360<=b&&43388>=b||44032<=b&&55203>=b||55216<=b&&55238>=b||55243<=b&&55291>=b||63744<=b&&64255>=b||65040<=b&&65049>=b||65072<=b&&65106>=b||65108<=b&&65126>=b||65128<=b&&65131>=b||65281<=b&&65376>=b||65504<=b&&65510>=b;c=d?c+2:c+1}}if(0==d)return[0,0];null==d&&(d=Infinity);var c=c||0,a=this,b,i;for(i=0;i<e.length;i++){b=e.charCodeAt(i);if(b==j.charCodeAt(0)&&this.isSmartNamesEnabled()){b=l.getSmartNameInfoAt(this.getDocument(),0,i);b=f.getSmartNameDisplayString(this.getDocument(),
b);for(var k=0;k<b.length;k++){var m=b.charCodeAt(k);g(m)}}else g(b);if(c>d)break}return[c,i]};this.getWordRangeBase=this.getWordRange;this.getWordRange=function(f,d){return this.getLine(f).charAt(d)==j&&this.isSmartNamesEnabled()?new i(f,d,f,d+1):this.getWordRangeBase(f,d)};this.moveText=function(e,d,c){var g=this.getTextRange(e),g=f.recompileText(this,this.getDocument(),e.start.column,g,!0),a=this.getFoldsInRange(e),d=i.fromPoints(d,d);if(!c){this.remove(e);var b=e.start.row-e.end.row,j=b?-e.end.column:
e.start.column-e.end.column;j&&(d.start.row==e.end.row&&d.start.column>e.end.column&&(d.start.column+=j),d.end.row==e.end.row&&d.end.column>e.end.column&&(d.end.column+=j));b&&d.start.row>=e.end.row&&(d.start.row+=b,d.end.row+=b)}c=f.parseText(this,g,!0);f.startSmartNameChangeGroup(this.getDocument());g=c.text;d.end=this.insert(d.start,g);g=new i(0,d.start.column,0,d.start.column+c.text.length);f.addSmartNameAnchors(this.getDocument(),g,c.smartnames);f.stopSmartNameChangeGroup(this.getDocument(),
g);if(a.length){var k=e.start,e=d.start,b=e.row-k.row,j=e.column-k.column;this.addFolds(a.map(function(a){a=a.clone();a.start.row==k.row&&(a.start.column+=j);a.end.row==k.row&&(a.end.column+=j);a.start.row+=b;a.end.row+=b;return a}))}return d}}).call(i.EditSession.prototype)});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/mod-ace-document",["lib/ace/document","lib/ace/range","./smartnameanchorcontrol","./smartnameextensionutils"],function(i,e,l,f){var m=e.Range,j=l.undoRedo,h=l.applyDelta;(function(){this._insertLinesBase=this._insertLines;this._insertLines=function(d,c){f.startSmartNameChangeGroup(this);var e=this._insertLinesBase(d,c),a=new m(d,0,d+c.length,0);h(this,{action:"insertLines",range:a});f.stopSmartNameChangeGroup(this,a);return e};
this.insertInLineBase=this.insertInLine;this.insertInLine=function(d,c){f.startSmartNameChangeGroup(this);var e=this.insertInLineBase(d,c),a=m.fromPoints(d,e);h(this,{action:"insertText",range:a});f.stopSmartNameChangeGroup(this,a);return e};this.removeInLineBase=this.removeInLine;this.removeInLine=function(d,c,e){if(c!=e){f.startSmartNameChangeGroup(this);var a=new m(d,c,d,e);h(this,{action:"removeText",range:a});d=this.removeInLineBase(d,c,e);f.stopSmartNameChangeGroup(this,a);return d}};this._removeLinesBase=
this._removeLines;this._removeLines=function(d,c){f.startSmartNameChangeGroup(this);var e=new m(d,0,c+1,0);h(this,{action:"removeLines",range:e});var a=this._removeLinesBase(d,c);f.stopSmartNameChangeGroup(this,e);return a};this.applyDeltas=function(d){for(var c=0;c<d.length;c++){var e=d[c],a=m.fromPoints(e.range.start,e.range.end);"insertLines"==e.action?this.insertLines(a.start.row,e.lines):"insertText"==e.action?this.insert(a.start,e.text):"removeLines"==e.action?this._removeLines(a.start.row,
a.end.row-1):"removeText"==e.action?this.remove(a):j(this,e,!1)}};this.revertDeltas=function(d){for(var c=d.length-1;0<=c;c--){var e=d[c],a=m.fromPoints(e.range.start,e.range.end);"insertLines"==e.action?this._removeLines(a.start.row,a.end.row-1):"insertText"==e.action?this.remove(a):"removeLines"==e.action?this._insertLines(a.start.row,e.lines):"removeText"==e.action?this.insert(a.start,e.text):j(this,e,!0)}}}).call(i.Document.prototype)});
define("utils/ConvertUtils",["jquery","underscore"],function(i){return{getLangFormattedDate:function(e,i){var f=[];f[0]=e.t("MONTH1");f[1]=e.t("MONTH2");f[2]=e.t("MONTH3");f[3]=e.t("MONTH4");f[4]=e.t("MONTH5");f[5]=e.t("MONTH6");f[6]=e.t("MONTH7");f[7]=e.t("MONTH8");f[8]=e.t("MONTH9");f[9]=e.t("MONTH10");f[10]=e.t("MONTH11");f[11]=e.t("MONTH12");null==i&&(i=new Date);var m=i.getMonth(),j=i.getDate(),h=i.getFullYear();return""+f[m]+" "+j+", "+h},getLangFormattedDateAndTime:function(e,i){var f=[];f[0]=
e.t("MONTH1");f[1]=e.t("MONTH2");f[2]=e.t("MONTH3");f[3]=e.t("MONTH4");f[4]=e.t("MONTH5");f[5]=e.t("MONTH6");f[6]=e.t("MONTH7");f[7]=e.t("MONTH8");f[8]=e.t("MONTH9");f[9]=e.t("MONTH10");f[10]=e.t("MONTH11");f[11]=e.t("MONTH12");null==i&&(i=new Date);var m=i.getMonth(),j=i.getDate(),h=i.getFullYear(),d=i.getHours();10>d&&(d="0"+d);var c=i.getMinutes();10>c&&(c="0"+c);return e.t("DateAndTimeString",f[m],j,h,d,c)},capitaliseFirstLetter:function(e){return e.charAt(0).toUpperCase()+e.slice(1)},getCharacterLineCount:function(e){var i=
1,f=0;if(e){for(var e=this.convertHTMLStringToRaw(e),e=e.replace(/\r\n/g,"\n"),f=0,m=e.indexOf("\n",0);-1!=m;)i++,f++,m=e.indexOf("\n",m+1);f=e.length-f}return{lineCount:i,charCount:f}},convertHTMLStringToRaw:function(e,i){void 0===i&&(i="\n");var f=e.replace(/>[\f\n\r\t\v\u00a0\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u2028\u2029\u202f\u205f\u3000]*([ ]*)[\f\n\r\t\v\u00a0\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u2028\u2029\u202f\u205f\u3000]*</g,
">$1<"),f=f.replace(/.*<body>((\r\n|\n|.)*)<\/body>.*/i,"$1"),f=f.replace(/^<(blockquote|body|center|dd|dir|div|dl|dt|form|h1|h2|h3|h4|h5|h6|head|hr|html|isindex|li|menu|noframes|ol|p|pre|td|th|title|ul)[^>]*>/,""),f=f.replace(/<(blockquote|body|br|center|dd|dir|div|dl|dt|form|h1|h2|h3|h4|h5|h6|head|hr|html|isindex|li|menu|noframes|ol|p|pre|td|th|title|ul)[^>]*>/g,i),f=f.replace(/<[^>]*>/g,""),f=f.replace(/&nbsp;|&#160;/gi," ");return f=this.decodeHtmlEntities(f)},convertRawStringToHTML:function(e){e=
this.encodeHtmlEntities(e);return e=e.replace(/(\r)?\n/g,"<br />")},decodeHtmlEntities:function(e){return i("<textarea>").html(e).text()},encodeHtmlEntities:function(e){return i("<div>").text(e).html()}}});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/mod-ace-layer-text",["lib/ace/layer/text","lib/ace/lib/lang","./smartnameanchorcontrol","./smartnameextensionutils","utils/ConvertUtils"],function(i,e,l,f){(function(){this.$renderToken=function(i,j,h,d){var c=this,g=/\x10|\t|&|<|( +)|([\x00-\x1f\x80-\xa0\xad\u1680\u180E\u2000-\u200f\u2028\u2029\u202F\u205F\u3000\uFEFF])|[\u1100-\u115F\u11A3-\u11A7\u11FA-\u11FF\u2329-\u232A\u2E80-\u2E99\u2E9B-\u2EF3\u2F00-\u2FD5\u2FF0-\u2FFB\u3000-\u303E\u3041-\u3096\u3099-\u30FF\u3105-\u312D\u3131-\u318E\u3190-\u31BA\u31C0-\u31E3\u31F0-\u321E\u3220-\u3247\u3250-\u32FE\u3300-\u4DBF\u4E00-\uA48C\uA490-\uA4C6\uA960-\uA97C\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFAFF\uFE10-\uFE19\uFE30-\uFE52\uFE54-\uFE66\uFE68-\uFE6B\uFF01-\uFF60\uFFE0-\uFFE6]/g,a=
function(a,b,d,f){if(b)return c.showInvisibles?"<span class='ace_invisible ace_invisible_space'>"+e.stringRepeat(c.SPACE_CHAR,a.length)+"</span>":e.stringRepeat("\u00a0",a.length);if("&"==a)return"&#38;";if("<"==a)return"&#60;";if("\t"==a)return a=c.session.getScreenTabSize(j+f),j+=a-1,c.$tabStrings[a];if("\u3000"==a)return a=c.showInvisibles?"ace_cjk ace_invisible ace_invisible_space":"ace_cjk",b=c.showInvisibles?c.SPACE_CHAR:"",j+=1,"<span class='"+a+"' style='width:"+2*c.config.characterWidth+
"px'>"+b+"</span>";if(d)return"<span class='ace_invisible ace_invisible_space ace_invalid'>"+c.SPACE_CHAR+"</span>";j+=1;return"<span class='ace_cjk' style='width:"+2*c.config.characterWidth+"px'>"+a+"</span>"},b=d.replace(g,function(b,d,e,h,i){return b==f.SMARTNAMECHAR&&c.session.isSmartNamesEnabled()?(b=c.session.screenToDocumentPosition(0,j+h),b=l.getSmartNameInfoAt(c.session.getDocument(),b.row,b.column),b=f.getSmartNameDisplayString(c.session.getDocument(),b),j+=b.length-1,"<span class='ace_smartname'>"+
b.replace(g,a)+"</span>"):a(b,d,e,h,i)});if(this.$textToken[h.type])i.push(b);else{var n="ace_"+h.type.replace(/\./g," ace_"),k="";"fold"==h.type&&(k=" style='width:"+h.value.length*this.config.characterWidth+"px;' ");i.push("<span class='",n,"'",k,">",b,"</span>")}return j+d.length}}).call(i.Text.prototype)});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/mod-ace-mouse-dragdrop_handler",["lib/ace/config","lib/ace/lib/event","lib/ace/range","./smartnameanchorcontrol","./smartnameextensionutils"],function(i,e,l,f,m){var j=l.Range;i.on("editor",function(f){var d=f.container,c;e.addListener(d,"dragstart",function(e){if(!this.cancelDrag&&d.draggable){var a=f.session.selection.getRange().start.column,e=e.dataTransfer;e.clearData();var b=f.session.getTextRange(),b=m.recompileText(f.session,
f.session.getDocument(),a,b,!0);e.setData("Text",b);c=!0}}.bind(this));e.addListener(d,"dragend",function(){c=!1}.bind(this));e.addListener(d,"drop",function(){if(!c){var d=f.getSelectedText(),a=m.tryParseText(f.session,d,!0);a.text!==d&&(m.startSmartNameChangeGroup(f.session.getDocument()),d=f.getSelectionRange(),d.isEmpty()||f.session.remove(d),f.session.insert(d.start,a.text),d=new j(0,d.start.column,0,d.start.column+a.text.length),m.addSmartNameAnchors(f.session.getDocument(),d,a.smartnames),
m.stopSmartNameChangeGroup(f.session.getDocument(),d))}}.bind(this))})});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/mod-ace-autocomplete",["lib/ace/autocomplete","lib/ace/autocomplete/util","./smartnameextensionutils"],function(i,e,l){e.retrievePrecedingIdentifier=function(e,i){var j=e.lastIndexOf(l.SMARTNAMECHAR,i),h=e.lastIndexOf("[",i);return-1===h||-1!==j&&h<j?"":e.substring(h,i)};(function(){this.insertMatch=function(e){e||(e=this.popup.getData(this.popup.getRow()));if(!e&&(e=this.popup.getData(0),!e))return!1;if(e.completer&&e.completer.insertMatch)e.completer.insertMatch(this.editor,
e);else{if(this.completions.filterText)for(var i=this.editor.selection.getAllRanges(),j=0,h;h=i[j];j++)h.start.column-=this.completions.filterText.length,this.editor.session.remove(h);e.snippet?snippetManager.insertSnippet(this.editor,e.snippet):e.smartname?this.editor.insertSmartName(e.smartname):this.editor.execCommand("insertstring",e.value||e)}this.detach()};delete this.commands.Space}).call(i.Autocomplete.prototype)});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/mod-ace-all","./mod-ace-editor ./mod-ace-edit_session ./mod-ace-document ./mod-ace-layer-text ./mod-ace-mouse-dragdrop_handler ./mod-ace-autocomplete".split(" "),function(){});
define("component/smartnames/input/smartnameinput","component/smartnames/encoding/smartnameencoding component/smartnames/encoding/smartnamestringpart component/smartnames/encoding/smartname jquery lib/ace/ace lib/ace/ext/language_tools ./ace-modifications-for-smartnamesupport/mod-ace-all".split(" "),function(i,e,l,f,m){function j(c){return"["+(new l(c.getFullName())).getDisplayName()+"]"}var h="showSettingsMenu goToNextError goToPreviousError centerselection gotoline fold unfold toggleFoldWidget toggleParentFoldWidget foldall foldOther unfoldall findnext findprevious selectOrFindNext selectOrFindPrevious find togglerecording replaymacro jumptomatching selecttomatching expandToMatching removeline duplicateSelection sortlines togglecomment toggleBlockComment modifyNumberUp modifyNumberDown replace copylinesup movelinesup copylinesdown movelinesdown cut_or_delete removetolinestart removetolineend outdent indent blockoutdent blockindent splitline transposeletters touppercase tolowercase expandtoline".split(" "),
d=function(c,d){c=void 0===c?document.createElement("div"):f(c).get(0);void 0===d&&(d={});void 0===d.readOnly&&(d.readOnly=!1);void 0===d.encoding&&(d.encoding=i.SAVEDSEARCH);this._encoding=d.encoding;this._mark=(this._markaware=!1===d.markaware?!1:!0)&&(!0===d.mark?!0:!1);this._markid=void 0!=d.markid?d.markid:"@";this._marksn=this._encoding.encodeSmartNameString([e.makeSmartNamePart(new l(this._markid))]);var a=m.edit(c);this._editor=a;this._div=f(c);c.SmartNameInput=this;a.$blockScrolling=Infinity;
var b=a.getValue();a.getSession().enableSmartNames(this._encoding);this.setValue(b);a.getSession().getDocument().displayFunction=void 0!==d.displayFunction?d.displayFunction:j;a.setOptions({highlightActiveLine:!1,highlightSelectedWord:!1});this.readOnly=d.readOnly;this.disabled=!1;this.readOnly?(a.setReadOnly(!0),a.setTheme("component/smartnames/input/themes/smartnames-display")):a.setTheme("component/smartnames/input/themes/smartnames-input");a.getSession().gutterRenderer={getWidth:function(){return 0},
getText:function(){return""}};a.renderer.setOptions({showLineNumbers:!1,maxLines:1,printMargin:0,printMarginColumn:0,showPrintMargin:!1,displayIndentGuides:!1,showGutter:!1});a.renderer.setPadding(0);a.commands.removeCommands(h);a.commands.addCommand({name:"myCommand",bindKey:{win:"Ctrl-F",mac:"Command-F"},exec:function(){},readOnly:!0})};(function(){this._addMark=function(c){this._mark&&(!this._encoding.containsSmartName(c)&&0<c.length)&&(c=this._marksn+c);return c};this._removeMark=function(c){if(this._markaware&&
c.length>=this._marksn.length){for(var c=this._encoding.decodeSmartNameString(c),d=0;d<c.length;d++){var a=c[d];a.isSmartNamePart()&&a.getAsSmartName().getName()===this._markid&&(c.splice(d,1),d--)}c=this._encoding.encodeSmartNameString(c)}return c};this.getValue=function(){return this._addMark(this._editor.getSmartNameEncodedValue())};this.setValue=function(c){try{this._encoding.decodeSmartNameString(c)}catch(d){window.console.error("Error: Illegal value used in setValue on SmartField. Falling back to text..."),
c=this._encoding.escapeString(c)}this._editor.setSmartNameEncodedValue(this._removeMark(c))};this.clear=function(){this._editor.setValue("")};this.onBlur=function(c){this._editor.on("blur",function(){try{c()}catch(d){console.error("An error was thrown in a blur listener: "+d)}})};this.onValueChange=function(c){var d=this;this._editor.on("change",function(){try{d._editor.isChangeReady()&&c(d.getValue())}catch(a){console.error("An error was thrown in a change listener: "+a)}})};this.setSmartNames=function(c){var d=
c.map(function(a){return{caption:"["+a.getDisplayName()+"]",value:"["+a.getDisplayName()+"]",score:1,meta:"",smartname:a.getFullName()}});this._editor.setOptions({enableLiveAutocompletion:[{getCompletions:function(a,b,c,e,f){f(null,d)}}]})};this.insertText=function(c){this._editor.insert(c);this._editor.renderer.scrollCursorIntoView()};this.insertSmartName=function(c){this._editor.insertSmartName(c);this._editor.renderer.scrollCursorIntoView()};this.show=function(){this._div.show()};this.hide=function(){this._div.hide()};
this.focus=function(){this._editor.focus()};this.blur=function(){this._editor.blur()};this.resize=function(){this._editor.resize()};this.isDisabled=function(){return this.disabled};this.disable=function(){this.disabled||(this.disabled=!0,this._editor.setReadOnly(!0),this._div.addClass("ace_smartinput_disabled"))};this.enable=function(){this.disabled&&(this.disabled=!1,this._editor.setReadOnly(!1),this._div.removeClass("ace_smartinput_disabled"))};this.destroy=function(){var c=this.getValue();this._editor.destroy();
this.getJQElement().text(c).removeClass("ace_editor").removeClass("ace-smartnamefield-display").removeClass("ace-smartnamefield-input");try{delete this._div.get(0).SmartNameInput}catch(d){}};this.getJQElement=function(){return this._div}}).call(d.prototype);d.wcrinit=function(c){new d(c)};d.wcrdestroy=function(c){c.SmartNameInput.destroy()};return d});