/**
 * (The MIT License)
 * Copyright (c) 2011 hij1nx http://www.twitter.com/hij1nx
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the 'Software'), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
 * The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
 * THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 * 
 * See https://github.com/hij1nx/EventEmitter2
 */

define("utils/ConvertUtils",["jquery","underscore"],function(g){return{getLangFormattedDate:function(c,g){var b=[];b[0]=c.t("MONTH1");b[1]=c.t("MONTH2");b[2]=c.t("MONTH3");b[3]=c.t("MONTH4");b[4]=c.t("MONTH5");b[5]=c.t("MONTH6");b[6]=c.t("MONTH7");b[7]=c.t("MONTH8");b[8]=c.t("MONTH9");b[9]=c.t("MONTH10");b[10]=c.t("MONTH11");b[11]=c.t("MONTH12");null==g&&(g=new Date);var h=g.getMonth(),l=g.getDate(),e=g.getFullYear();return""+b[h]+" "+l+", "+e},getLangFormattedDateAndTime:function(c,g){var b=[];b[0]=
c.t("MONTH1");b[1]=c.t("MONTH2");b[2]=c.t("MONTH3");b[3]=c.t("MONTH4");b[4]=c.t("MONTH5");b[5]=c.t("MONTH6");b[6]=c.t("MONTH7");b[7]=c.t("MONTH8");b[8]=c.t("MONTH9");b[9]=c.t("MONTH10");b[10]=c.t("MONTH11");b[11]=c.t("MONTH12");null==g&&(g=new Date);var h=g.getMonth(),l=g.getDate(),e=g.getFullYear(),a=g.getHours();10>a&&(a="0"+a);var d=g.getMinutes();10>d&&(d="0"+d);return c.t("DateAndTimeString",b[h],l,e,a,d)},capitaliseFirstLetter:function(c){return c.charAt(0).toUpperCase()+c.slice(1)},getCharacterLineCount:function(c){var g=
1,b=0;if(c){for(var c=this.convertHTMLStringToRaw(c),c=c.replace(/\r\n/g,"\n"),b=0,h=c.indexOf("\n",0);-1!=h;)g++,b++,h=c.indexOf("\n",h+1);b=c.length-b}return{lineCount:g,charCount:b}},convertHTMLStringToRaw:function(c,g){void 0===g&&(g="\n");var b=c.replace(/>[\f\n\r\t\v\u00a0\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u2028\u2029\u202f\u205f\u3000]*([ ]*)[\f\n\r\t\v\u00a0\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u2028\u2029\u202f\u205f\u3000]*</g,
">$1<"),b=b.replace(/.*<body>((\r\n|\n|.)*)<\/body>.*/i,"$1"),b=b.replace(/^<(blockquote|body|center|dd|dir|div|dl|dt|form|h1|h2|h3|h4|h5|h6|head|hr|html|isindex|li|menu|noframes|ol|p|pre|td|th|title|ul)[^>]*>/,""),b=b.replace(/<(blockquote|body|br|center|dd|dir|div|dl|dt|form|h1|h2|h3|h4|h5|h6|head|hr|html|isindex|li|menu|noframes|ol|p|pre|td|th|title|ul)[^>]*>/g,g),b=b.replace(/<[^>]*>/g,""),b=b.replace(/&nbsp;|&#160;/gi," ");return b=this.decodeHtmlEntities(b)},convertRawStringToHTML:function(c){c=
this.encodeHtmlEntities(c);return c=c.replace(/(\r)?\n/g,"<br />")},decodeHtmlEntities:function(c){return g("<textarea>").html(c).text()},encodeHtmlEntities:function(c){return g("<div>").text(c).html()}}});
define("utils/HTTPUtils",["jquery","underscore","utils/ConvertUtils"],function(g,c,j){return{constructURL:function(b,h,l){var e="";l&&(e+=l);var e=e+b,b="?",a;for(a in h){if(h.hasOwnProperty(a))if(c.isArray(h[a]))for(l=0;l<h[a].length;l++)e+=b+encodeURIComponent(a)+"="+encodeURIComponent(j.decodeHtmlEntities(h[a][l]));else e+=b+encodeURIComponent(a)+"="+encodeURIComponent(j.decodeHtmlEntities(h[a]));b="&"}return e}}});
define("utils/XMLUtils",[],function(){var g=null;return g={attributeValue:function(c,g){var b=c.attributes.getNamedItem(g);return b?b.nodeValue:null},nodeTextContent:function(c,j){var b=c.getElementsByTagName(j)[0];return b?g.textContent(b):null},textContent:function(c){var g=c.textContent;void 0===g&&(g=c.nodeTypedValue);return g},xml2obj:function(c,g){for(var b={},h=c.childNodes,l=0;l<h.length;l++){var e=h[l],a=e.nodeName;if("#text"!=a){var d=this.numberOfChildren(e),k=void 0,k=0<d?this.xml2obj(e,
d):this.textContent(e);void 0!==b[a]?("[object Array]"!==Object.prototype.toString.call(b[a])&&(e=b[a],b[a]=[],b[a].push(e)),b[a].push(k)):b[a]=k}}if((void 0!==g||0<this.numberOfChildren(c))&&c.attributes){b.attributes={};for(h=0;h<c.attributes.length;h++)b.attributes[c.attributes[h].name]=c.attributes[h].value}return b},numberOfChildren:function(c){var g=0;if(c.childNodes&&0<c.childNodes.length)for(var b=0;b<c.childNodes.length;b++)1==c.childNodes[b].nodeType&&g++;return g}}});
define("utils/I18n",["utils/HTTPUtils","utils/XMLUtils","underscore","jquery"],function(g,c,j,b){var h=function(b,e,a){this._locale=b?b:"en";this._timestamp=a?a:0;this.wcrInstanceUrl=e;this.bundles={};this.loading={};this.bundleOrder=[];this.bundleLoadedListeners={}};h.prototype.setLocale=function(b){this._locale=b;this.bundles={};for(var b=function(){},e=0;e<this.bundleOrder.length;e++)this.loadBundle(this.bundleOrder[e],b)};h.prototype.getLocale=function(){return this._locale};h.prototype.loadBundle=
function(b,e,a){e&&a&&(e=j.bind(e,a));if(j.isArray(b)){var d=j.after(b.length,j.once(e));j.each(b,j.bind(function(a){this.loadSingleBundle(a,d)},this))}else this.loadSingleBundle(b,e)};h.prototype.loadSingleBundle=function(h,e){if(this.bundles[h])e&&e(this.bundles[h]);else if(e&&this.whenBundleLoaded(h,e),!this.loading[h]){this.bundleOrder.push(h);this.loading[h]=1;var a=this;b.ajax(g.constructURL("DownloadLocKeys.jsp",{scope:h,t:this._timestamp,lk:this._locale},this.wcrInstanceUrl),{dataType:"xml",
success:function(d){if(d){var e=d.getElementsByTagName("code");if(e[0]&&"001"===c.textContent(e[0]))return}for(var e={},d=d.documentElement.getElementsByTagName("lang_string"),b=0;b<d.length;b++){var f=d[b];e[f.getAttribute("key")]=f.getAttribute("value")}a.bundles[h]={};delete a.loading[h];e&&(a.bundles[h]=e);a.fireBundleLoaded(h,a.bundles[h])},error:function(){},cache:!0,type:"GET"})}};h.prototype.whenBundleLoaded=function(b,e){this.bundleLoadedListeners[b]||(this.bundleLoadedListeners[b]=[]);this.bundleLoadedListeners[b].push(e)};
h.prototype.fireBundleLoaded=function(b,e){this.bundleLoadedListeners[b]&&(j.each(this.bundleLoadedListeners[b],function(a){a(e)}),delete this.bundleLoadedListeners[b])};h.prototype.findByKey=function(b){for(var e=this.bundleOrder.length-1;0<=e;e--)if(this.bundles[this.bundleOrder[e]]&&this.bundles[this.bundleOrder[e]][b])return this.bundles[this.bundleOrder[e]][b]};h.prototype.findByKeyInBundle=function(b,e){if(this.bundles[e]&&this.bundles[e][b])return this.bundles[e][b]};h.prototype.t=function(b){var e=
this.findByKey(b);if(void 0!==e){for(var a=1;a<arguments.length;a++)e=e.replace("{"+(a-1)+"}",arguments[a]);return e}return b};h.prototype.d=function(b,e){var a=this.findByKey(b);if(void 0!==a)return e.toString(a)};return h});
define("utils/webi18n",["utils/I18n","jquery"],function(g,c){var j;return j={getInstance:function(){if(!window.webI18n){var b=window,h=function(e,a){void 0===a||null===a||(a instanceof jQuery||(a=c(a)),a.text(e))},l=new g(window.webcenterConfig.userLang,window.webcenterConfig.jspBaseUrl,window.webcenterConfig.languageLoadTimestamp);b.webI18n={loadSingleBundle:function(e,a){l.loadSingleBundle(e,a)},whenBundleLoaded:function(e,a){l.whenBundleLoaded(e,a)},t:function(e,a){var d=l.findByKeyInBundle(e,
a);if(void 0!==d){for(var b=2;b<arguments.length;b++)d=d.replace("{"+(b-2)+"}",arguments[b]);return d}return e},tIn:function(e,a,d){var b=arguments,i=l.findByKeyInBundle(e,a);if(void 0===i)l.whenBundleLoaded(a,function(){i=l.findByKeyInBundle(e,a);if(void 0!==i){for(var f=3;f<b.length;f++)i=i.replace("{"+(f-3)+"}",b[f]);h(i,d)}else h(e,d)}),h(e,d);else{for(var f=3;f<b.length;f++)i=i.replace("{"+(f-3)+"}",b[f]);h(i,d)}},getLocale:function(){return l.getLocale()}}}return window.webI18n},load:function(b,
h,c,e){if(e.isBuild)c();else{var a=j.getInstance();a.loadSingleBundle(b,function(d){c({t:function(d){var e=[d,b].concat(Array.prototype.slice.call(arguments).slice(1));return a.t.apply(a,e)},tFallback:function(d,e){var f=[d,b].concat(Array.prototype.slice.call(arguments).slice(2)),f=a.t.apply(a,f);return f===d?e:f},asMap:function(){return d}})})}}}});
define("doctablex/DocTableXUtils",["jquery","utils/webi18n!DocRefStrings"],function(g,c){var j,b=0;return j={maxBOMCount:2147483647,getNextUniquePrefix:function(){return b++},log:function(b){"undefined"!=typeof console&&console.log(b)},error:function(b){"undefined"!=typeof console?console.error(b):alert(b)},isValidID:function(b){return b&&"string"==typeof b&&16==b.trim().length},getFileExtension:function(b,c){if(null==b||null==b.length||3>b.length||0>b.lastIndexOf(".")||b.lastIndexOf(".")>=b.length-
1)return null;var e=b.substr(b.lastIndexOf(".")),e=e.replace(/^\s+|\s+$/g,"").toLowerCase();c&&(e=e.substring(e.indexOf(".")+1));return e},getRenderItem:function(b,c){if(!b)return null;for(var e=0;e<b.length;e++){var a=b[e];if(a&&a.type){var d=a.type;"DocumentProperty"==d&&(d+="_"+a.typeDetail);if(d==c)return a}}return null},_getFileExtensionsList:function(b){var c=[];if(b&&0<b.length){var e=b.split(",");1==e.length&&(e=b.split(";"));for(b=0;b<e.length;b++){var a=e[b];a&&(a=a.replace(/^\s+|\s+$/g,
"").toLowerCase(),"."==a.substr(0,1)&&(a=a.substr(1)),c.push(a))}}return c},_getDocTemplateNameList:function(b){var c=[];if(b&&0<b.length){var e=b.split(",");1==e.length&&(e=b.split(";"));for(b=0;b<e.length;b++){var a=e[b];a&&(a=a.replace(/^\s+|\s+$/g,"").toLowerCase(),c.push(a))}}return c},preserveFileInputs:function(b){var c=g("#DocTableFileInputsReposElemID");0==c.length&&(c=g('<div id="DocTableFileInputsReposElemID" style="display:none"></div>'),g("body").prepend(c));b=g("#"+b+" input.docTableFileInputToPreserve");
b.appendTo(c);return b.length},reinsertPreservedFileInputs:function(b){g("#DocTableFileInputsReposElemID input.docTableFileInputToPreserve").each(function(e){j.log("Preserved file input"+e+": "+g(this).attr("name"));e=g(this).attr("name");if(!b||0==b.length||0==e.indexOf(b))e=g("input[name="+e+"]").not(this),g(this).attr("name",e.attr("name")),g(this).attr("onchange",e.attr("onchange")),e.replaceWith(g(this))});var c=g("#DocTableFileInputsReposElemID input.docTableFileInputToPreserve");0<c.length&&
!b&&(j.log(c.length+" document(s) to be uploaded was(were) removed from document table(s)!"),c.remove())},getMenuFileParamValue:function(){var b;b="menu_file".replace(/[\[]/,"\\[").replace(/[\]]/,"\\]");b=RegExp("[\\?&]"+b+"=([^&#]*)").exec(location.search);return null===b?"":decodeURIComponent(b[1].replace(/\+/g," "))},getSourcePageURLEncoded:function(){var b=location.pathname.replace(/\/[^\/]*/i,"");return encodeURIComponent(b+location.search)},getEncodedTranslatedLabel:function(b){var g="",e="DocRefColLabel_"+
b;0===b.indexOf("DocRefColLabel_")?g=c.t(b):c.t(e)!=e&&(g=c.t(e));g||(g=b);return WCXML.xmlencode(g)}}});
define("doctablex/DocTableXView",["doctablex/DocTableXUtils","wcr/webcenter_xml","jquery"],function(g,c,j){var b=function(b,c,e){if(!b&&!c&&!e)return this;this.dm=b;this.phElemID=c;this.renderMethodMap={AttributeFlapout:this.renderExpandCollapseButtonHeader,UpDownArrows:this.renderSortingArrowsHeader,SequenceNumber:this.renderSequenceNumberHeader,DocumentName:this.renderDocumentSpecHeader,DocumentActions:this.renderDocumentActionsHeader,DocumentProperty_Thumbnail:this.renderThumbnailHeader,DocumentProperty_Description:this.renderDocumentDescriptionHeader,
DocumentProperty_ApprovalStatus:this.renderApprovalStatusHeader,DocumentProperty_ApprovalStage:this.renderApprovalStageHeader,DocumentProperty_Project:this.renderDocProjectNameHeader,DocumentProperty_VersionRevision:this.renderDocumentVersionHeader,DocumentProperty_VersionAuthor:this.renderDocumentAuthorHeader,DocumentProperty_ModifiedDate:this.renderDocumentModifiedDateHeader,ReferenceProperty:this.renderReferencePropertyHeader,DocumentAttribute:this.renderDocAttributeHeader,LocalRemote:this.renderLocalRemoteButtonHeader,
DeleteButton:this.renderDeleteButtonHeader};this.renderOptions=e;return this};b.prototype.render=function(b){var c=j("#"+this.phElemID);if(0==c.length)return c;this.dm.isInactive&&c.hide();var e=this.renderOptions;b&&(this.renderOptions=b);b=g.preserveFileInputs(this.phElemID);"list"==this.renderOptions.renderMethod?this.renderSimple(c):"table"==this.renderOptions.renderMethod?this.renderComplex(c):alert("Not supported render method: "+this.renderOptions.renderMethod+".");for(var a=0;a<this.dm.docRows.length;a++)this.dm.docRows[a].displayRow(!1);
0<b&&g.reinsertPreservedFileInputs();this.renderDocSourceLinks();this.renderOptions=e;return c};b.prototype.repaintRemoteDocRows=function(){if(this.dm.docRows)for(var b=0;b<this.dm.docRows.length;b++){var c=this.dm.docRows[b];c.isRemoteDocument()&&c.view.repaintRow()}};b.prototype.renderDocSourceLinks=function(){if(this.dm.isEditable){if(0<j("#"+this.dm.greenLinksPrefix).length){var b=this.dm.getDocumentSourceOptions(this.dm.greenLinksPrefix);this.dm.dshObj.displayLinks(b)}0<j("#"+this.dm.greenLinksPrefix+
"_bottom").length&&(b=this.dm.getDocumentSourceOptions(this.dm.greenLinksPrefix+"_bottom"),this.dm.dshObj.displayLinks(b))}};b.prototype.renderSimple=function(b){try{this.isSingleValueListRendering=!this.dm.allowMultiple,this.renderOptions.hideHeader=!0,this.renderComplex(b)}catch(c){return g.log("Problem in DocTableXView.renderSimple:\n"+c),null}return b};b.prototype.renderComplex=function(b){try{this.dm.destroy();b.html("");this.isSingleValueListRendering||b.append(this.renderGreenLinksPlaceholder("top"));
var c="",c=this.renderOptions.hideHeader?c+"headerlessTable":c+"ordtable docreftable documentsTable",e=j('<table class="'+c+'"></table>');b.append(e);this.renderOptions.hideHeader||this.renderTableHeader(e);c="<tbody>";if(0<this.dm.docRows.length)for(var a=0;a<this.dm.docRows.length;a++)c+='<tr id="'+this.dm.docRows[a].view.phElemID+'"></tr>';else this.isSingleValueListRendering&&(c+="<tr><td>",c+=this.renderGreenLinksPlaceholder("top"),c+="</td></tr>");e.append(c+"</tbody>");this.isSingleValueListRendering||
b.append(this.renderGreenLinksPlaceholder("bottom"));if(!this.dm.isInactive||this.dm.clearValues){var d=this.dm.getTablePrefix();b.append('<input type="hidden" id="'+d+'" name="'+d+'"/>')}}catch(k){return g.log("Problem in DocTableXView.renderComplex:\n"+k),null}return b};b.prototype.renderGreenLinksPlaceholder=function(b){var c="";try{c+='<div class="docrefheader">',this.dm.isEditable&&(-1!=b.indexOf("top")&&this.renderOptions.showGreenLinksOnTop&&(c+='<div class="darktext_greenlink_11 nobr mr10" id="'+
this.dm.greenLinksPrefix+'"></div>'),-1!=b.indexOf("bottom")&&this.renderOptions.showGreenLinksAtBottom&&(c+='<div class="darktext_greenlink_11 nobr mr10" id="'+this.dm.greenLinksPrefix+'_bottom"></div>'),-1!=b.indexOf("inline")&&(c+='<div class="darktext_greenlink_11 nobr mr10" id="'+this.dm.greenLinksPrefix+'_inline"></div>')),c+="</div>"}catch(e){g.log("Problem in DocTableXView.renderGreenLinksPlaceholder:\n"+e),c=""}return c};b.prototype.renderTableHeader=function(b){if(b&&0!=b.length)try{var c=
"";if(0<this.dm.getNumberOfRows()){var c=c+"<thead><tr>",e=this.renderOptions.columns;if(e)for(var a=0;a<e.length;a++){var d=this.renderOptions.columns[a];if(d){var k=d.type;"DocumentProperty"==k&&(k+="_"+d.typeDetail);var i=this.renderMethodMap[k];i&&(c+=i.call(this,d))}}c+="</tr></thead>"}b.html(c)}catch(f){g.log("Problem in DocTableXView.renderTableHeader:\n"+f)}};b.prototype.renderExpandCollapseButtonHeader=function(){var b="javascript: "+this.dm.getThisInDOM()+".expandCollapseAllClicked(this);return false;",
b='<th class="docrefexpandcol">'+('<a class="btn btn12 expandAll" href="#" onclick="'+b+'"><i class="expand-small"></i></a>')+('<a class="btn btn12 collapseAll" href="#" onclick="'+b+'"><i class="collapse-small"></i></a>');return b+="</th>"};b.prototype.renderSortingArrowsHeader=function(){return this.dm.isEditable?'<th class="docrefsortcol"></th>':""};b.prototype.renderSequenceNumberHeader=function(b){return'<th class="docrefsortcol">'+c.xmlencode(b.label)+"</th>"};b.prototype.renderThumbnailHeader=
function(b){return'<th class="docrefthumbcol">'+g.getEncodedTranslatedLabel(b.label)+"</th>"};b.prototype.renderDocumentSpecHeader=function(b){return'<th class="docrefdoccol">'+g.getEncodedTranslatedLabel(b.label)+"</th>"};b.prototype.renderDocumentActionsHeader=function(b){return'<th class="docrefactionscol">'+g.getEncodedTranslatedLabel(b.label)+"</th>"};b.prototype.renderDocumentDescriptionHeader=function(b){return'<th class="docrefdoccol">'+g.getEncodedTranslatedLabel(b.label)+"</th>"};b.prototype.renderApprovalStatusHeader=
function(b){return'<th class="docrefApprovalStatus">'+g.getEncodedTranslatedLabel(b.label)+"</th>"};b.prototype.renderApprovalStageHeader=function(b){return'<th class="docrefdoccol">'+g.getEncodedTranslatedLabel(b.label)+"</th>"};b.prototype.renderDocProjectNameHeader=function(b){return'<th class="docrefdoccol">'+g.getEncodedTranslatedLabel(b.label)+"</th>"};b.prototype.renderDocumentVersionHeader=function(b){return'<th class="docrefversioncol">'+g.getEncodedTranslatedLabel(b.label)+"</th>"};b.prototype.renderDocumentAuthorHeader=
function(b){return'<th class="docrefdoccol">'+g.getEncodedTranslatedLabel(b.label)+"</th>"};b.prototype.renderDocumentModifiedDateHeader=function(b){return'<th class="docrefdoccol">'+g.getEncodedTranslatedLabel(b.label)+"</th>"};b.prototype.renderLocalRemoteButtonHeader=function(){return'<th class="docrefsortcol"></th>'};b.prototype.renderDeleteButtonHeader=function(){return this.dm.isEditable?'<th class="docrefremovecol"></th>':""};b.prototype.renderReferencePropertyHeader=function(b){var g;g='<th class="docrefdoccol">'+
c.xmlencode(b.label);"Required"==b.visibility&&(g+='&nbsp;<font color="red">*</font>');return g+"</th>"};b.prototype.renderDocAttributeHeader=function(b){var g;g='<th class="docrefdoccol">'+c.xmlencode(b.label);"Required"==b.visibility&&(g+='&nbsp;<font color="red">*</font>');return g+"</th>"};return b});
define("doctablex/DocumentTypeUtils",[],function(){var g=!1,c="ard cf2 cff2 ds2 dd3 dxf dwg scb vlm".split(" "),j=[],b=[],h=function(c){for(var e=0;e<b.length;e++)if(c==b[e].id)return!0;return!1};return{initDocumentTypes:function(c,e){if(c&&(!g||e)){c.graphicExtList&&(j=c.graphicExtList);if(c.docTypeList)for(var a=0;a<c.docTypeList.length;a++){var d=c.docTypeList[a];"1"==d.enabled&&b.push(d)}g=!0}},getIsInitialized:function(){return g},getDocTypeIDByExtension:function(b,e){if(!g)return"00001_0000000005";
var a=b?b.toLowerCase():"",d;a:{for(d=0;d<c.length;d++)if(a==c[d]&&h("00001_0000000001")){d=!0;break a}d=!1}if(d)return"00001_0000000001";a:{for(d=0;d<j.length;d++)if(a==j[d]&&h("00001_0000000004")){d=!0;break a}d=!1}if(d)return"00001_0000000004";if("pagelist"==e&&h("00001_0000000014"))return"00001_0000000014";if(e&&e.indexOf&&-1<e.indexOf("00002_0000000"))return e;switch(a){case "a3d":if(h("00001_0000000003"))return"00001_0000000003";break;case "acd":if(h("00001_0000000020"))return"00001_0000000020";
break;case "mfg":if(h("00001_0000000002"))return"00001_0000000002";break;case "clf":if(h("00001_0000000008"))return"00001_0000000008";break;case "zcp":if(h("00001_0000000008"))return"00001_0000000008";break;case "dae":if(h("00001_0000000017"))return"00001_0000000017";break;case "zae":if(h("00001_0000000016"))return"00001_0000000016";break;case "chp":if(h("00001_0000000018"))return"00001_0000000018"}return"00001_0000000005"}}});
define("attributecategory/Attribute",[],function(){function g(c){this.id=c.id;this.name=c.name;this.description=c.description;this.unitId=c.unitId;this.rsId=c.rsId;this.type=c.type;c.value?this.setValue(c.value,c.valueHyperlink):this.setValue("");this.placedOriginally=c.placedOriginally||!1;this.placedArr=c.placedArr||[];this.isRequired=c.isRequired||!1;this.rs=c.rs;this.restrictType=c.restrictType;this.isCheckBox=c.isCheckBox||!1;this.isDocReference()&&c.docTable&&(this.docTableObj=c.docTable)}g.prototype.isDocReference=
function(){return this.type?"documentreference"==this.type.toLowerCase():"00001_0000000022"==this.unitId};g.prototype.isText=function(){return this.type?"text"==this.type.toLowerCase():"00001_0000000001"==this.unitId};g.prototype.isRichText=function(){return this.type?"richtext"==this.type.toLowerCase():"00001_0000000021"==this.unitId};g.prototype.setIsRequired=function(c){this.isRequired=c};g.prototype.getIsRequired=function(){return!this.isRequired?!1:this.isRequired};g.prototype.setValue=function(c,
g){c||(g=c="");this.value!=c&&(this.value=c,this.valueHyperlink=g)};g.prototype.copyValueFrom=function(c){c&&(this.value=c.value,this.valueHyperlink="undefined"==typeof c.valueHyperlink?"":c.valueHyperlink,this.hiddenDate="undefined"==typeof c.hiddenDate?"":c.hiddenDate,this.oldDate="undefined"==typeof c.oldDate?"":c.oldDate)};return g});
define("doctablex/AJAXDataCache","doctablex/DocTableXUtils doctablex/DocumentTypeUtils attributecategory/Attribute wcr/webcenter_xml wcr/webcenter_html wcr/ObjectArrayCloneUtil jquery underscore".split(" "),function(g,c,j,b,h,l,e,a){var d=null,k={},i={},f=[],n=[],m=[],p=[],o=[],r=[],w=null,x=[],t=[],y=[],s=function(d){try{var a=b.GetFirstFirstLevelChild(d,"error");if(a){var e=b.GetElementText(a,"code"),c=b.GetElementText(a,"message");g.log("SDK error "+e+": "+c);return e+": "+c}}catch(f){return g.log("Problem in findAndGetSDKError() private method."),
"000: Undefined error"}return""};return{getInstance:function(){d||(d={resetDocDataByDocVerID:function(d){d&&(o[d]&&(o[d]=null),r[d]&&(r[d]=null))},getProjCreationSysDefaults:function(d){d&&(i=null);var a=i;a||(i=a={});if(a.request)return a.request.promise();a.request=new e.Deferred;try{var f=e.ajax({type:"GET",url:window.webcenterConfig.jspBaseUrl+"GetProjectCreationInfo.jsp?action=LoadDefaultSettings&ajax=1",dataType:"xml",context:this});f.fail(function(d,a,b){if(0!=d.status){var d=i,e="Request failed.\n",
e="SESSION_EXP"==b?e+"Session expired, please try again.":e+("Unable to load project creation system defaults.\nServer status: "+a);g.log(e);i=null;d.request.reject(e)}});f.done(function(d){var a=i,e=s(d);if(e)return e="Request failed with SDK error:\n"+e,g.log(e),i=null,a.request.reject(e),a.request.promise();var e={},c=b.GetFirstFirstLevelChild(d,"system_defaults");if(c){e.blankProjectAutoname=b.GetElementText(c,"blank_project_autoname");e.useDefAutoname4BlankProj=b.GetElementText(c,"use_default_autoname_for_blank_project");
e.useDefCategory4BlankProj=b.GetElementText(c,"use_default_category_for_blank_project");if(d=b.GetFirstFirstLevelChild(c,"graphic_files_extensions"))if(d=b.GetFirstLevelChilds(d,"extension")){e.graphicExtList=[];for(var f=0;f<d.length;f++){var o=b.GetElementSelfTextContent(d[f]),o=o.substring(o.indexOf(".")+1);e.graphicExtList.push(o)}}d=[];if(f=b.GetFirstFirstLevelChild(c,"doc_type_list"))if(o=b.GetFirstLevelChilds(f,"doc_type")){e.docTypeList=[];for(var h=0;h<o.length;h++){var m=o[h],f={};f.id=
b.GetElementAttribute(m,"id");d.push(f.id);f.name=b.GetElementText(m,"name");f.labelTag=b.GetElementText(m,"label_tag");f.enabled=b.GetElementText(m,"enabled");f.uploadJSP=b.GetElementText(m,"Upload_JSP");f.typicalExt=b.GetElementText(m,"upload_hint");e.docTypeList.push(f)}}if(e.docTypeList&&0<e.docTypeList.length&&(c=b.GetFirstFirstLevelChild(c,"doctype_autonaming_list")))if(c=b.GetFirstLevelChilds(c,"doctype_autonaming"))for(o=0;o<c.length;o++)if(h=c[o],f=b.GetElementText(h,"doctypeid"))if(f=d.indexOf(f),
!(0>f)&&(f=e.docTypeList[f]))f.anPrefix=b.GetElementText(h,"autoname_prefix"),f.anSuffix=b.GetElementText(h,"autoname_suffix"),f.anCounterLength=b.GetElementText(h,"autoname_counter_length"),f.anOption=b.GetElementText(h,"autoname_option"),f.categoryID=b.GetElementText(h,"category_id"),f.categoryID||(f.categoryID=k),f.categoryOption=b.GetElementText(h,"category_option")}a.request.resolve(e)})}catch(o){alert("Problem in AJAXDataCache.getProjCreationSysDefaults: "+o)}c&&a.request.done(function(a){c.initDocumentTypes(a,
d)});return a.request.promise()},getEffectiveDocTypesSettingsByProjID:function(d,a){if(!d||0==d.length)return e.Deferred().reject("Project ID has to be specified in AJAXDataCache.getEffectiveDocTypesSettingsByProjID() method!").promise();a&&(f[d]=null);var c=f[d];c||(c={},f[d]=c);if(c.request)return c.request.promise();c.request=new e.Deferred;try{var i=new e.Deferred,o=e.ajax({type:"GET",url:window.webcenterConfig.jspBaseUrl+"GetDocUploadInfo.jsp?action=GetAutonamingSettingsForProject&projectID="+
d+"&ajax=1",dataType:"xml",context:this});o.fail(function(d,a,b){0!=d.status&&(d="Request failed.\n",d="SESSION_EXP"==b?d+"Session expired, please try again.":d+("Unable to load project creation system defaults.\nServer status: "+a),g.log(d),i.reject(d))});o.done(function(a){var e=s(a);if(e)e="Request failed with SDK error:\n"+e,g.log(e),i.reject(e);else{e=[];if(a=b.GetFirstFirstLevelChild(a,"autonaming_info"))if(a=b.GetFirstFirstLevelChild(a,"project_autoname"))if(a=b.GetFirstFirstLevelChild(a,"doctype_autonaming_list"))if(a=
b.GetFirstLevelChilds(a,"doctype_autonaming"))for(var f=0;f<a.length;f++){var c=a[f],o=b.GetElementText(c,"projectid");if(o!=d)alert("Project ID of processed <doctype_autonaming> tag is not the same as 'projectID'!");else{var h={};h.projectID=o;h.id=b.GetElementText(c,"doctypeid");h.anPrefix=b.GetElementText(c,"autoname_prefix");h.anSuffix=b.GetElementText(c,"autoname_suffix");h.anCounterLength=b.GetElementText(c,"autoname_counter_length");h.anOption=b.GetElementText(c,"autoname_option");h.categoryID=
b.GetElementText(c,"category_id");h.categoryID||(h.categoryID=k);h.categoryOption=b.GetElementText(c,"category_option");e.push(h)}}i.resolve(e)}});var h=this.getProjCreationSysDefaults(a);e.when(i,h).done(function(d,a){var b=l.getCloneOfObject(a),e=b.docTypeList;if(d&&e)for(var f=0;f<e.length;f++){var k=e[f].id;if(k)for(var i=0;i<d.length;i++){var g=d[i];if(k==g.id){k=b.docTypeList[f];if("0"==g.anOption||"1"==g.anOption)k.anPrefix=g.anPrefix,k.anSuffix=g.anSuffix,k.anCounterLength=g.anCounterLength,
k.anOption=g.anOption;if("0"==g.categoryOption||"1"==g.categoryOption)k.categoryID=g.categoryID,k.categoryOption=g.categoryOption;break}}}c.request.resolve(b)}).fail(function(d){0!=jqXHR.status&&c.request.reject(d)})}catch(m){alert("Problem in AJAXDataCache.getDocTypeSettingsByProjID: "+m)}return c.request.promise()},getDocTemplatesByProjID:function(d,a,f){if(!d||0==d.length)return e.Deferred().reject("Project ID has to be specified in AJAXDataCache.getDocTemplatesByProjID() method!").promise();f&&
(n[d]=null);if((f=n[d])&&!f.isThumbnailsLoaded&&a)f=n[d]=null;f||(f={},n[d]=f);if(f.request)return f.request.promise();f.request=new e.Deferred;f.isThumbnailsLoaded=a;try{var c=window.webcenterConfig.jspBaseUrl+"GetProjectCreationInfo.jsp?action=LoadTemplateDocuments&projectID="+d+"&ajax=1";a&&(c+="&loadThumbnails=1");var i=e.ajax({type:"GET",url:c,dataType:"xml",context:this});i.fail(function(a,b,e){if(0!=a.status){var a=n[d],f="Request failed.\n",f="SESSION_EXP"==e?f+"Session expired, please try again.":
f+("Unable to load project creation system defaults.\nServer status: "+b);g.log(f);n[d]=null;a.request.reject(f)}});i.done(function(e){var f=n[d],c=s(e);if(c)return c="Request failed with SDK error:\n"+c,g.log(c),n[d]=null,f.request.reject(c),f.request.promise();var i=function(d,a){var e={};if(d){e.id=b.GetElementText(d,"document_id");e.docVerID=b.GetElementAttribute(d,"id");e.docVerIdx=b.GetElementText(d,"version_number");e.categoryID=b.GetElementText(d,"category_id");e.categoryID||(e.categoryID=
k);e.docTypeID=b.GetElementText(d,"doctype_id");var f=b.GetFirstFirstLevelChild(d,"document");e.name=b.GetElementText(f,"name");e.thumbnailURL=b.GetElementText(f,"thumbnail_url");a&&(e.folderID=a.id?a.id:"",e.folderName=a.name?a.name:"")}return e},c=[];if(e=b.GetFirstFirstLevelChild(e,"template_documents")){c.tempProjID=b.GetElementText(e,"template_project_id");var o=b.GetFirstFirstLevelChild(e,"template_docs");if(o&&(o=b.GetFirstFirstLevelChild(o,"folder_doc_list"))){var h=b.GetFirstLevelChilds(o,
"folder");if(h)for(var m=0;m<h.length;m++){var p=h[m],j={};j.id=b.GetElementAttribute(p,"id");j.name=b.GetElementText(p,"name");if(p=b.GetFirstFirstLevelChild(p,"doc_version_checkout_list"))if(p=b.GetFirstLevelChilds(p,"doc_version_checkout"))for(var l=0;l<p.length;l++){var u=b.GetFirstFirstLevelChild(p[l],"doc_version");c.push(i(u,j))}}if(p=b.GetFirstFirstLevelChild(o,"doc_version_checkout_list"))if(p=b.GetFirstLevelChilds(p,"doc_version_checkout"))for(l=0;l<p.length;l++)u=b.GetFirstFirstLevelChild(p[l],
"doc_version"),c.push(i(u))}if(a&&(i=b.GetFirstFirstLevelChild(e,"template_docs_thumbnail")))if(i=b.GetFirstLevelChilds(i,"template_doc_thumbnail"))for(e=0;e<i.length;e++){o=i[e];h=b.GetElementText(o,"id");for(m=0;m<c.length;m++)if(j=c[m],h==j.id){j.thumbnailURL=b.GetElementText(o,"thumbnail");break}}}f.request.resolve(c)})}catch(o){alert("Problem in AJAXDataCache.getDocTemplatesByProjID: "+o)}return f.request.promise()},getFoldersByProjID:function(d,a){if(!d||0==d.length)return e.Deferred().reject("Project ID has to be specified in AJAXDataCache.getFoldersByProjID() method!").promise();
a&&(m[d]=null);var f=m[d];f||(f={},m[d]=f);if(f.request)return f.request.promise();f.request=new e.Deferred;try{var c=e.ajax({type:"GET",url:"GetDocUploadInfo.jsp?action=GetSingleProjectFolders&projectID="+d+"&ajax=1&loadfolderpermissions=1",dataType:"xml",context:this});c.fail(function(a,b,e){if(0!=a.status){var a=m[d],f="Request failed.\n",f="SESSION_EXP"==e?f+"Session expired, please try again.":f+("Unable to load project upload folders.\nServer status: "+b);g.log(f);m[d]=null;a.request.reject(f)}});
c.done(function(a){var e=m[d],f=s(a);if(f)return f="Request failed with SDK error:\n"+f,g.log(f),m[d]=null,e.request.reject(f),e.request.promise();f=[];if(a=b.GetFirstFirstLevelChild(a,"upload_projects")){var c=b.GetFirstFirstLevelChild(a,"project");if(c){a=b.GetElementText(c,"root_upload_enabled");if(null!=a&&"1"==a){var a={id:"0",name:""},k=b.GetElementText(c,"root_change_prop_enabled");a.changePropPerm=k&&"1"==k;f.push(a)}if(a=b.GetFirstFirstLevelChild(c,"folder_list"))if(c=b.GetFirstLevelChilds(a,
"folder"))for(k=0;k<c.length;k++){var i=c[k],a={};a.id=b.GetElementAttribute(i,"id");a.name=b.GetElementText(i,"name");var o=!1;if((i=b.GetFirstLevelChilds(i,"permission"))&&0<i.length)o=(o=b.GetElementText(i[0],"update"))&&"1"==o;a.changePropPerm=o;f.push(a)}}}e.request.resolve(f)})}catch(k){alert("Problem in AJAXDataCache.getFoldersByProjID: "+k)}return f.request.promise()},getDocVersionsByProjID:function(d,a){if(!d||0==d.length)return e.Deferred().reject("Project ID has to be specified in AJAXDataCache.getDocVersionsByProjID() method!").promise();
a&&(p[d]=null);var f=p[d];f||(f={},p[d]=f);if(f.request)return f.request.promise();f.request=new e.Deferred;try{var c=e.ajax({type:"GET",url:"GetDocumentList.jsp?projectID="+d+"&ajax=1",dataType:"xml",context:this});c.fail(function(a,b,e){if(0!=a.status){var a=p[d],f="Request failed.\n",f="SESSION_EXP"==e?f+"Session expired, please try again.":f+("Unable to load project documents.\nServer status: "+b);g.log(f);p[d]=null;a.request.reject(f)}});c.done(function(a){var e=p[d],f=s(a);if(f)return f="Request failed with SDK error:\n"+
f,g.log(f),p[d]=null,e.request.reject(f),e.request.promise();f=[];if(a=b.GetFirstFirstLevelChild(a,"document_list"))if(a=b.GetFirstLevelChilds(a,"document"))for(var c=0;c<a.length;c++){var k=a[c],i={};i.id=b.GetElementText(k,"document_version_id");i.name=b.GetElementText(k,"document_name");i.versionIndex=b.GetElementText(k,"document_version");i.revisionIndex=b.GetElementText(k,"document_revision");f.push(i)}e.request.resolve(f)})}catch(k){alert("Problem in AJAXDataCache.getdocByProjID: "+k)}return f.request.promise()},
getDocInfoWithThumbnail:function(d,a){if(!d||0==d.length)return e.Deferred().reject("Document version ID has to be specified in AJAXDataCache.getDocInfoWithThumbnail() method!").promise();a&&(o[d]=null);var f=o[d];f||(f={},o[d]=f);if(f.request)return f.request.promise();f.request=new e.Deferred;try{var c=window.webcenterConfig.jspBaseUrl+"GetDocumentHistory.jsp?docversionid="+d,i=e.ajax({type:"GET",url:c+"&projectinfo=1&includetemplates=1&approvalinfo=1&limitdocversions=1&thumbnailurl=1&dateformat=2&ajax=1",
dataType:"xml",context:this});i.fail(function(a,b,e){if(0!=a.status){var a=o[d],f="Request failed.\n",f="SESSION_EXP"==e?f+"Session expired, please try again.":f+("Unable to load document details (version "+d+").\nServer status: "+b);g.log(f);o[d]=null;a.request.reject(f)}});i.done(function(a){var e=o[d],f=null,c=s(a);if(c)return 0==c.indexOf("021")||0==c.indexOf("005")?(f=k,e.request.resolve(f)):(f="Request failed with SDK error:\n"+c,g.log(f),o[d]=null,e.request.reject(f)),e.request.promise();if(a=
b.GetFirstFirstLevelChild(a,"document_info")){f={};f.docID=b.GetElementText(a,"docID");f.latestDocVerIdx=b.GetElementText(a,"last_version_number");f.docName=b.GetElementText(a,"document_name");f.docDesc=b.GetElementText(a,"description");f.modDate=b.GetElementText(a,"modification_date");f.docIsUrl=b.GetElementBoolean(a,"is_url");f.docCheckedOutOwner=b.GetElementText(a,"checked_out_owner_id");if(c=b.GetFirstFirstLevelChild(a,"permission")){var i={};i.view="1"==b.GetElementText(c,"view");i.add="1"==
b.GetElementText(c,"add");i.change="1"==b.GetElementText(c,"update");i.remove="1"==b.GetElementText(c,"delete");i.checkout="1"==b.GetElementText(c,"checkout");i.download="1"==b.GetElementText(c,"download");i.changeApp="1"==b.GetElementText(c,"change_approval");i.changeTask="1"==b.GetElementText(c,"change_task");i.changeBOM="1"==b.GetElementText(c,"change_bom");i.isProjMgr="1"==b.GetElementText(c,"can_manage_this_project");f.userPerms=i}if(c=b.GetFirstFirstLevelChild(a,"document_version")){f.docVerID=
b.GetElementText(c,"docVersionID");f.docVerIdx=b.GetElementText(c,"version_number");f.docVerDesc=b.GetElementText(c,"version_comments");f.docRevIdx=b.GetElementText(c,"revision");f.docRevLetter=b.GetElementText(c,"revision_letter");f.docTypeID=b.GetElementText(c,"doc_type_id");f.thumbnailURL=b.GetElementText(c,"thumb_url");f.docSourceId=b.GetElementText(c,"source_id");f.has3dView=b.GetElementText(c,"has_3d_view");var m=b.GetFirstFirstLevelChild(c,"author");if(m){var i={},p=b.GetFirstFirstLevelChild(m,
"user");if(p){i.isUser=!0;i.id=b.GetElementText(p,"userID");var m=b.GetElementText(p,"lastname"),j=b.GetElementText(p,"firstname"),p=b.GetElementText(p,"login");i.fullName=h.getUserNameString(j,m,p)}f.docVerAuthor=i}i={};i.cycleStatusCode=b.GetElementText(c,"document_approval_cycle_code");i.cycleStatus=b.GetElementText(c,"document_approval_cycle_status");i.status=b.GetElementText(c,"document_approval_status");i.statusID=b.GetElementText(c,"document_approval_code");i.cycleStatusStringCode={"-1":"no_approval_rule",
"0":"cycle_started",1:"cycle_stopped",2:"cycle_finished"}[i.cycleStatusCode];i.stageIdx=b.GetElementText(c,"stage_index");if(c=b.GetFirstFirstLevelChild(c,"stages"))if(c=b.GetFirstLevelChilds(c,"stage"))for(m=0;m<c.length;m++)if(j=c[m],b.GetElementText(j,"index")==i.stageIdx){i.stageID=b.GetElementText(j,"stage_id");i.stageName=b.GetElementText(j,"name");break}f.appStatus=i}f.appTypeList=[];if(c=b.GetFirstFirstLevelChild(a,"approvaltypes"))if(i=b.GetFirstLevelChilds(c,"approvaltype"))for(c=0;c<i.length;c++)m=
i[c],j={},j.id=b.GetElementText(m,"approvalid"),j.name=b.GetElementText(m,"type_name"),j.translName=b.GetElementText(m,"approvalname"),j.level=b.GetElementText(m,"approval_level"),j.dispOrder=b.GetElementText(m,"display_order"),j.icon=b.GetElementText(m,"icon"),f.appTypeList.push(j);f.projList=[];if(a=b.GetFirstFirstLevelChild(a,"project_list"))if(a=b.GetFirstLevelChilds(a,"project"))for(c=0;c<a.length;c++)m=a[c],i={},i.id=b.GetElementAttribute(m,"id"),i.name=b.GetElementText(m,"name"),m=b.GetElementText(m,
"is_template"),i.isTemplate=m&&"1"==m,f.projList.push(i)}e.request.resolve(f)})}catch(m){alert("Problem in AJAXDataCache.getDocInfoWithThumbnail: "+m)}return f.request.promise()},getDocAttrCatInfo:function(d,a){if(!d||0==d.length)return e.Deferred().reject("Document version ID has to be specified in AJAXDataCache.getDocAttrCatInfo() method!").promise();a&&(r[d]=null);var f=r[d];f||(f={},r[d]=f);if(f.request)return f.request.promise();f.request=new e.Deferred;try{var c=e.ajax({type:"GET",url:window.webcenterConfig.jspBaseUrl+
"GetAttributes.jsp?docverid="+d+"&ajax=1",dataType:"xml",context:this});c.fail(function(a,b,e){if(0!=a.status){var a=r[d],f="Request failed.\n",f="SESSION_EXP"==e?f+"Session expired, please try again.":f+("Unable to load attribute category of document version with ID: "+d+").\nServer status: "+b);g.log(f);r[d]=null;a.request.reject(f)}});c.done(function(a){var e=r[d],f=null,c=s(a);if(c)if(0==c.indexOf("043")||0==c.indexOf("005"))f=k;else return f="Request failed with SDK error:\n"+c,g.log(f),r[d]=
null,e.request.reject(f),e.request.promise();null==f&&((a=b.GetFirstFirstLevelChild(a,"attribute_category"))?(f={},f.id=b.GetElementText(a,"id"),f.id?(f.name=b.GetElementText(a,"name"),f.userUnits=b.GetElementText(a,"user_units")):f=k):f=k);e.request.resolve(f)})}catch(i){alert("Problem in AJAXDataCache.getDocAttrCatInfo: "+i)}return f.request.promise()},getGlobalDocumentSettings:function(d){d&&(w=null);d=w;d||(w=d={});if(d.request)return d.request.promise();d.request=new e.Deferred;try{var a=e.ajax({type:"GET",
url:window.webcenterConfig.jspBaseUrl+"GetDocUploadInfo.jsp?action=LoadGlobalDocumentSettings",dataType:"xml",context:this});a.fail(function(d,a,b){if(0!=d.status){var d=w,f="Request failed.\n",f="SESSION_EXP"==b?f+"Session expired, please try again.":f+("Unable to load global settings.\nServer status: "+a);g.log(f);w=null;d.request.reject(f)}});a.done(function(d){var a=w,f=s(d);if(f)return d="Request failed with SDK error:\n"+f,g.log(d),w=null,a.request.reject(d),a.request.promise();f={};(d=b.GetFirstFirstLevelChild(d,
"site_defaults"))?(f.approvalRestartUploaderCanOverrule=b.GetElementText(d,"approval_restart_option"),f.approvalRestartOption=b.GetElementText(d,"approval_restart_enable_checkbox"),f.allowRaiseRevision=b.GetElementText(d,"allow_raise_revision"),f.openCadType=b.GetElementText(d,"open_cad_type")):f=k;a.request.resolve(f)})}catch(f){alert("Problem in AJAXDataCache.getGlobalDocumentSettings: "+f)}return d.request.promise()},getDocDownloadPerspectives:function(d,a,f){if(!d||0==d.length)return e.Deferred().reject("Document version ID has to be specified in AJAXDataCache.getDocDownloadPerspectives() method!").promise();
if(!a||0==a.length)return e.Deferred().reject("Document type ID has to be specified in AJAXDataCache.getDocDownloadPerspectives() method!").promise();f&&(x[a]=null);f=x[a];f||(f={},x[a]=f);if(f.request)return f.request.promise();f.request=new e.Deferred;try{var c=e.ajax({type:"GET",url:window.webcenterConfig.jspBaseUrl+"GetDocumentPerspectives.jsp?docVerID="+d,dataType:"xml",context:this});c.fail(function(f,b,e){if(0!=f.status){var f=x[a],c="Request failed.\n",c="SESSION_EXP"==e?c+"Session expired, please try again.":
c+("Unable to load download perspectives for document version with ID: "+d+").\nServer status: "+b);g.log(c);x[a]=null;f.request.reject(c)}});c.done(function(d){var f=x[a],e=s(d);if(e)return e="Request failed with SDK error:\n"+e,g.log(e),x[a]=null,f.request.reject(e),f.request.promise();e=null;if(d=b.GetFirstFirstLevelChild(d,"perspective_name_list"))for(var e=[],d=b.GetFirstLevelChilds(d,"perspective_name"),c=0;c<d.length;c++){var i=d[c],k={};k.name=b.GetElementText(i,"name");k.longName=b.GetElementText(i,
"long_name");e.push(k)}f.request.resolve(e)})}catch(i){alert("Problem in AJAXDataCache.getDocDownloadPerspectives: "+i)}return f.request.promise()},getAttribute:function(d,a){if(!d||0==d.length)return e.Deferred().reject("Attribute Name has to be specified in AJAXDataCache.getAttribute() method!").promise();a&&(t[d]=null);var f=t[d];f||(f={},t[d]=f);if(f.request)return f.request.promise();f.request=new e.Deferred;y.push(d);this.fetchAttributes();return f.request.promise()},fetchAttributes:a.debounce(function(){for(var d=
window.webcenterConfig.jspBaseUrl+"GetAttributeListXML.jsp?",a=y,f=0;f<y.length;f++)0<f&&(d+="&"),d+="attrname="+encodeURIComponent(y[f]);d=e.ajax({type:"GET",url:d,dataType:"xml",context:this});d.fail(function(d,f,b){if(0!=d.status){d="Request failed.\n";d="SESSION_EXP"==b?d+"Session expired, please try again.":d+("Unable to load attributes with names: "+a+").\nServer status: "+f);g.log(d);for(f=0;f<a.length;f++){var b=a[f],e=t[b];t[b]=null;e.request.reject(d)}}});d.done(function(d){var f=s(d);if(f){var e=
"Request failed with SDK error:\n"+f;g.log(e);for(f=0;f<a.length;f++){var c=a[f],i=t[c];t[c]=null;i.request.reject(e)}}if(f=b.GetFirstFirstLevelChild(d,"attributes"))if(f=b.GetFirstFirstLevelChild(f,"attribute_list")){d=b.GetFirstLevelChilds(f,"attribute");for(f=0;f<d.length;f++)i=d[f],e=new j({name:b.GetElementText(i,"name"),id:b.GetElementAttribute(i,"id"),description:b.GetElementAttribute(i,"description"),unitId:b.GetElementText(i,"attribute_unit_id"),rsId:b.GetElementText(i,"restricted_set_id"),
placedArr:[],value:""}),i=a.indexOf(e.name),-1!=i&&a.splice(i,1),(i=t[e.name])&&i.request.resolve(e)}for(f=0;f<a.length;f++)c=a[f],i=t[c],i.request.reject("Attribute "+c+" not found")});y=[]},50)});return d},isEmptyValue:function(d){return d&&d===k},getEmptyValue:function(){return k}}});
!function(g){function c(){this._events={};this._conf&&j.call(this,this._conf)}function j(b){b&&(this._conf=b,b.delimiter&&(this.delimiter=b.delimiter),b.maxListeners&&(this._events.maxListeners=b.maxListeners),b.wildcard&&(this.wildcard=b.wildcard),b.newListener&&(this.newListener=b.newListener),this.wildcard&&(this.listenerTree={}))}function b(b){this._events={};this.newListener=!1;j.call(this,b)}function h(b,a,d,c){if(!d)return[];var i=[],f,g,m,p;m=a.length;p=a[c];var o=a[c+1];if(c===m&&d._listeners){if("function"===
typeof d._listeners)b&&b.push(d._listeners);else{a=0;for(c=d._listeners.length;a<c;a++)b&&b.push(d._listeners[a])}return[d]}if("*"===p||"**"===p||d[p]){if("*"===p){for(f in d)"_listeners"!==f&&d.hasOwnProperty(f)&&(i=i.concat(h(b,a,d[f],c+1)));return i}if("**"===p){(p=c+1===m||c+2===m&&"*"===o)&&d._listeners&&(i=i.concat(h(b,a,d,m)));for(f in d)"_listeners"!==f&&d.hasOwnProperty(f)&&("*"===f||"**"===f?(d[f]._listeners&&!p&&(i=i.concat(h(b,a,d[f],m))),i=i.concat(h(b,a,d[f],c))):i=f===o?i.concat(h(b,
a,d[f],c+2)):i.concat(h(b,a,d[f],c)));return i}i=i.concat(h(b,a,d[p],c+1))}(g=d["*"])&&h(b,a,g,c+1);if(d=d["**"])if(c<m)for(f in d._listeners&&h(b,a,d,m),d)"_listeners"!==f&&d.hasOwnProperty(f)&&(f===o?h(b,a,d[f],c+2):f===p?h(b,a,d[f],c+1):(m={},m[f]=d[f],h(b,a,{"**":m},c+1)));else d._listeners?h(b,a,d,m):d["*"]&&d["*"]._listeners&&h(b,a,d["*"],m);return i}var l=Array.isArray?Array.isArray:function(b){return"[object Array]"===Object.prototype.toString.call(b)};b.prototype.delimiter=".";b.prototype.setMaxListeners=
function(b){this._events||c.call(this);this._events.maxListeners=b;this._conf||(this._conf={});this._conf.maxListeners=b};b.prototype.event="";b.prototype.once=function(b,a){this.many(b,1,a);return this};b.prototype.many=function(b,a,d){function c(){0===--a&&i.off(b,c);d.apply(this,arguments)}var i=this;if("function"!==typeof d)throw Error("many only accepts instances of Function");c._origin=d;this.on(b,c);return i};b.prototype.emit=function(){this._events||c.call(this);var b=arguments[0];if("newListener"===
b&&!this.newListener&&!this._events.newListener)return!1;if(this._all){for(var a=arguments.length,d=Array(a-1),k=1;k<a;k++)d[k-1]=arguments[k];k=0;for(a=this._all.length;k<a;k++)this.event=b,this._all[k].apply(this,d)}if("error"===b&&!this._all&&!this._events.error&&(!this.wildcard||!this.listenerTree.error)){if(arguments[1]instanceof Error)throw arguments[1];throw Error("Uncaught, unspecified 'error' event.");}var i;this.wildcard?(i=[],a="string"===typeof b?b.split(this.delimiter):b.slice(),h.call(this,
i,a,this.listenerTree,0)):i=this._events[b];if("function"===typeof i){this.event=b;if(1===arguments.length)i.call(this);else if(1<arguments.length)switch(arguments.length){case 2:i.call(this,arguments[1]);break;case 3:i.call(this,arguments[1],arguments[2]);break;default:a=arguments.length;d=Array(a-1);for(k=1;k<a;k++)d[k-1]=arguments[k];i.apply(this,d)}return!0}if(i){a=arguments.length;d=Array(a-1);for(k=1;k<a;k++)d[k-1]=arguments[k];i=i.slice();k=0;for(a=i.length;k<a;k++)this.event=b,i[k].apply(this,
d);return 0<i.length||this._all}return this._all};b.prototype.on=function(b,a){if("function"===typeof b)return this.onAny(b),this;if("function"!==typeof a)throw Error("on only accepts instances of Function");this._events||c.call(this);this.emit("newListener",b,a);if(this.wildcard){a:{for(var d=b,d="string"===typeof d?d.split(this.delimiter):d.slice(),k=0,i=d.length;k+1<i;k++)if("**"===d[k]&&"**"===d[k+1])break a;k=this.listenerTree;for(i=d.shift();i;){k[i]||(k[i]={});k=k[i];if(0===d.length){k._listeners?
"function"===typeof k._listeners?k._listeners=[k._listeners,a]:l(k._listeners)&&(k._listeners.push(a),k._listeners.warned||(d=10,"undefined"!==typeof this._events.maxListeners&&(d=this._events.maxListeners),0<d&&k._listeners.length>d&&(k._listeners.warned=!0,console.error("(node) warning: possible EventEmitter memory leak detected. %d listeners added. Use emitter.setMaxListeners() to increase limit.",k._listeners.length),console.trace()))):k._listeners=a;break a}i=d.shift()}}return this}this._events[b]?
"function"===typeof this._events[b]?this._events[b]=[this._events[b],a]:l(this._events[b])&&(this._events[b].push(a),this._events[b].warned||(d=10,"undefined"!==typeof this._events.maxListeners&&(d=this._events.maxListeners),0<d&&this._events[b].length>d&&(this._events[b].warned=!0,console.error("(node) warning: possible EventEmitter memory leak detected. %d listeners added. Use emitter.setMaxListeners() to increase limit.",this._events[b].length),console.trace()))):this._events[b]=a;return this};
b.prototype.onAny=function(b){this._all||(this._all=[]);if("function"!==typeof b)throw Error("onAny only accepts instances of Function");this._all.push(b);return this};b.prototype.addListener=b.prototype.on;b.prototype.off=function(b,a){if("function"!==typeof a)throw Error("removeListener only takes instances of Function");var d,c=[];if(this.wildcard)d="string"===typeof b?b.split(this.delimiter):b.slice(),c=h.call(this,null,d,this.listenerTree,0);else{if(!this._events[b])return this;d=this._events[b];
c.push({_listeners:d})}for(var i=0;i<c.length;i++){var f=c[i];d=f._listeners;if(l(d)){for(var g=-1,m=0,p=d.length;m<p;m++)if(d[m]===a||d[m].listener&&d[m].listener===a||d[m]._origin&&d[m]._origin===a){g=m;break}if(0>g)break;this.wildcard?f._listeners.splice(g,1):this._events[b].splice(g,1);0===d.length&&(this.wildcard?delete f._listeners:delete this._events[b])}else if(d===a||d.listener&&d.listener===a||d._origin&&d._origin===a)this.wildcard?delete f._listeners:delete this._events[b]}return this};
b.prototype.offAny=function(b){var a=0,d=0,c;if(b&&this._all&&0<this._all.length){c=this._all;a=0;for(d=c.length;a<d;a++)if(b===c[a]){c.splice(a,1);break}}else this._all=[];return this};b.prototype.removeListener=b.prototype.off;b.prototype.removeAllListeners=function(b){if(0===arguments.length)return!this._events||c.call(this),this;if(this.wildcard)for(var a="string"===typeof b?b.split(this.delimiter):b.slice(),a=h.call(this,null,a,this.listenerTree,0),d=0;d<a.length;d++)a[d]._listeners=null;else{if(!this._events[b])return this;
this._events[b]=null}return this};b.prototype.listeners=function(b){if(this.wildcard){var a=[],b="string"===typeof b?b.split(this.delimiter):b.slice();h.call(this,a,b,this.listenerTree,0);return a}this._events||c.call(this);this._events[b]||(this._events[b]=[]);l(this._events[b])||(this._events[b]=[this._events[b]]);return this._events[b]};b.prototype.listenersAny=function(){return this._all?this._all:[]};"function"===typeof define&&define.amd?define("lib/EventEmitter2",[],function(){return b}):g.EventEmitter2=
b}("undefined"!==typeof process&&"undefined"!==typeof process.title&&"undefined"!==typeof exports?exports:window);define("utils/WCEvent",["lib/EventEmitter2"],function(g){if(!window.WCEvent){var c=window,j=new g({wildcard:!0,delimiter:"."});c.WCEvent={on:function(){j.on.apply(j,arguments)},emit:function(){j.emit.apply(j,arguments)}}}return window.WCEvent});
define("component/actionbuttons/AbstractButton",["jquery","underscore","doctablex/DocTableXUtils","doctablex/AJAXDataCache"],function(g,c,j,b){j=function(b,c){this.btnCtx=null;c&&(this.btnCtx=c);this.baseUrl=window.webcenterConfig.jspBaseUrl||"./";this.loaded=!1;this.afterLoadCallbacks=[];this.docVerId=b;this.isVisible=!1;this.loadDocumentInfo()};j.prototype.loadDocumentInfo=function(){if(this.docVerId){var h=b.getInstance().getDocInfoWithThumbnail(this.docVerId);g.when(h).done(c.bind(function(b){this.loaded=
!0;this.updateDocumentInfo(b);this.render();if(0<this.afterLoadCallbacks.length){for(b=0;b<this.afterLoadCallbacks.length;b++)this.afterLoadCallbacks[b]();this.afterLoadCallbacks=[]}},this))}};j.prototype.render=function(){this.renderBtn(this.btnCtx)};j.prototype.renderBtn=function(b){b&&(this.loaded?(b.empty(),this.isVisible&&this._renderBtnImpl(b)):this.afterLoadCallbacks.push(c.bind(this.renderBtn,this,b)))};j.prototype._renderBtnImpl=function(){};j.prototype.openInNewTab=function(b){b=window.open(b,
"_blank");null!=b&&b.focus()};j.prototype.setBtnContext=function(b){this.btnCtx=b;this.render()};j.prototype.updateDocumentInfo=function(){};return j});
define("tpl",["underscore"],function(g){var c={};return{load:function(c,b,h){g.templateSettings.variable="d";b.toUrl(c+".tpl.html");b(["lib/text!"+c+".tpl.html","underscore"],function(b,c){var a=c.template(b);h(a)})},write:function(j,b,h){if(b in c){var l=g.template("define('<%-d.pluginName%>!<%=d.moduleName%>', function(){return <%=d.func%>});");h(l({pluginName:j,moduleName:b,func:c[b]}))}}}});
define("tpl!component/actionbuttons/InlineUploadNewVersionBlock",function(){return function(g){var c,j;j=""+('<input type="hidden" name="originalDocVersionID" value="'+(null==(c=g.docVerId)?"":_.escape(c))+'" />\r\n<input type="hidden" name="docName_'+(null==(c=g.docVerId)?"":_.escape(c))+'" value="'+(null==(c=g.docName)?"":_.escape(c))+'" />\r\n<input type="hidden" name="docID_'+(null==(c=g.docVerId)?"":_.escape(c))+'" value="'+(null==(c=g.docId)?"":_.escape(c))+'" />\r\n<div style="float:left;">\r\n\t<table width="100%">\r\n\t\t<tr>\r\n\t\t\t<td width="1px" class="darktext_darklink_11">\r\n\t\t\t\t<span class="nobr">'+
(null==(c=g.i18n("CHECKINNEWVERWITHCOMMENT"))?"":_.escape(c))+':<span class="esko-green">*</span>&nbsp;</span>\r\n\t\t\t</td>\r\n\t\t\t<td width="1px">\t\t\t\t\t\t\t\t\t\t\t\t\r\n\t\t\t\t<input size="30" type="file" name="newVersionDocFile_'+(null==(c=g.docVerId)?"":_.escape(c))+'" class="datafield" />\t\t\t\t\t\t\t\t\t\t\r\n\t\t\t</td>\r\n\t\t\t<td align="left">\r\n\t\t\t\t<input  size="50" type="text" name="newVersionDocDesc_'+(null==(c=g.docVerId)?"":_.escape(c))+'" value="'+(null==(c=g.formdata.newVersionDocDesc)?
"":_.escape(c))+'" class="datafield" />\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t\r\n\t\t<\!-- Raise revision checkbox --\>\r\n\t  \t<\!-- only show this HTML control if the setting is enabled --\>\r\n\t  \t');g.allowRaiseRevision&&(j+='\r\n\t  \t  \t<tr>\r\n\t\t\t\t<td align="left" nowrap="nowrap" class="darktext_darklink_bold_12" style="padding-top: 10px;">\r\n\t\t\t\t\t'+(null==(c=g.i18n("REVISION"))?"":_.escape(c))+':\r\n\t\t\t\t</td>\r\n\t\t\t\t<td class="darktext_darklink_11" style="padding-top: 10px;">\r\n\t\t\t\t\t<label>\r\n\t\t\t\t\t\t<input class="datafield" style="position: relative; vertical-align: middle; bottom: 1px;" type="checkbox" value="true" name="incrementRevision_'+
(null==(c=g.docVerId)?"":_.escape(c))+'" '+(null==(c=g.incrementRevision?'checked="checked"':"")?"":_.escape(c))+"/>\r\n\t\t\t\t\t\t"+(null==(c=g.i18n("INCREMENT_TO"))?"":_.escape(c))+"&nbsp;\r\n\t\t\t\t\t\t\t<b>\r\n\t\t\t\t\t\t\t\t"+(null==(c=g.i18n("REVISION"))?"":_.escape(c))+"&nbsp;"+(null==(c=g.lastRevision)?"":_.escape(c))+"\r\n\t\t\t\t\t\t\t</b>\r\n\t\t\t\t\t</label>\r\n\t\t\t\t</td>\r\n\t\t\t</tr>\r\n\t  \t");j+="\r\n\t\t\r\n\t\t\r\n\t\t<\!-- Show the 'update related projects' checkbox if needed --\>\r\n\t\t";
1<g.projectList.length&&!g.alwayUpdateAllProject&&(j+='\r\n\t\t<tr>\r\n\t\t\t<td >\r\n\t\t\t\t<img width="1" height="1" src="'+(null==(c=g.baseUrl)?"":_.escape(c))+'images/clearpixel.gif" />\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t\t<tr>\r\n\t\t\t<td colspan="2" class="darktext_darklink_11">\r\n\t\t\t\t'+(null==(c=g.i18n("PROJ_TASK_DOC_MULPROJ"))?"":_.escape(c))+'\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t\t<tr>\r\n\t\t\t<td >\r\n\t\t\t\t<img width="1" height="1" src="'+(null==(c=g.baseUrl)?"":_.escape(c))+'images/clearpixel.gif" />\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\r\n\t\t<tr>\r\n\t\t\t<td  colspan="2" class="darktext_darklink_11">\r\n\t\t\t\t<input  type="checkbox" '+
(null==(c=!1===g.updateAllProjects?"":'checked="checked"')?"":_.escape(c))+' class="datafield" name="updateAllProjects_'+(null==(c=g.docVerId)?"":_.escape(c))+'" style="position: relative; vertical-align: middle; bottom: 1px;"/>\r\n\t\t\t\t'+(null==(c=g.i18n("PROJ_TASK_DOC_MULPROJ_UPDATEALL"))?"":_.escape(c))+"\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t\t");j+='\r\n\t\t\r\n\t\t<tr>\r\n\t\t\t<td height="10">\r\n\t\t\t\t<img width="1" height="1" src="'+(null==(c=g.baseUrl)?"":_.escape(c))+'images/clearpixel.gif" />\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t\t\r\n\t\t<\!-- APPROVAL --\>\r\n\t\t';
g.approvalRestartEnableCheckbox||(j+='\r\n\t\t\t<\!-- set the default value input field --\>\r\n\t\t\t<tr><td><input type="hidden"  name="startApprovalDefaultValue'+(null==(c=g.docVerId)?"":_.escape(c))+'" id="'+(null==(c=g.idprefix)?"":_.escape(c))+"startApprovalDefaultValue"+(null==(c=g.docVerId)?"":_.escape(c))+'"\r\n\t\t\t\tvalue="'+(null==(c=g.initialStartApprovalValue?"1":"0")?"":_.escape(c))+'"></input>\t</td></tr>\t\r\n\t\t');j+="\r\n\t\t\r\n\t\t";if(2>g.projectList.length){j+=" <\!-- not linked --\>\r\n\t\t\t";
if(g.approvalCycleState){j+="\r\n\t\t\t\t";if("cycle_started"==g.approvalCycleState||"cycle_stopped"==g.approvalCycleState||"cycle_finished"==g.approvalCycleState)j+='\r\n\t\t  \t\t\t<tr id="'+(null==(c=g.idprefix)?"":_.escape(c))+"approvalCheckBox"+(null==(c=g.docVerId)?"":_.escape(c))+'">\r\n\t\t  \t\t\t\t<td class="darktext_darklink_11">&nbsp;</td>\r\n\t\t\t    \t  \t<td class="darktext_darklink_11" valign="top" colspan="2">\r\n\t\t\t    \t  \t\t',j=g.approvalRestartEnableCheckbox?j+('\r\n\t\t\t    \t  \t\t\t<\!-- show checkbox --\>\r\n\t\t\t    \t  \t\t\t<input type="checkbox" name="AppCycleFlag'+
(null==(c=g.docVerId)?"":_.escape(c))+'" id="'+(null==(c=g.idprefix)?"":_.escape(c))+"AppCycleFlag"+(null==(c=g.docVerId)?"":_.escape(c))+'" class="datafield"\r\n\t\t\t    \t  \t\t\t\t'+(null==(c=!0===g.AppCycleFlag||!1!==g.AppCycleFlag&&g.initialStartApprovalValue?' checked="checked"':"")?"":_.escape(c))+' ></input>\r\n\t\t\t  \t\t\t\t\t<img src="'+(null==(c=g.baseUrl)?"":_.escape(c))+'images/clearpixel.gif" width="10" height="1"/>\r\n\t\t\t  \t\t\t\t\t'+(null==(c=g.i18n("DOCCHECKINAPPROVALCYCLE_TAG"))?
"":_.escape(c))+"\r\n\t\t\t    \t  \t\t"):j+("\r\n\t\t\t    \t  \t\t\t<\!-- CheckBox is not enabled, only show a feedback string --\>\r\n\t\t\t    \t  \t\t\t"+(null==(c=g.initialStartApprovalValue?g.i18n("APPROVAL_WILL_AUTO_START"):g.i18n("APPROVAL_WILL_NOT_AUTO_START"))?"":_.escape(c))+"\r\n\t\t\t    \t  \t\t"),j+="\r\n\t\t  \t\t\t\t</td>\r\n\t\t\t\t\t</tr>\r\n\t\t\t\t\t\r\n\t\t\t\t\t<\!-- show calendar --\>\r\n\t\t\t\t\t","1"==g.showDueDate&&(j+='\r\n\t\t\t\t\t\t<tr><td height="5"><img src="'+(null==
(c=g.baseUrl)?"":_.escape(c))+'images/clearpixel.gif" width="1" height="10"/></td></tr>   \r\n\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t<td/>\r\n\t\t\t\t\t\t\t<td class="darktext_darklink_11" align="left" valign="middle" colspan="2">\r\n\t\t\t\t\t\t\t\t<table>\r\n\t\t\t\t\t\t\t\t\t<tr colspan="3" id="'+(null==(c=g.idprefix)?"":_.escape(c))+"approvalDueDate"+(null==(c=g.docVerId)?"":_.escape(c))+'">\r\n\t\t\t\t\t\t\t\t\t\t<td class="darktext_darklink_11" align="left">\t\r\n\t\t\t\t\t\t  \t\t\t\t\t<\!-- specify new due date --\>\r\n\t\t\t\t\t\t    \t  \t\t\t'+
(null==(c=g.i18n("NEW_DUEDATE"))?"":_.escape(c))+':&nbsp;\r\n\t\t\t\t\t\t\t   \t  \t\t</td>\r\n\t\t\t\t\t\t\t    \t  \t<td class="darktext_darklink_11" valign="top" nowrap="nowrap">\r\n\t\t\t\t\t\t\t\t    \t  \t<\!-- due date controls --\>\r\n\t\t\t\t\t\t\t\t\t\t\t<table border="0" cellspacing="0" cellpadding="0" >\r\n\t\t\t\t\t\t\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t<td>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<input type="hidden" name="due_date'+(null==(c=g.docVerId)?"":_.escape(c))+'" size="10" id="'+
(null==(c=g.idprefix)?"":_.escape(c))+"due_date"+(null==(c=g.docVerId)?"":_.escape(c))+'" readonly="readonly" value="'+(null==(c=g.dueDateH1)?"":_.escape(c))+'" />\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t \t<input type="hidden" name="save_due_date'+(null==(c=g.docVerId)?"":_.escape(c))+'" size="10" id="'+(null==(c=g.idprefix)?"":_.escape(c))+"save_due_date"+(null==(c=g.docVerId)?"":_.escape(c))+'" value="'+(null==(c=g.dueDateH2)?"":_.escape(c))+'" />\r\n\t\t\t\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<\!--Put new calendar there --\>\t\t\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t \t<input class="filter datafield" value="'+
(null==(c=g.dueDate)?"":_.escape(c))+'" type="text" name="longFormat_due_date'+(null==(c=g.docVerId)?"":_.escape(c))+'" size="20" id="'+(null==(c=g.idprefix)?"":_.escape(c))+"longFormat_due_date"+(null==(c=g.docVerId)?"":_.escape(c))+'" />\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t</td>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t<td>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t<a target="_self" href="#" onclick="javascript:$(\'#'+(null==(c=g.idprefix)?"":_.escape(c))+"longFormat_due_date"+(null==(c=g.docVerId)?"":_.escape(c))+'\')[0].focus(); return false;">\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<img height="15" src="'+
(null==(c=g.baseUrl)?"":_.escape(c))+'images/show-calendar.gif"  width="24" border="0" />\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t</a>\t\t\t\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t</td>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\r\n\t\t\t\t\t\t\t\t\t\t    \t\t<script type="text/javascript">\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t$(function() {\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t$("#'+(null==(c=g.idprefix)?"":_.escape(c))+"longFormat_due_date"+(null==(c=g.docVerId)?"":_.escape(c))+'").datepicker({dateFormat: "M dd, yy", \r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tonClose: function(dateText, inst) {\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tvar element = $("#'+
(null==(c=g.idprefix)?"":_.escape(c))+"due_periodOfDay"+(null==(c=g.docVerId)?"":_.escape(c))+'")[0];\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tif(element && element.selectedIndex == 0){\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\telement.selectedIndex = (36 + 1);\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t}\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tvar dateVal = dateText;\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tif (dateText != \'\')\t\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t{\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tvar date = new Date(dateText);\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tdateVal = formatDate(date, "MM/dd/yyyy");\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t}\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t$("#'+
(null==(c=g.idprefix)?"":_.escape(c))+"due_date"+(null==(c=g.docVerId)?"":_.escape(c))+'").val(dateVal);\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t}\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t});\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t});\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t<\/script>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t<style type="text/css">\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t    #ui-datepicker-div\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t    {\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t        z-index: 9999999;\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t    }\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t</style>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t<td><img src="'+
(null==(c=g.baseUrl)?"":_.escape(c))+'images/clearpixel.gif" width="5" height="1"/></td>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t<td>\t\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<input type="hidden" name="save_due_periodOfDay'+(null==(c=g.docVerId)?"":_.escape(c))+'" size="10" id="'+(null==(c=g.idprefix)?"":_.escape(c))+"save_due_periodOfDay"+(null==(c=g.docVerId)?"":_.escape(c))+'" value="0"/>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t    <select name="due_periodOfDay'+(null==(c=g.docVerId)?"":_.escape(c))+'" id="'+(null==(c=g.idprefix)?
"":_.escape(c))+"due_periodOfDay"+(null==(c=g.docVerId)?"":_.escape(c))+'" class="datafield">\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="-1">---</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t     \t <option value="0" >00:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="1" >00:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="2" >01:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="3" >01:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="4" >02:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="5" >02:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="6" >03:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="7" >03:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="8" >04:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="9" >04:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="10">05:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="11">05:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="12">06:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="13">06:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="14">07:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="15">07:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="16">08:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="17">08:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="18">09:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="19">09:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="20">10:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="21">10:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="22">11:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="23">11:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="24">12:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="25">12:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="26">13:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="27">13:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="28">14:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="29">14:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="30">15:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="31">15:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="32">16:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="33">16:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="34">17:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="35">17:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="36">18:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="37">18:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="38">19:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="39">19:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="40">20:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="41">20:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="42">21:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="43">21:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="44">22:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="45">22:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="46">23:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="47">23:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t   </select>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t</td>\r\n\t\t\t\t\t\t\t\t\t\t\t  \t</tr>\r\n\t\t\t\t\t\t\t\t\t\t\t</table>\t\r\n\t\t\t\t\t\t\t    \t  \t</td>\t    \t  \t\r\n\t\t\t\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t\t\t\t</table>\t\t\t\t\t\t\r\n\t\t\t\t\t\t\t</td>\r\n\t\t\t\t\t\t</tr> \t\t\t\t\t\t\t\t\t\t\t\t\r\n\t\t\t\t\t'),
j+=" \r\n\t\t\t\t";j+="\r\n\t\t\t"}j+="\r\n\t\t"}return j+='\t\r\n\t</table>\r\n</div>\r\n<div align="center" valign="middle" width="25" style="float:right;">\r\n\t<a href="#" onclick="return false;">\r\n\t\t<img src="'+(null==(c=g.baseUrl)?"":_.escape(c))+'images/delete_icon_15.png" class="remove" title="'+(null==(c=g.i18n("DELETE_TAG"))?"":_.escape(c))+'" width="15" height="15"/>\r\n\t</a>\r\n</div>'}});
define("component/actionbuttons/UploadNewVersionButton","component/actionbuttons/AbstractButton Template tpl!component/actionbuttons/InlineUploadNewVersionBlock jquery underscore utils/webi18n!ActionBtnStrings doctablex/AJAXDataCache doctablex/DocTableXUtils utils/WCEvent".split(" "),function(g,c,j,b,h,l,e,a,d){var k=function(d,a,b,e){this.isExpanded=!1;this.rowCtx=null;this.currentUser=b;this.currentUser||(this.currentUser=gCurrentUser);e&&(this.useInlineForm=e.useInlineForm);this.useInlineForm?
(this.t=new c(l,j),this.t.d.formdata={},this.t.bind("click","img.remove",this.clearRow,this),this.t.bind("change",".datafield",h.bind(this.storeFormData,this))):this.t={d:{}};e&&(e.alwaysUpdateAllProjects&&(this.t.d.alwaysUpdateAllProjects=!0),this.useInlineForm=e.useInlineForm,this.t.d.idprefix=e.uniqueIdPrefix?e.uniqueIdPrefix:"");g.call(this,d,a)};k.prototype=Object.create(g.prototype);k.prototype.constructor=k;k.prototype.loadDocumentInfo=function(){if(this.docVerId){var d=e.getInstance().getDocInfoWithThumbnail(this.docVerId),
a=null;this.useInlineForm&&(a=e.getInstance().getGlobalDocumentSettings());b.when(a,d).done(h.bind(function(d,a){this.loaded=!0;this.updateDocumentInfo(a,d);this.render();if(0<this.afterLoadCallbacks.length){for(var b=0;b<this.afterLoadCallbacks.length;b++)this.afterLoadCallbacks[b]();this.afterLoadCallbacks=[]}},this))}};k.prototype.render=function(){this.renderBtn(this.btnCtx);this.isExpanded&&this.rowCtx&&(this.t.render(),this.fileField&&this.rowCtx.find("input[name^=newVersionDocFile_]").replaceWith(this.fileField),
this.t.d.duePeriod&&this.rowCtx.find("select[name^=due_periodOfDay]").val(this.t.d.duePeriod))};k.prototype._renderBtnImpl=function(d){var a=b('<img src="'+this.baseUrl+'images/round_button_upload.png" />');a.attr("alt",l.t("DOCDETAILSCHECKIN_TAG"));a.attr("title",l.t("DOCDETAILSCHECKIN_TAG"));a.addClass("actionBtn");var c=b('<a href="#"></a>');c.append(a);c.click(h.bind(function(){this.btnClicked();return!1},this));d.append(c)};k.prototype.btnClicked=function(){if(this.useInlineForm)this.isExpanded=
!0,this.render(),d.emit("btnClicked.UploadNewVersion."+this.docVerId);else{var b=a.getMenuFileParamValue(),b=window.open(this.baseUrl+"dodocdetailsactions.jsp?actionVal=DirectCheckinDoc&docVerID="+this.docVerId+"&menu_file="+b,"_blank");null!=b&&b.focus()}};k.prototype.clearRow=function(){this.rowCtx.empty();this.isExpanded=!1};k.prototype.revisionLetters="ABCDEFGHIJKLMNOPQRSTUVWXYZ".split("");k.prototype.getRevisionLetter=function(d){var a="";if(d&&!isNaN(d)){for(;d>this.revisionLetters.length;)a+=
this.revisionLetters[this.revisionLetters.length-1],d-=this.revisionLetters.length;0<d&&(a+=this.revisionLetters[d-1])}else a+=this.revisionLetters[0];return a};k.prototype.setRowContext=function(d){this.rowCtx=d;this.t.setContext(d);this.render()};k.prototype.storeFormData=function(){this.fileField=this.rowCtx.find("input[name^=newVersionDocFile_]");this.t.d.formdata.newVersionDocDesc=this.rowCtx.find("input[name^=newVersionDocDesc_]").val();this.t.d.incrementRevision="checked"==this.rowCtx.find("input[name^=incrementRevision_]").attr("checked");
this.t.d.updateAllProjects="checked"==this.rowCtx.find("input[name^=updateAllProjects_]").attr("checked");this.t.d.AppCycleFlag="checked"==this.rowCtx.find("input[name^=AppCycleFlag]").attr("checked");this.t.d.dueDate=this.rowCtx.find("input[name^=longFormat_due_date]").val();this.t.d.dueDateH1=this.rowCtx.find("input[name^=due_date]").val();this.t.d.dueDateH2=this.rowCtx.find("input[name^=save_due_date]").val();this.t.d.duePeriod=this.rowCtx.find("select[name^=due_periodOfDay]").val()};k.prototype.updateDocumentInfo=
function(d,a){this.t.d.docVerId=this.docVerId;this.t.d.docId=d.docID;this.t.d.docName=d.docName;this.t.d.projectList=d.projList;var b=null;try{b=parseInt(d.docRevIdx)}catch(c){b=0}this.t.d.lastRevision=this.getRevisionLetter(b+1);d.appStatus&&(this.t.d.approvalCycleState=d.appStatus.cycleStatusStringCode);this.t.d.showDueDate=d.userPerms.changeApp?"1":"0";if(!d.docIsUrl&&!("00001_0000000014"==d.docTypeID&&d.docSourceId)&&(!d.docCheckedOutOwner||d.docCheckedOutOwner==this.currentUser.userID)&&(d.userPerms.isProjMgr||
d.userPerms.checkout))this.isVisible=!0;a&&(b=a.approvalRestartOption,this.t.d.initialStartApprovalValue="1"==b?!0:"2"==b?!1:"cycle_started"==a.approvalCycleState||"cycle_finished"==a.approvalCycleState?!0:!1,this.t.d.allowRaiseRevision="1"==a.allowRaiseRevision,this.t.d.approvalRestartEnableCheckbox=a.approvalRestartUploaderCanOverrule);this.t.d.baseUrl=this.baseUrl};k.prototype.validate=function(){var d=[];if(this.isExpanded){var f=this.rowCtx.find("input[name^=newVersionDocFile_]"),c=f.val();c?
a.getFileExtension(c)!=a.getFileExtension(this.t.d.docName)&&(f={isBlocking:!0,msg:l.t("BADCHECKINEXT"),element:f},d.push(f)):(f={isBlocking:!0,msg:l.t("DocRowFileNotChosen"),element:f},d.push(f));f=this.rowCtx.find("input[name^=newVersionDocDesc_]");b.trim(f.val())||(f={isBlocking:!0,msg:l.t("DOCDETAILSCHECKINCOMMENT_TAG"),element:f},d.push(f))}return d};k.wcrinit=function(d){var a=b(d).attr("data-docverid"),c=b(d).attr("data-inlinectx"),e=b(d).attr("data-inline");(new k(a,b(d),window.gCurrentUser,
{useInlineForm:"true"==e})).setRowContext(b("#"+c))};return k});
define("component/actionbuttons/ViewButton","component/actionbuttons/AbstractButton jquery underscore utils/webi18n!ActionBtnStrings doctablex/DocTableXUtils doctablex/AJAXDataCache".split(" "),function(g,c,j,b,h){var l=function(b,a){g.call(this,b,a)};l.prototype=Object.create(g.prototype);l.prototype.constructor=l;l.prototype._renderBtnImpl=function(e){var a=c('<img src="'+this.baseUrl+'images/viewmag.png" />');a.attr("alt",b.t("CLICK_HERE_TO_VIEW"));a.attr("title",b.t("CLICK_HERE_TO_VIEW"));a.addClass("actionBtn");
var d=c("<a></a>");d.attr("href","#");d.append(a);d.click(j.bind(function(){this.openViewer();return!1},this));e.append(d)};l.prototype.openViewer=function(){var b=h.getMenuFileParamValue(),a=h.getSourcePageURLEncoded();this.openInNewTab(this.baseUrl+"viewdocument.jsp?docVerID="+this.docVerId+"&menu_file="+b+"&pageIndex=0&sourcePage="+a)};l.prototype.updateDocumentInfo=function(b){this.isVisible=b.userPerms.view&&!b.docIsUrl};l.wcrinit=function(b){var a=c(b).attr("data-docverid");new l(a,c(b))};return l});
define("component/actionbuttons/DownloadButton","component/actionbuttons/AbstractButton jquery underscore utils/webi18n!ActionBtnStrings doctablex/AJAXDataCache doctablex/DocTableXUtils".split(" "),function(g,c,j,b,h,l){var e=function(a,d){this.downloadType="none";g.call(this,a,d)};e.prototype=Object.create(g.prototype);e.prototype.constructor=e;e.prototype._renderBtnImpl=function(a){var d=c('<img src="'+this.baseUrl+'images/round_button_download.png" />');d.attr("alt",b.t("DOWNLOAD"));d.attr("title",
b.t("DOWNLOAD"));d.addClass("actionBtn");var e=j.bind(function(){"pespective"==this.downloadType?this.showDownloadPerspectives():"locked"==this.downloadType?confirm(b.t("CHECKED_OUT_DOWNLOAD_WARNING"))&&this.downloadDocument():(this.downloadType="download")&&this.downloadDocument();return!1},this),i=c('<a href="#"></a>');i.click(e);i.append(d);a.append(i)};e.prototype.downloadDocument=function(){var a=l.getSourcePageURLEncoded();window.location=this.baseUrl+"doprojectdocsactions.jsp?actionVal=DownloadDoc&actionDocVerID="+
this.docVerId+"&projectID="+this.projectId+"&sourcePage="+a};e.prototype.showDownloadPerspectives=function(){var a=h.getInstance().getDocDownloadPerspectives(this.docVerId,this.docTypeId);c.when(a).done(j.bind(function(d){if(null==d)alert(b.t("UNABLETOGETFORMATSFORDOWNLOAD"));else if(0==d.length)alert(b.t("NOFORMATSFORFILETYPE"));else{this.popupContent=c("<div />");for(var a=0;a<d.length;a++){var e=d[a].name,f=d[a].longName;"Native"===e&&(e=b.t("NATIVE_PERSPECTIVE_NAME"),f="");var g=c('<input type="radio" name="selectedDownloadFormat"/>');
g.val(f);this.popupContent.append(g).append("&nbsp;"+e+"<br/>")}this.showDialog()}},this))};e.prototype.showDialog=function(){if(this.popupContent){var a={};a[b.t("CLOSE")]=j.bind(function(){this.popupContent.dialog("close")},this);a[b.t("DOWNLOAD")]=j.bind(function(){this.downloadPerspective()&&this.popupContent.dialog("close")},this);this.popupContent.dialog({autoOpen:!1,dialogClass:"no-close",modal:!0,title:b.t("SELFORMAT_NOTREDUNDANT"),position:"center",buttons:a}).dialog("open")}};e.prototype.downloadPerspective=
function(){var a=this.popupContent.find("input:checked");if(1!=a.length)return alert(b.t("ONEFORMATHASTOBESELECTEDTOPERFORMDOWNLOAD")),!1;window.location=this.baseUrl+"dodocdetailsactions.jsp?actionVal=DoDownloadPerspective&docVerID="+this.docVerId+"&perspectiveName="+a.val();return!0};e.prototype.updateDocumentInfo=function(a){this.docTypeId=a.docTypeID;0<a.projList.length&&(this.projectId=a.projList[0].id);a.userPerms.download&&!a.docIsUrl&&(this.downloadType="00001_0000000001"==a.docTypeID||"00001_0000000002"==
a.docTypeID||"00001_0000000018"==a.docTypeID?"pespective":a.docCheckedOutOwner?"locked":"download");this.isVisible="none"!=this.downloadType};e.wcrinit=function(a){var d=c(a).attr("data-docverid");new e(d,c(a))};return e});
define("component/actionbuttons/Open3DButton","component/actionbuttons/AbstractButton jquery underscore utils/webi18n!ActionBtnStrings doctablex/AJAXDataCache doctablex/DocTableXUtils".split(" "),function(g,c,j,b,h,l){var e=function(a,d){g.call(this,a,d)};e.prototype=Object.create(g.prototype);e.prototype.constructor=e;e.prototype._renderBtnImpl=function(a){var d=c('<img src="'+this.baseUrl+'images/view3d.png" />');d.attr("alt",b.t("CLICK_HERE_TO_VIEW_3D"));d.attr("title",b.t("CLICK_HERE_TO_VIEW_3D"));
d.addClass("actionBtn");var e=j.bind(function(){this.openDocument3D();return!1},this),i=c('<a href="#"></a>');i.click(e);i.append(d);a.append(i)};e.prototype.openDocument3D=function(){var a=l.getMenuFileParamValue(),d=l.getSourcePageURLEncoded();this.openInNewTab(this.baseUrl+"doctypecolladaview.jsp?docVerID="+this.docVerId+"&menu_file="+a+"&sourcePage="+d)};e.prototype.updateDocumentInfo=function(a){this.isVisible="1"==a.has3dView};e.wcrinit=function(a){var d=c(a).attr("data-docverid");new e(d,c(a))};
return e});
define("component/actionbuttons/OpenACADButton","component/actionbuttons/AbstractButton jquery underscore utils/webi18n!ActionBtnStrings doctablex/AJAXDataCache doctablex/DocTableXUtils".split(" "),function(g,c,j,b,h,l){var e=function(a,d){g.call(this,a,d)};e.prototype=Object.create(g.prototype);e.prototype.constructor=e;e.prototype.loadDocumentInfo=function(){if(this.docVerId){var a=h.getInstance().getGlobalDocumentSettings(),d=h.getInstance().getDocInfoWithThumbnail(this.docVerId);c.when(a,d).done(j.bind(function(d,
a){this.loaded=!0;this.updateDocumentInfo(a,d);this.render();if(0<this.afterLoadCallbacks.length){for(var b=0;b<this.afterLoadCallbacks.length;b++)this.afterLoadCallbacks[b]();this.afterLoadCallbacks=[]}},this))}};e.prototype._renderBtnImpl=function(a){var d=c('<img src="'+this.baseUrl+'images/open_acad.png" />');d.attr("alt",b.t("DOCOPENINACAD"));d.attr("title",b.t("DOCOPENINACAD"));d.addClass("actionBtn");var e="",i=j.bind(function(){if("Standard"===this.openType){var d=l.getMenuFileParamValue();
e=this.baseUrl+"doctypeotherview.jsp?docVerID="+this.docVerId+"&menu_file="+d}else"Enterprise"===this.openType&&(e=encodeURI("acade:@"+this.projectName+":"+this.docName));j.defer(function(){window.location=e});return!1},this),f=c('<a href="#"></a>');f.click(i);f.append(d);a.append(f)};e.prototype.updateDocumentInfo=function(a,d){this.docName=a.docName;0<a.projList.length&&(this.projectName=a.projList[0].name);if(a.userPerms.download&&("00001_0000000001"==a.docTypeID||"00001_0000000002"==a.docTypeID||
"00001_0000000003"==a.docTypeID))this.openType=d.openCadType;this.isVisible=this.openType&&"None"!==this.openType};e.wcrinit=function(a){var d=c(a).attr("data-docverid");new e(d,c(a))};return e});
define("doctablex/StaticDocumentRowView","doctablex/DocTableXUtils utils/WCEvent wcr/webcenter_xml wcr/webcenter_html jquery wcr/ObjectArrayCloneUtil component/actionbuttons/UploadNewVersionButton component/actionbuttons/ViewButton component/actionbuttons/DownloadButton component/actionbuttons/Open3DButton component/actionbuttons/OpenACADButton utils/webi18n!DocRefStrings wcr/extpopup wcr/approvalInfoPopup".split(" "),function(g,c,j,b,h,l,e,a,d,k,i,f){var n=function(d,a,b){if(!d&&!a&&!b)return this;
this.dm=d;if(!this.dm)return alert("Cannot initialized view without data model."),null;this.phElemID=a;this.rowIndex=-1;this.renderOptions=b;this.renderOptions||(this.renderOptions=this.dm.renderOptions);this.supportAdvancedThumb=b.supportAdvancedThumb;!this.supportAdvancedThumb&&!1!==this.supportAdvancedThumb&&(this.supportAdvancedThumb=!1,this.constructor==n.prototype.constructor&&(this.supportAdvancedThumb=!0));this.itemRootElemStr=this.renderOptions.itemRootElemStr||"td";this.renderMethodMap=
{AttributeFlapout:this.renderExpandCollapseButton,UpDownArrows:this.renderSortingArrows,SequenceNumber:this.renderSequenceNumber,DocumentName:this.renderDocumentSpec,DocumentActions:this.renderDocumentActions,DocumentProperty_Thumbnail:this.renderThumbnail,DocumentProperty_Description:this.renderDocumentDescription,DocumentProperty_ApprovalStatus:this.renderApprovalStatus,DocumentProperty_ApprovalStage:this.renderApprovalStage,DocumentProperty_Project:this.renderDocProjectName,DocumentProperty_VersionRevision:this.renderDocumentVersion,
DocumentProperty_VersionAuthor:this.renderDocumentAuthor,DocumentProperty_ModifiedDate:this.renderDocumentModifiedDate,ReferenceProperty:this.renderReferenceProperty,DocumentAttribute:this.renderDocAttribute,LocalRemote:this.renderLocalRemoteButton,DeleteButton:this.renderDeleteButton};this._newVersionCell=this._newVersionRow=this.newVersionBtn=this.openAcadBtn=this.open3dBtn=this.downloadBtn=this.viewBtn=null;return this};n.prototype.render=function(d){var a=h("#"+this.phElemID);if(0==a.length)return a;
var b=this.renderOptions;d&&(this.renderOptions=d);this.rowIndex=this.dm.getIndexInTable();"list"==this.renderOptions.renderMethod?this.renderSimple(a):"table"==this.renderOptions.renderMethod?this.renderComplex(a):alert("Not supported render method: "+this.renderOptions.renderMethod+".");this.renderOptions=b;this.renderOptions.styleObj&&a.find("*").not(".darktext_greenlink_12_bold").not(".darktext_greenlink_11").css(this.renderOptions.styleObj);return a};n.prototype.repaintRow=function(){this.renderOptions.isRepaintRow=
!0;this.render();this.renderOptions.isRepaintRow=!1};n.prototype.renderSimple=function(d){if(!d||0==d.length)return d;try{if(d.html(""),this.renderDocAttrCatAndRefPropsPlaceholder(d),this.renderNewVersionPlaceholder(d),this.renderSortingArrows(d),this.renderThumbnail(d,{thumbnailSize:50}),this.renderDocumentSpec(d),this.renderDeleteButton(d),!this.dm.getParentDocTable().allowMultiple&&this.constructor==n){var a="<"+this.itemRootElemStr+' class="darktext_greenlink_11">',b=this.dm.getParentDocTable().view,
a=a+b.renderGreenLinksPlaceholder("inline"),a=a+("</"+this.itemRootElemStr+">");if(0<h(a).appendTo(d).length){var f=this.dm.getParentDocTable(),c=f.getDocumentSourceOptions(f.greenLinksPrefix+"_inline");f.dshObj.displayLinks(c)}}}catch(e){return g.log("Problem in StaticDocumentRowView.renderSimple:\n"+e),null}return d};n.prototype.renderComplex=function(d){if(!d||0==d.length)return d;try{d.html("");this.renderDocAttrCatAndRefPropsPlaceholder(d);this.renderNewVersionPlaceholder(d);var a=this.renderOptions.columns;
if(a)for(var b=0;b<a.length;b++){var f=this.renderOptions.columns[b];if(f){var c=f.type;"DocumentProperty"==c&&(c+="_"+f.typeDetail);var e=this.renderMethodMap[c];e&&e.call(this,d,f)}}var i=d.find(">td").size()-1;h("#"+this.dm.aCatRowID+" > td.attrCategoryColumn").attr("colspan",i)}catch(k){return g.log("Problem in StaticDocumentRowView.renderComplex:\n"+k),null}return d};n.prototype.renderExpandCollapseButton=function(d){try{var a="",a=a+("<"+this.itemRootElemStr+' class="center">');if(!this.dm.isInErrorStatus())var b=
this.dm.getThisInDOM()+".expandClicked(this); return false;",c=this.dm.hasAttrCat()?"":" hiddenElement",a=a+('<a class="btn btn16 expandCollapseButton '+c+'" href="#" onclick="'+b+'">'),a=this.dm.dependsOnItself?a+('<i class="cycle" title="'+j.xmlencode(f.t("DocRowCyclicDepTooltip"))+'"></i>'):this.dm.aCatExpanded?a+('<i class="collapse" title="'+j.xmlencode(f.t("DocRowCollapseTooltip"))+'"></i>'):a+('<i class="expand" title="'+j.xmlencode(f.t("DocRowExpandTooltip"))+'"></i>'),a=a+"</a>";a+="</"+
this.itemRootElemStr+">";d.append(a)}catch(e){g.log("Problem in StaticDocumentRowView.renderExpandCollapseButton:\n"+e)}};n.prototype.renderSortingArrows=function(d){try{var a="";if(this.dm.isEditable){var a=a+("<"+this.itemRootElemStr+">"),b=this.dm.getParentInDOM()+".moveUpButtonClicked("+this.rowIndex+");return false;",f=this.dm.getParentInDOM()+".moveDownButtonClicked("+this.rowIndex+");return false;",c=0==this.rowIndex,e=this.rowIndex==this.dm.getParentDocTable().getNumberOfRows()-1;c&&!e?a+=
'<a class="btn btn9x14 float-right" href="#" onclick="'+f+'"><i class="sort-down"></i></a>':e&&!c?a+='<a class="btn btn9x14 float-right" href="#" onclick="'+b+'"><i class="sort-up"></i></a>':!c&&!e&&(a+='<div class="float-right">',a+='<a class="btn btn9x14 float-right" href="#" onclick="'+b+'"><i class="sort-asc"></i></a><br/>',a+='<a class="btn btn9x14 float-right" href="#" onclick="'+f+'"><i class="sort-desc"></i></a>',a+="</div>");a+="</"+this.itemRootElemStr+">"}d.append(a)}catch(i){g.log("Problem in StaticDocumentRowView.renderSortingArrows:\n"+
i)}};n.prototype.renderSequenceNumber=function(d){try{var a="",a=a+("<"+this.itemRootElemStr+' class="center">'),a=a+("<span>"+(this.rowIndex+1)+"</span>"),a=a+("</"+this.itemRootElemStr+">");d.append(a)}catch(b){g.log("Problem in StaticDocumentRowView.renderSequenceNumber:\n"+b)}};n.prototype.renderThumbnail=function(d,a){try{var b="",b=b+("<"+this.itemRootElemStr+">");if(!this.dm.isInErrorStatus())var f=this.dm.thumbnailURL,b=f&&0<f.length?b+this.customThumbnailHTML(f,a.thumbnailSize):b+'<div class="thumb"></div>';
b+="</"+this.itemRootElemStr+">";d.append(b)}catch(c){g.log("Problem in StaticDocumentRowView.renderThumbnail:\n"+c)}};n.prototype.renderDocumentSpec=function(d,a){try{var b="",b=b+("<"+this.itemRootElemStr+">"),b=b+this.renderInlineLabel(a);if(this.dm.isInErrorStatus()){b+='<span class="brokenDocRef">';this.dm.docName&&(b+=j.xmlencode(this.dm.docName)+"&nbsp;&nbsp;");var c=j.xmlencode(f.t("DocRowCannotLoadDoc")),b=b+('<img border="0" src="'+window.webcenterConfig.jspBaseUrl+'images/warning.gif" title="'+
c+'"/>'),b=b+"</span>"}else b+='<a class="docrefdoclink" href="'+window.webcenterConfig.jspBaseUrl+"docdetails.jsp?docVerID="+this.dm.docVerID+"&amp;menu_file="+g.getMenuFileParamValue()+'" target="_blank">',b+=j.xmlencode(this.dm.docName),b+="</a>",this.dm.docCheckedOutOwner&&(b+='&nbsp;<img border="0" style="vertical-align:bottom" title="'+j.xmlencode(f.t("DOC_CHECKED_OUT"))+'" alt="'+j.xmlencode(f.t("DOC_CHECKED_OUT"))+'" src="images/locked_on_white.gif">');b+="</"+this.itemRootElemStr+">";d.append(b)}catch(e){g.log("Problem in StaticDocumentRowView.renderDocumentSpec:\n"+
e)}};n.prototype.renderDocumentActions=function(d,a){var b;b=""+("<"+this.itemRootElemStr+' class="docrefactionscol">');if(!this.dm.isInErrorStatus())for(var f=a.typeDetail.split("|"),c=0;c<f.length;c++){var e=f[c],i=this.phElemID+"_actionBtn_"+g.getNextUniquePrefix();b+='<span id="'+i+'" />';var k=null;switch(e){case "View":k=this.getViewBtn();break;case "Open3d":k=this.getOpen3DBtn();break;case "OpenAcad":k=this.getOpenACADBtn();break;case "Download":k=this.getDownloadBtn();break;case "UploadNewVersion":k=
this.getUploadNewVersionBtn()}k&&_.defer(_.bind(function(d,a){a.renderBtn(h("#"+d))},this,i,k))}b+="</"+this.itemRootElemStr+">";d.append(b)};n.prototype.renderDocumentDescription=function(d,a){try{var b="",b=b+("<"+this.itemRootElemStr+">"),b=b+this.renderInlineLabel(a);this.dm.isInErrorStatus()||this.dm.docDesc&&(b+="<span>"+j.xmlencode(this.dm.docDesc)+"</span>");b+="</"+this.itemRootElemStr+">";d.append(b)}catch(f){g.log("Problem in StaticDocumentRowView.renderDocumentDescription:\n"+f)}};n.prototype.renderApprovalStatus=
function(d,a){try{var c="",c=c+("<"+this.itemRootElemStr+"  >"),c=c+this.renderInlineLabel(a);if(!this.dm.isInErrorStatus()){var e=this.dm.appStatus;if(e&&e.cycleStatus){for(var i=null,k=this.dm.appTypeList,h=0;h<k.length;h++){var l=k[h];if(l.id==e.statusID){i=l;break}}var n="onclick=\"javascript:showapprovaldetails(this, event,'"+this.dm.docVerID+"', 'Approval Setup "+j.xmlencode(b.encodeForJScript(this.dm.docName))+"')\"",n=n+' onmouseout="javascript:delayhidemenu();"',c=c+'<div class="docrefApprovalStatus">';
if("Not Started"==e.cycleStatus)var v=j.xmlencode(f.t("APPROVAL_STATUS_HOLD")),c=c+('<img border="0" src="images/stopped-approval.png" alt="'+v+'" title="'+v+'" '+n+" />");else i&&(v=j.xmlencode(i.translName),c+='<img border="0" src="images/'+i.icon+'" alt="'+v+'" title="'+v+'" '+n+"/>");c+="</div>";c+="</div>"}}c+="</"+this.itemRootElemStr+">";d.append(c)}catch(A){g.log("Problem in StaticDocumentRowView.renderApprovalStatus:\n"+A)}};n.prototype.renderApprovalStage=function(d,a){try{var b="",b=b+
("<"+this.itemRootElemStr+' class="docrefApprovalStage" >'),b=b+this.renderInlineLabel(a);if(!this.dm.isInErrorStatus()){var f=this.dm.appStatus;f&&f.stageName&&(b+=j.xmlencode(f.stageName))}b+="</"+this.itemRootElemStr+">";d.append(b)}catch(c){g.log("Problem in StaticDocumentRowView.renderDocumentAuthor:\n"+c)}};n.prototype.renderDocProjectName=function(d,a){try{var b="",b=b+("<"+this.itemRootElemStr+">"),b=b+this.renderInlineLabel(a);if(!this.dm.isInErrorStatus()){var f=this.dm.projects;if(f&&0<
f.length)for(var c=0;c<f.length;c++){var e=f[c];e&&(e.id&&e.name)&&(0<c&&(b+="<br/>"),b+='<a href="'+window.webcenterConfig.jspBaseUrl+"projdetails.jsp?projectID="+e.id+"&amp;menu_file="+g.getMenuFileParamValue()+'" target="_blank">',b+=j.xmlencode(e.name),b+="</a>")}else this.dm.project.id&&this.dm.project.name&&(b+='<a href="'+window.webcenterConfig.jspBaseUrl+"projdetails.jsp?projectID="+this.dm.project.id+"&amp;menu_file="+g.getMenuFileParamValue()+'" target="_blank">',b+=j.xmlencode(this.dm.project.name),
b+="</a>")}b+="</"+this.itemRootElemStr+">";d.append(b)}catch(i){g.log("Problem in StaticDocumentRowView.renderDocProjectName:\n"+i)}};n.prototype.renderDocumentVersion=function(d,b){try{var a="",a=a+("<"+this.itemRootElemStr+' class="center">'),a=a+this.renderInlineLabel(b);this.dm.isInErrorStatus()||(this.dm.docVerIdx&&(a+=this.dm.docVerIdx,this.dm.docRevLetter&&(a+="("+this.dm.docRevLetter+")")),b.uploadNewVersion&&(a+='&nbsp;&nbsp;<span id="'+this.phElemID+'_uploadNewVersionBtn" />',_.defer(_.bind(function(){var d=
this.getUploadNewVersionBtn();d&&d.setBtnContext(h("#"+this.phElemID+"_uploadNewVersionBtn"))},this))));a+="</"+this.itemRootElemStr+">";d.append(a)}catch(f){g.log("Problem in StaticDocumentRowView.renderDocumentVersion:\n"+f)}};n.prototype.renderDocumentAuthor=function(d,b){try{var a="",a=a+("<"+this.itemRootElemStr+' class="Black_11">'),a=a+this.renderInlineLabel(b);!this.dm.isInErrorStatus()&&this.dm.docAuthor&&(a+='<a class="docrefdoclink" href="#" onclick="javascript:ShowUserDetails(\''+this.dm.docAuthor.id+
"');return false;\">",a+=j.xmlencode(this.dm.docAuthor.fullName),a+="</a>");a+="</"+this.itemRootElemStr+">";d.append(a)}catch(f){g.log("Problem in StaticDocumentRowView.renderDocumentAuthor:\n"+f)}};n.prototype.renderDocumentModifiedDate=function(d,a){try{var f="",f=f+("<"+this.itemRootElemStr+' class="center">'),f=f+this.renderInlineLabel(a);this.dm.isInErrorStatus()||this.dm.modDate&&(f+=j.xmlencode(b.getDateHourString(this.dm.modDate)));f+="</"+this.itemRootElemStr+">";d.append(f)}catch(c){g.log("Problem in StaticDocumentRowView.renderDocumentAuthor:\n"+
c)}};n.prototype.renderLocalRemoteButton=function(d,a){try{var b="",b=b+("<"+this.itemRootElemStr+' class="center">');if(!this.dm.isInErrorStatus()&&this.dm.getParentDocTable().hasLocalRemoteButton()&&this.dm.isRemoteDocument()){var c="",e=j.xmlencode(f.t("DocRowLocalRemoteInfoTooltip")),i="docref_info_external.png";this.dm.isEditable&&(this.dm.canUserAddDocuments()&&"ReadOnly"!=a.visibility&&!this.dm.dependsOnItself)&&(c="javascript: "+this.dm.getParentInDOM()+".localRemoteButtonClicked("+this.rowIndex+
");",e=j.xmlencode(f.t("DocRowLocalRemoteButtonTooltip")),i="docref_make_internal.png");b+='<img border="0" src="'+window.webcenterConfig.jspBaseUrl+"images/"+i+'"';b+=' title="'+e+'" onclick="'+c+'"/>'}b+="</"+this.itemRootElemStr+">";d.append(b)}catch(k){g.log("Problem in StaticDocumentRowView.renderLocalRemoteButton:\n"+k)}};n.prototype.renderDeleteButton=function(d){try{var a="";if(this.dm.isEditable)var b="javascript: "+this.dm.getParentInDOM()+".deleteButtonClicked("+this.rowIndex+");return false;",
a=a+("<"+this.itemRootElemStr+' class="center">'),a=a+('<a class="btn btn15" href="#" onclick="'+b+'"><i class="remove"></i></a>'),a=a+("</"+this.itemRootElemStr+">");d.append(a)}catch(f){g.log("Problem in StaticDocumentRowView.renderDeleteButton:\n"+f)}};n.prototype.renderReferenceProperty=function(d,a){this._renderDocAttrRefPropValue(d,a,!0)};n.prototype.renderDocAttribute=function(d,a){this.dm.isInErrorStatus()||this.dm.dependsOnItself?d.append("<"+this.itemRootElemStr+"/>"):this._renderDocAttrRefPropValue(d,
a,!1)};n.prototype._renderDocAttrRefPropValue=function(d,a,b){try{var c=!1,e=a.typeDetail,i=b?this.dm.propsACatObj:this.dm.aCatObj;if(e&&i&&i.loaded){var k=i.findAttribute(e,a.attributeName);if(k&&!k.isRichText()){var l=i.findCell(k);if(l){var n=l.cellObj,v=l.row,A=l.col,z="ReadOnly"!=a.visibility,z=b?z&&this.dm.canUserEditProperties():z&&this.dm.canUserEditAttributes(),C=b?this.dm.propsACatPrefix:this.dm.aCatPrefix,e=C+"td_"+v+"_"+A,B=h("#"+e);if(1==B.length){var l='<span class="docRefInfo">',u=
j.xmlencode(f.t("DocRowAttributeInColumnInfo")+": "+a.label),l=l+('<img border="0" src="images/doc_ref_info.png" title="'+u+'"/>'),l=l+"</span>";B.removeAttr("id");B.html(l)}else 1<B.length&&alert("More than one HTML element with ID '"+e+"' on the page!");var q="<"+this.itemRootElemStr+' id="'+e+'" class="'+(b?"referencePropertyCell":"documentAttributeCell")+'">',q=q+this.renderInlineLabel(a);k.isDocReference()?k.valueHyperlink&&(q+=k.valueHyperlink.replace(/ \| /g,"<br/>")):q+=i.renderAttributeValueInternal(n,
k,v,A,a.visibility,z);q+="</"+this.itemRootElemStr+">";d.append(q);z&&k.type&&"datetime"==k.type.toLowerCase()&&i.createCalendar("#"+C+"longFormat_adate"+k.id,"#"+C+"date_period_of_day_"+k.id);c=!0}}}c||(q="<"+this.itemRootElemStr+">",q+=this.renderInlineLabel(a),i&&i.loaded?(q+='<span class="brokenDocRef">',u=j.xmlencode(b?f.t("DocRowCannotFindProperty"):f.t("DocRowCannotFindAttribute")),q+='<img border="0" src="images/warning.gif" title="'+u+'"/>',q+="</span>"):!b&&this.dm.hasNoAttrCat()&&(q+='<span class="brokenDocRef">',
u=j.xmlencode(f.t("DocRowNoAttrCategoryInfo")),q+='<img border="0" src="images/warning.gif" title="'+u+'"/>',q+="</span>"),q+="</"+this.itemRootElemStr+">",d.append(q))}catch(D){g.log("Problem in StaticDocumentRowView.renderReferenceProperty "+a.label+":\n"+D)}};n.prototype.renderDocAttrCatAndRefPropsPlaceholder=function(d){try{if(!this.renderOptions.isRepaintRow){this.dm.destroyACatObj();h("#"+this.dm.aCatRowID).remove();var a="",b=this.renderOptions.columns,a=a+('<tr id="'+this.dm.aCatRowID+'" class="hiddenElement">'),
a=a+"<td></td>",a=a+'<td class="attrCategoryColumn">';null!=g.getRenderItem(b,"ReferenceProperty")&&(a+='<div id="'+this.dm.propsACatElemID+'" class="hiddenElement"></div>');if(!this.aCatExpandDisabled||null!=g.getRenderItem(b,"DocumentAttribute"))a+='<div id="'+this.dm.aCatElemID+'"></div>';var a=a+"</td>",f=h(a+"</tr>");this.renderOptions.styleObj&&f.css(this.renderOptions.styleObj);d.after(f)}}catch(c){g.log("Problem in StaticDocumentRowView.renderDocAttrCatAndRefPropsPlaceholder:\n"+c)}};n.prototype.renderNewVersionPlaceholder=
function(d){this.renderOptions.isRepaintRow||(this._newVersionRow&&this._newVersionRow.remove(),this._newVersionRow=h('<tr id="'+this.phElemID+'_newVersionRow"></tr>'),d.after(this._newVersionRow),this._newVersionCell=h("<td colspan="+(this.renderOptions.columns?this.renderOptions.columns.length:1)+' style="padding: 0px 10px">'),this._newVersionRow.append(this._newVersionCell),this.newVersionBtn&&this.newVersionBtn.setRowContext(this._newVersionCell),this.renderOptions.styleObj&&this._newVersionRow.find("*").css(this.renderOptions.styleObj))};
n.prototype.customThumbnailHTML=function(d,a){var f="";if(!a||"0"==a)a="50";if(this.supportAdvancedThumb&&this.dm.docVerID)var c=window.webcenterConfig.jspBaseUrl+"DownloadViewerThumbnail.jsp?docversionid="+this.dm.docVerID+"&amp;pix=500&amp;ajax=1",e=this.dm.docDesc?this.dm.docDesc:"",i=window.webcenterConfig.jspBaseUrl+"viewdocument.jsp?docVerID="+this.dm.docVerID+"&amp;menu_file="+g.getMenuFileParamValue()+"&amp;sourcePage="+g.getSourcePageURLEncoded(),f=f+('<a href="'+i+'" target="_blank">')+
'<img onmouseout="delayhidethumb();"',f=f+(" onmouseover=\"showthumb(event, '"+d+"', '"+j.xmlencode(b.encodeForJScript(this.dm.docName))+"', 202, null, '"+c+"', 500);\""),f=f+(' src="'+window.webcenterConfig.jspBaseUrl+d+'"'),f=f+(' alt="'+j.xmlencode(e)+'" width="'+a+'px" height="'+a+'px" border="0" align="middle">'),f=f+"</a>";else f+='<img src="'+window.webcenterConfig.jspBaseUrl+d+'"',f+=' width="'+a+'px" height="'+a+'px" border="0" align="middle">';return f};n.prototype.renderInlineLabel=function(d){var a=
"";this.renderOptions.hideHeader&&(d&&d.label)&&(a+='<div class="docrefinlinelabel">'+g.getEncodedTranslatedLabel(d.label),"Required"==d.visibility&&(a+='&nbsp;<font color="red">*</font>'),a+="</div>");return a};n.prototype.getUploadNewVersionBtn=function(){if(!this.newVersionBtn&&this.showAdvancedDocumentActions()&&this.dm.canUserUploadNewVersion()){var d={useInlineForm:!0,alwaysUpdateAllProjects:!0,uniqueIdPrefix:g.getNextUniquePrefix()+"_"};this.newVersionBtn=new e(this.dm.docVerID,null,this.dm.parentDocTable.currentUser,
d);c.on("btnClicked.UploadNewVersion."+this.dm.docVerID,this.dm.setIsChanged.bind(this.dm));this._newVersionCell&&this.newVersionBtn.setRowContext(this._newVersionCell)}return this.newVersionBtn};n.prototype.getViewBtn=function(){this.viewBtn||(this.viewBtn=new a(this.dm.docVerID));return this.viewBtn};n.prototype.getDownloadBtn=function(){this.downloadBtn||(this.downloadBtn=new d(this.dm.docVerID));return this.downloadBtn};n.prototype.getOpen3DBtn=function(){this.open3dBtn||(this.open3dBtn=new k(this.dm.docVerID));
return this.open3dBtn};n.prototype.getOpenACADBtn=function(){this.openAcadBtn||(this.openAcadBtn=new i(this.dm.docVerID));return this.openAcadBtn};n.prototype.showAdvancedDocumentActions=function(){return!0};return n});
define("doctablex/StaticDocumentRow","doctablex/DocTableXUtils doctablex/StaticDocumentRowView doctablex/AJAXDataCache utils/webi18n!DocRefStrings wcr/ObjectArrayCloneUtil wcr/webcenter_xml jquery".split(" "),function(g,c,j,b,h,l,e){var a=function(d){if(!d)return this;this.setStatus("init");this.rowID=d.origDocRow?d.origDocRow.rowID:g.getNextUniquePrefix();if(this.parentDocTable=d.parentDocTable){this.prefix=this.getParentDocTable().getTablePrefix()+"_"+this.rowID;this.isChanged=!1;this.isEditable=
this.getParentDocTable().isEditable;"undefined"!=typeof d.isEditable&&(this.isEditable=!0===d.isEditable);this.aCatNotExpandedYet=!0;this.dependsOnItself=!1;this.renderOptions=d.renderOptions;this.renderOptions||(this.renderOptions=this.getParentDocTable().renderOptions);this.renderOptions||(this.renderOptions={});this.drID=d.drID;this.docVerID=d.docVerID;this.docID=d.docID;this.docName=d.docName;this.docDesc=d.docDesc;this.docVerIdx=d.docVerIdx;this.latestDocVerIdx=d.latestDocVerIdx;this.docRevLetter=
d.docRevLetter;this.appStatus=d.appStatus;this.thumbnailURL=d.thumbnailURL;this.docAuthor=d.docVerAuthor;this.modDate=d.modDate;this.appTypeList=d.appTypeList;this.userPerms=d.userPerms||{};this.docCheckedOutOwner=this.docType=this.docTypeID=null;this.project={id:d.projectID||null,name:d.projectID?d.projectName:null,isTemplate:d.isInTemplate||null};this.projects=d.projects||[];var b=[],e=this.renderOptions.columns;if(e)for(var f=0;f<e.length;f++){var h=e[f];if(h&&h.type&&"ReferenceProperty"==h.type){var j=
h.typeDetail,l=this.findPropertyByID(j,d.properties);l?(l.name=h.label,l.isRequired="Required"==h.visibility):l={id:j,name:h.label,isRequired:"Required"==h.visibility,value:""};b.push(l)}}this.props=b;this.propsValuesInitialized=!1;b=g.getRenderItem(this.renderOptions.columns,"AttributeFlapout");this.aCatExpandDisabled=!b;this.aCatExpanded=d.aCatExpanded||!1;this.aCatView=this.getParentDocTable().aCatView;b&&b.typeDetail&&(this.aCatView=b.typeDetail);this.aCatPrefix=this.getRowPrefix()+"_ACat_";this.aCatRowID=
this.getRowPrefix()+"_ACatRow";this.aCatElemID=this.getRowPrefix()+"_ACatPanel";this.aCatID=d.aCatID||null;this.aCatObj=null;this.renderedAttrCat={id:"",isEditable:!1};this.isExpandedAttrsEditable=!0;b&&(this.isExpandedAttrsEditable="Editable"==b.visibility);this.propsACatPrefix=this.getRowPrefix()+"_PropsACat_";this.propsACatElemID=this.getRowPrefix()+"_PropsACatID";this.propsACatID=this.getParentDocTable().propsACatID;this.propsACatObj=null;this.view=new (d.viewClass||c)(this,this.getRowPrefix(),
this.renderOptions);this.constructor==a.prototype.constructor&&this.updateDocInfoFromServer(!0);return this}alert("StaticDocumentRow cannot be initialized without parent table reference!")};a.prototype.setCustomView=function(d,a){d&&(this.view=d,this.view.dm=this,this.view.phElemID||(this.view.phElemID=this.getRowPrefix()),a&&this.displayRow())};a.prototype.setIsEditable=function(d){void 0!==d&&d!=this.isEditable&&(this.isEditable=d)};a.prototype.isInactive=function(){return this.getParentDocTable().isInactive};
a.prototype.displayRow=function(d){this.view.render();this.propsACatID&&this._prepareReferenceCategoryObj(!1);this.showDocAttributeCategory(!1,d)};a.prototype.resetDocument=function(){j.getInstance().resetDocDataByDocVerID(this.docVerID);this.dependsOnItself=!1;this.modDate=this.docDesc=this.thumbnailURL=this.docVerIdx=this.appStatus=this.docName=this.docID=this.docVerID="";this.appTypeList=[];this.userPerms={};this.project={};this.projects=[];this.docType=this.docTypeID=null;this.resetDocumentAttrCategory();
this.isChanged=!1};a.prototype.resetDocumentAttrCategory=function(){this.aCatID=null;this.aCatObj&&this.aCatObj.destroy();this.aCatObj=null};a.prototype.setIsChanged=function(){this.isChanged=!0;this.getParentDocTable()&&this.getParentDocTable().setIsChanged()};a.prototype.getIsChanged=function(){return this.isChanged};a.prototype.setStatus=function(d){this.isInErrorStatus()||(this.status=d,this.isInErrorStatus()&&(this.view.repaintRow(),this.hideDocAttributeCategory()))};a.prototype.isInErrorStatus=
function(){return"noperm"==this.status||"error"==this.status};a.prototype.getParentDocTable=function(){return this.parentDocTable};a.prototype.getIndexInTable=function(){return this.getParentDocTable()?this.getParentDocTable().docRows.indexOf(this):-1};a.prototype.getRowPrefix=function(){return this.prefix};a.prototype.getThisInDOM=function(){return this.getParentInDOM()+".getRowByID("+this.rowID+")"};a.prototype.getParentInDOM=function(){if(this.getParentDocTable())return this.getParentDocTable().getThisInDOM();
g.log("Error: Cannot find itself in parent documents table!");return"window"};a.prototype.findPropertyByID=function(d,a){a||(a=this.props);if(a)for(var b=0;b<a.length;b++){var f=a[b];if(f.id==d)return f}return null};a.prototype._updateDocInfo=function(d){var a=!1;if(d&&d.docVerID&&d.docVerID==this.docVerID){this.docID!=d.docID&&(a=!0,this.docID=d.docID);this.docName!=d.docName&&(a=!0,this.docName=d.docName);this.docDesc!=d.docDesc&&(a=!0,this.docDesc=d.docDesc);this.docVerIdx!=d.docVerIdx&&(a=!0,
this.docVerIdx=d.docVerIdx);this.latestDocVerIdx!=d.latestDocVerIdx&&(a=!0,this.latestDocVerIdx=d.latestDocVerIdx);this.docRevLetter!=d.docRevLetter&&(a=!0,this.docRevLetter=d.docRevLetter);this.appStatus!=d.appStatus&&(a=!0,this.appStatus=d.appStatus);this.thumbnailURL!=d.thumbnailURL&&(a=!0,this.thumbnailURL=d.thumbnailURL);this.docTypeID!=d.docTypeID&&(a=!0,this.docTypeID=d.docTypeID);!this.project.id&&(d.projList[0]&&this.project.id!=d.projList[0].id)&&(a=!0,this.project=d.projList[0]);d.projList&&
""+this.projects!=""+d.projList&&(a=!0,this.projects=d.projList);if(d.docVerAuthor&&(!this.docAuthor||this.docAuthor.id!=d.docVerAuthor.id))a=!0,this.docAuthor=d.docVerAuthor;if(this.modDate!=d.modDate)try{a=!0,this.modDate=d.modDate?new Date(parseInt(d.modDate)):""}catch(b){g.log("Failed to parse '"+d.modDate+"' to a Date object."),this.modDate=""}d.userPerms&&(this.userPerms=d.userPerms);d.appTypeList&&(this.appTypeList=d.appTypeList);d.docCheckedOutOwner&&(this.docCheckedOutOwner=d.docCheckedOutOwner)}else j.isEmptyValue(d)&&
this.setStatus("noperm");return a};a.prototype.updateDocInfoFromServer=function(d,a){this.setStatus("loading");if(!this.docVerID)return e.Deferred().reject("Cannot update document info from server, this.docVerID is not known!").promise();var b=j.getInstance().getDocInfoWithThumbnail(this.docVerID,a);b.done(function(a){this._updateDocInfo(a)&&d&&this.view.repaintRow()}.bind(this));b.fail(function(d){this.setStatus("error");g.log(d)}.bind(this));return b};a.prototype.isInConfigPreview=function(){return this.getParentDocTable().isInConfigPreview};
a.prototype.isRemoteDocument=function(){return this.project.id&&this.project.id!=this.getParentDocTable().projectID};a.prototype.isLatestDocVersion=function(){return this.latestDocVerIdx&&this.docVerIdx==this.latestDocVerIdx};a.prototype.hasAttrCat=function(){return!!this.aCatID&&!j.isEmptyValue(this.aCatID)&&g.isValidID(this.aCatID)};a.prototype.hasNoAttrCat=function(){return!!this.aCatID&&j.isEmptyValue(this.aCatID)};a.prototype.setDocumentHasNoAttrCategory=function(){this.aCatID=j.getEmptyValue();
this.aCatObj&&this.aCatObj.destroy();this.aCatObj=null};a.prototype.isAttrCatNeeded=function(){return g.getRenderItem(this.renderOptions.columns,"AttributeFlapout")||g.getRenderItem(this.renderOptions.columns,"DocumentAttribute")?!0:!1};a.prototype.isAttrCatUpdateNeeded=function(){return this.renderedAttrCat.id!=this.aCatID||this.renderedAttrCat.isEditable!=this.canUserEditExpandedAttributes()};a.prototype.canUserEditAttributes=function(){return!this.isInactive()&&!this.isInErrorStatus()&&this.isLatestDocVersion()&&
!this.dependsOnItself&&this.userPerms.change};a.prototype.canUserEditExpandedAttributes=function(){return this.canUserEditAttributes()&&this.isExpandedAttrsEditable};a.prototype.canUserEditProperties=function(){return!this.isInactive()&&this.isEditable&&!this.dependsOnItself};a.prototype.canUserAddDocuments=function(){return this.getParentDocTable().canUserAddDocuments};a.prototype.canUserUploadNewVersion=function(){return!this.isInactive()&&!this.isInErrorStatus()&&this.isLatestDocVersion()&&!this.dependsOnItself&&
this.isEditable&&this.userPerms.checkout};a.prototype.updateDocAttrCategoryFromServer=function(d){return!this.docVerID?null:j.getInstance().getDocAttrCatInfo(this.docVerID,d).pipe(function(d){var a=!1;d?d.id?(this.aCatID!=d.id&&(a=!0),this.aCatID=d.id):(j.isEmptyValue(this.aCatID)||(a=!0),this.setDocumentHasNoAttrCategory()):(j.isEmptyValue(this.aCatID)||(a=!0),this.setDocumentHasNoAttrCategory());return a}.bind(this),function(d){alert(d)})};a.prototype._initializeAndRenderAttrCategoryObj=function(d,
a){if(!this.getParentDocTable().parentACatNotExpandedYet&&0!=e("#"+this.aCatElemID).length)if(this.hasAttrCat()){this.setStatus("loading");var b=h.getCloneOfObject(this.getParentDocTable().currentUser);b.canEditAttributes=this.canUserEditExpandedAttributes();var f=[],c=this.getParentDocTable().parentDocVerIDs;c&&0<c.length&&(f=h.getCloneOfArray(c));f.push(this.docVerID?this.docVerID:"newID_"+g.getNextUniquePrefix());var j={};j.prefix=this.aCatPrefix;j.ACatObj=this.aCatElemID;j.ACatPanel=this.aCatElemID;
j.readURL=window.webcenterConfig.jspBaseUrl+"GetAttributeCategoryXML.jsp?categoryid="+this.aCatID+"&ajax=1";j.valuesURL=this.generateDocAttributeValuesAJAXURL();j.valuesURL||(j.valuesURL=window.webcenterConfig.jspBaseUrl+"GetAttributes.jsp?categoryid="+this.aCatID+"&ajax=1");j.currentUser=b;j.view=this.getAttCatView();j.type="document";j.projectID=this.project.id;j.documentID=this.docID;this.docVerID&&(j.docVersionID=this.docVerID);d&&(j.callbackOnRender=d);a&&(j.callbackOnFail=a);j.docTableParentDocVerIDs=
f;j.isInactive=this.isInactive();j.aCatNotExpandedYet=this.aCatNotExpandedYet;this.renderOptions.styleObj&&(j.defaultStyleObject=this.renderOptions.styleObj.inlineStyleObject);require(["attributecategory/AttributeCategory"],function(d){this.aCatObj=new d(j);this.aCatObj.valueChangedListeners.push(function(){this.setIsChanged()}.bind(this))}.bind(this));this.renderedAttrCat.id=this.aCatID;this.renderedAttrCat.isEditable=b.canEditAttributes}else g.log("Attempt to render attribute category when its ID is not known!")};
a.prototype._initializeAndRenderReferenceCategoryObj=function(d,a){if(!this.getParentDocTable().parentACatNotExpandedYet&&0!=e("#"+this.propsACatElemID).length)if(this.propsACatID){this.setStatus("loading");this.propsValuesInitialized=!1;var b=h.getCloneOfObject(this.currentUser);b.canEditAttributes=this.canUserEditProperties();var f={};f.prefix=this.propsACatPrefix;f.ACatObj=this.propsACatElemID;f.ACatPanel=this.propsACatElemID;f.readURL=window.webcenterConfig.jspBaseUrl+"GetAttributeCategoryXML.jsp?categoryid="+
this.propsACatID+"&ajax=1";f.valuesURL=window.webcenterConfig.jspBaseUrl+"GetAttributes.jsp?categoryid="+this.propsACatID+"&ajax=1";f.currentUser=b;d&&(f.callbackOnRender=d);a&&(f.callbackOnFail=a);require(["attributecategory/AttributeCategory"],function(d){this.propsACatObj=new d(f);this.propsACatObj.valueChangedListeners.push(function(){this.setIsChanged()}.bind(this))}.bind(this))}else g.log("Attempt to initialize reference properties when reference category ID is not known!")};a.prototype.generateDocAttributeValuesAJAXURL=
function(){var d=null;this.docVerID&&(d=window.webcenterConfig.jspBaseUrl+"GetAttributes.jsp?docverid="+this.docVerID);return d};a.prototype.showDocAttributeCategory=function(d,a){this.aCatExpandDisabled&&(a=!1);if(this.docVerID&&!this.aCatID){var b=this.updateDocAttrCategoryFromServer();b&&(b.done(function(b){this._showDocAttributeCategory(d||b,a)}.bind(this)),b.fail(function(){this.hideDocAttributeCategory()}.bind(this)))}else this.hasAttrCat()?this._showDocAttributeCategory(d,a):this.hideDocAttributeCategory()};
a.prototype.getExpColButton=function(){return e("#"+this.getRowPrefix()+" > "+this.view.itemRootElemStr+" > a.expandCollapseButton > i")};a.prototype._expandDocAttrCat=function(d){d||(d=this.getExpColButton());this.dependsOnItself?d.removeClass("expand").addClass("cycle").attr("title",l.xmlencode(b.t("DocRowCyclicDepTooltip"))):d.removeClass("expand cycle").addClass("collapse").attr("title",l.xmlencode(b.t("DocRowCollapseTooltip")));e("#"+this.aCatRowID).removeClass("hiddenElement");this.aCatExpanded=
!0;this.aCatNotExpandedYet&&this.setACatIsExpanded()};a.prototype.setACatIsExpanded=function(){this.aCatNotExpandedYet=!1;this.aCatObj&&this.aCatObj.setACatIsExpanded();this.displayRow()};a.prototype._collapseDocAttrCat=function(d){d||(d=this.getExpColButton());this.dependsOnItself?d.removeClass("collapse").addClass("cycle").attr("title",l.xmlencode(b.t("DocRowCyclicDepTooltip"))):d.removeClass("collapse cycle").addClass("expand").attr("title",l.xmlencode(b.t("DocRowExpandTooltip")));e("#"+this.aCatRowID).addClass("hiddenElement");
this.aCatExpanded=!1};a.prototype._showDocAttributeCategory=function(d,a){if(d||this.isAttrCatUpdateNeeded())this.aCatObj&&this.aCatObj.destroy(),this.aCatObj=null;if(!this.hasAttrCat()||!this.isAttrCatNeeded())this.hideDocAttributeCategory();else{var b=this.getExpColButton();b.parent().removeClass("hiddenElement");if(this.dependsOnItself)this._collapseDocAttrCat(b);else if(a||this.aCatExpanded?this._expandDocAttrCat(b):this._collapseDocAttrCat(b),b=null!=g.getRenderItem(this.renderOptions.columns,
"DocumentAttribute"),!this.aCatNotExpandedYet||b)if(this.aCatObj){var b=!1,f=e("#"+this.aCatElemID);1==f.length&&f[0].ACatObj!=this.aCatObj&&(f[0].ACatObj=this.aCatObj,b=!0);b&&(this.aCatObj.isInactive=this.isInactive(),this.aCatObj.displayAttributeCategory())}else this._initializeAndRenderAttrCategoryObj(this._onAttrCategoryReady.bind(this,!1),this._onAttrCategoryLoadFailed.bind(this))}};a.prototype._prepareReferenceCategoryObj=function(d){this.propsACatID?(d&&(this.propsACatObj&&this.propsACatObj.destroy(),
this.propsACatObj=null),this.propsACatObj?(d=e("#"+this.propsACatElemID),1==d.length&&d[0].ACatObj!=this.propsACatObj&&(d[0].ACatObj=this.propsACatObj)):this._initializeAndRenderReferenceCategoryObj(this._onAttrCategoryReady.bind(this,!0),this._onAttrCategoryLoadFailed.bind(this))):g.log("StaticDocumentRow._prepareReferenceCategoryObj() called when no reference category ID known (or it was nullified)")};a.prototype._onAttrCategoryReady=function(d){if(d&&this.propsACatObj&&this.propsACatObj.loaded){if(!this.propsValuesInitialized){for(d=
0;d<this.props.length;d++){var a=this.props[d];if(a&&a.id){var b=this.propsACatObj.findAttribute(a.id,a.name);b&&b.copyValueFrom(a)}}this.propsValuesInitialized=!0}this.propsACatObj.destroy();e("#"+this.propsACatElemID).html("")}this.setStatus("ready");this.view.repaintRow()};a.prototype._onAttrCategoryLoadFailed=function(){this.setStatus("error");g.log("Failed to load attribute category.")};a.prototype.hideDocAttributeCategory=function(){var d=this.getExpColButton();this._collapseDocAttrCat(d);this.hasAttrCat()||
(d.parent().addClass("hiddenElement"),d=e("#"+this.aCatElemID),d.ACatObj&&d.ACatObj.destroy(),d.ACatObj=null,d.html(""))};a.prototype.collapseAllDescendants=function(){this.aCatObj&&this.aCatObj.executeOnAllDocReferences(function(d){d.collapseAllRows()},this);this._collapseDocAttrCat()};a.prototype.deleteItself=function(d){this.destroy();d?e("#"+this.view.phElemID).empty():e("#"+this.view.phElemID).remove();e("#"+this.aCatRowID).remove();this.view._newVersionRow.remove()};a.prototype.swapWith=function(d){this.aCatObj&&
this.aCatObj.beforeMove();e("#"+this.view.phElemID).insertAfter(e("#"+d.aCatRowID));this.view._newVersionRow?(this.view._newVersionRow.insertAfter(e("#"+this.view.phElemID)),e("#"+this.aCatRowID).insertAfter(this.view._newVersionRow)):e("#"+this.aCatRowID).insertAfter(e("#"+this.view.phElemID));this.view.repaintRow();d.view.repaintRow();this.aCatObj&&this.aCatObj.afterMove()};a.prototype.setDependsOnItself=function(d){this.dependsOnItself=!0==d};a.prototype.convertRefPropertiesToXML=function(){var d=
"";try{if(this.props&&0<this.props.length){for(var d=d+"<refatts>",a=0;a<this.props.length;a++){var b=this.props[a];b&&b.id&&(d+="<att>",d+=l.ElementEncode("id",b.id),d+="</att>")}d+="</refatts>";d+=l.ElementEncode("refprefix",this.propsACatPrefix)}}catch(f){g.log("Problem in StaticDocumentRow.convertRefPropertiesToXML:\n"+f),d=""}return d};a.prototype.convertUploadNewVersionToXML=function(){var a="";if(this.view.newVersionBtn&&this.view.newVersionBtn.isExpanded&&this.view._newVersionCell){var b=
this.view._newVersionCell,a=a+"<ds>"+l.ElementEncode("action","UploadNewVersion"),a=a+l.ElementEncode("file_form_field","newVersionDocFile_"+this.docVerID),a=a+l.ElementEncode("version_comment",b.find("input[name=newVersionDocDesc_"+this.docVerID+"]").val()),a=a+l.ElementEncode("raise_revision","checked"==b.find("input[name=incrementRevision_"+this.docVerID+"]").attr("checked")?"1":"0");0<e("input[name=AppCycleFlag"+this.docVerID+"]").length?(a+=l.ElementEncode("start_approval","checked"==b.find("input[name=AppCycleFlag"+
this.docVerID+"]").attr("checked")?"1":"0"),a+=l.ElementEncode("approval_due_date",b.find("input[name=due_date"+this.docVerID+"]").val()),a+=l.ElementEncode("approval_due_period",b.find("select[name=due_periodOfDay"+this.docVerID+"]").val())):a+=l.ElementEncode("start_approval",b.find("input[name=startApprovalDefaultValue"+this.docVerID+"]").val());a+="</ds>"}return a};a.prototype.convertToXML=function(a){var b="";try{b+="<dr>",this.drID&&(b+=l.ElementEncode("id",this.drID)),a&&0<a.length&&(b+=a),
this.docVerID&&(b+=l.ElementEncode("dv",this.docVerID),this.docVerIdx&&(b+=l.ElementEncode("dvidx",this.docVerIdx)),this.docID&&(b+=l.ElementEncode("doc_id",this.docID)),this.docName&&(b+=l.ElementEncode("dn",this.docName))),this.appStatus&&this.appStatus.cycleStatus&&(b+=l.ElementEncode("astat",this.appStatus.cycleStatus)),this.isEditable&&(b+=this.convertUploadNewVersionToXML(),b+=this.convertRefPropertiesToXML()),this.isInErrorStatus()||(b+=l.ElementEncode("daprefix",this.aCatPrefix)),b+="</dr>"}catch(c){g.log("Problem in StaticDocumentRow.convertToXML:\n"+
c),b=""}return b};a.prototype.validateDocRow=function(a,c){var i=!0;if(this.isInactive())return i;if(this.aCatObj&&this.aCatObj.loaded){var f=[];if(this.canUserEditAttributes()&&!a.isTemplate){var g=this.renderOptions.columns;if(g)for(var h=0;h<g.length;h++){var j=g[h];if(j&&j.type&&"DocumentAttribute"==j.type){var l=j.typeDetail;f.push(l);if("Required"==j.visibility&&(j=this.aCatObj.findAttribute(l,j.attributeName))&&!j.value)i={level:c,attrLabel:this.aCatObj.getAttributeLabel(j),element:e("#"+this.aCatObj.prefix+
j.id).closest("td").find("*"),docRowObj:this},a.errors.push(i),i=!1}}}this.aCatObj.validateAttributes(!1,a,f,this,c+1)||(i=!1)}if(this.canUserEditProperties()&&!a.isTemplate&&this.props&&this.propsACatObj&&this.propsACatObj.loaded)for(h=0;h<this.props.length;h++)if((f=this.props[h])&&f.id&&f.isRequired)if((g=this.propsACatObj.findAttribute(f.id,f.name))&&!g.value)i={level:c,msg:b.t("DocRowPropertyRequiredButNull",f.name),element:e("#"+this.propsACatObj.prefix+g.id).closest("td").find("*"),docRowObj:this},
a.errors.push(i),i=!1;if(this.view.newVersionBtn&&(f=this.view.newVersionBtn.validate())&&0<f.length){for(h=0;h<f.length;h++)i=f[h],i.level=c,i.docRowObj=this,a.errors.push(i);i=!1}return i};a.prototype.expandBranchTillThis=function(a){for(var b=this.getRowPrefix().split("_"),c=1,f=0,g="";f+2<b.length&&c<a;){var h=b[f]+"_"+b[++f],j=g+h+"_docTable",l=b[++f],j=e("#"+j);if(1==j.length&&(j=j[0].docTable))(j=j.getRowByID(l))&&j.showDocAttributeCategory(!1,!0);g+=h+"_"+l+"_ACat_";f+=2;c++}};a.prototype._onSubmit=
function(){this.aCatObj&&!this.isInactive()&&this.aCatObj.convertDocReferencesToXML()};a.prototype.expandClicked=function(a){a&&(a=e(a).find("i"),a.hasClass("cycle")||(a.hasClass("expand")?this.showDocAttributeCategory(!1,!0):this.hideDocAttributeCategory()))};a.prototype.destroy=function(){this.destroyACatObj()};a.prototype.destroyACatObj=function(){this.aCatObj&&this.aCatObj.destroy()};a.prototype.reconstruct=function(){this.aCatObj&&this.aCatObj.reconstruct()};a.prototype.getAttCatView=function(){return this.aCatView||
"Default"};return a});
define("doctablex/DocumentRowView",["doctablex/StaticDocumentRowView","doctablex/DocTableXUtils","utils/webi18n!DocRefStrings","wcr/webcenter_xml"],function(g,c,j,b){var h=function(b,c,a){if(!b&&!c&&!a)return this;g.call(this,b,c,a);return this};h.prototype=new g;h.prototype.constructor=h;h.prototype.parent=g.prototype;h.prototype.renderDocTemplateSelector=function(){var g="";try{var e=this.dm.docTemplates;if(!e||0==e.length)return g;if("FixedDocTemplate"==this.dm.docTempType)g+="<span>"+b.xmlencode(j.t("PROJ_CREATION_DOCUMENT_TEMPLATE"))+
":&nbsp;</span>",g+="<span>"+b.xmlencode(e[0].name)+"</span>";else{g='<select class="form-control form-field-medium form-dropdown-field" onChange="'+("javascript: "+this.dm.getThisInDOM()+".docTemplateSelected(this.value);")+'">';g+='<option value="-1"'+(!this.dm.selDocTemplate?' selected="selected"':"")+">"+b.xmlencode(j.t("SELECTDOCTEMPLATE"))+"...</option>";if(e)for(var a=0;a<e.length;a++)var d=e[a],g=g+('<option value="'+a+'"'+(this.dm.selDocTemplate==d?' selected="selected"':"")+">"+b.xmlencode(d.name)+
"</option>");g+="</select>"}}catch(k){c.log("Problem in DocumentRowView.renderDocTemplateSelector:\n"+k),g=""}return g};h.prototype.renderDocFolderSelector=function(){var g="";try{var e=this.dm.targetFolders;if(!e||0==e.length)return g;if(1==e.length){var a=e[0].name;"0"==e[0].id&&(a=j.t("DEFAULT_FOLDER_ROOT"));g+="<label>"+b.xmlencode(j.t("FOLDER"))+":&nbsp;"+b.xmlencode(a)+"</label>"}else{var g='<select class="form-control form-field-medium form-dropdown-field" onChange="'+("javascript: "+this.dm.getThisInDOM()+
".targetFolderSelected(this.value);")+'">',d=e[0].id;this.dm.selTargetFolder&&(d=this.dm.selTargetFolder.id);a=!1;this.dm.selDocTemplate&&(this.dm.selTargetFolder.isDefaultFromDocTempl&&(a=!0),g+='<option value="-1"'+(a?' selected="selected"':"")+">",g+=b.xmlencode(j.t("DEFAULT_FOLDER_TEMPLATE")),g+="</option>");for(var k=0;k<e.length;k++)var i=e[k],g=g+('<option value="'+k+'"'+(d==i.id&&!a?' selected="selected"':"")+">"),g="0"==i.id?g+b.xmlencode(j.t("DEFAULT_FOLDER_ROOT")):g+b.xmlencode(i.name),
g=g+"</option>";g+="</select>"}}catch(f){c.log("Problem in DocumentRowView.renderDocFolderSelector:\n"+f),g=""}return g};h.prototype.showAdvancedDocumentActions=function(){return!1};return h});
define("utils/EventBasedValidator",["utils/webi18n!validatorStrings","jquery","utils/WCEvent"],function(g,c,j){return{getInstance:function(){window.eventBasedValidator||(window.eventBasedValidator={onValidateUniqueDocName:function(b){j.on("validation.uniqueDocName",b)},createUniqueNamesObj:function(){return{errors:[],newDocs:[],newDocsDOMElems:{},excludedProjects:{},localClashFound:!1,addDoc:function(b,c){if(b.val()){var j=b.val().toLowerCase();this.newDocsDOMElems[c+"_"+j]?(this.newDocsDOMElems[c+
"_"+j].push(b[0]),this.localClashFound||(j={msg:g.t("PROJ_CREATION_SPECIFY_UNIQUE_DOCNAMES"),element:this.newDocsDOMElems[this.projectID+"_"+j],docRowObj:this},this.errors.splice(0,0,j),this.localClashFound=!0)):(this.newDocsDOMElems[c+"_"+j]=b,c&&!this.excludedProjects[c]&&this.newDocs.push({docName:j,projectId:c}))}},excludeProject:function(b){this.excludedProjects[b]=!0},isOk:function(){return 0==this.errors.length}}},validateNamesGlobally:function(b){b||(b=this.createUniqueNamesObj());j.emit("validation.uniqueDocName",
b);0<b.newDocs.length&&c.ajax({url:"GetDocumentsByNameAndProjectID.jsp",dataType:"json",method:"POST",async:!1,data:{data:JSON.stringify({docs:b.newDocs})}}).done(function(a){if(a.docs&&0<a.docs.length)for(var d=0;d<a.docs.length;d++){var c={msg:g.t("NAMECONFLICTEXCEPTION_ADV_TAG",a.docs[d].docName,a.docs[d].projectName),element:b.newDocsDOMElems[a.docs[d].projectId+"_"+a.docs[d].docName.toLowerCase()]};b.errors.push(c)}});for(var h="",l=0;l<b.errors.length;l++){var e=b.errors[l];e.msg&&(h+=e.msg+
"\n");e.element&&e.element.addClass("validationHighlight")}h&&alert(h)}});return window.eventBasedValidator}}});
define("doctablex/DocumentRow","doctablex/StaticDocumentRow doctablex/DocumentRowView doctablex/DocTableXUtils wcr/webcenter_xml utils/EventBasedValidator utils/webi18n!DocRefStrings underscore".split(" "),function(g,c,j,b,h,l,e){var a=function(b){if(!b)return this;b.viewClass||(b.viewClass=c);g.call(this,b);this.docOperation=b.operation||null;this.useDocTypeDefaultACat=!1;this.origDocRow=b.origDocRow||null;this.docVerIdx="1";this.docRevLetter="";this.latestDocVerIdx="1";this.fieldsModByUser=[];this.docNameSuffix=
null;this.anPrefix=b.anPrefix||null;this.anSuffix=b.anSuffix||null;this.anCounterLength=b.anCounterLength||0;this.docTempType=b.docTempType;this.docTempType||(this.docTempType="AnyDocTemplate");this.docTempNames=b.docTempNames||"";this.selDocTemplate=this.docTemplates=null;this.targetFolderName=b.targetFolderName||"";this.selTargetFolder=this.targetFolders=null;this.constructor==a.prototype.constructor&&this.setStatus("ready");h.getInstance().onValidateUniqueDocName(e.bind(function(a){this.validateDocRowUniqueName(a)},
this));return this};a.prototype=new g;a.prototype.constructor=a;a.prototype.parent=g.prototype;a.prototype.resetDocument=function(b){this.anSuffix=this.anPrefix=null;this.anCounterLength=0;b&&(a.prototype.parent.resetDocument.call(this),this.fieldsModByUser=[])};a.prototype.canUserEditAttributes=function(){var a=this.selTargetFolder?this.selTargetFolder.changePropPerm:!1;return this.isEditable&&!this.isInErrorStatus()&&this.isLatestDocVersion()&&a};a.prototype.generateDocAttributeValuesAJAXURL=function(){var a=
window.webcenterConfig.jspBaseUrl;this.selDocTemplate&&this.selDocTemplate.docVerID&&j.isValidID(this.selDocTemplate.categoryID)?(a=a+"GetAttributes.jsp?doctemplate=1"+("&projectid="+this.project.id),a+="&documentid="+this.selDocTemplate.id,a+="&docverid="+this.selDocTemplate.docVerID,a+="&categoryid="+this.selDocTemplate.categoryID):j.isValidID(this.aCatID)?a+="GetAttributes.jsp?categoryid="+this.aCatID:j.log("Cannot generate URL in DocumentRowNew.generateDocAttributeValuesAJAXURL().");return a};
a.prototype.isModifiedByUser=function(a){return-1<this.fieldsModByUser.indexOf(a)};a.prototype.setFieldModByUser=function(a,b){if(b){var c=this.fieldsModByUser.indexOf(a);-1<c&&this.fieldsModByUser.splice(c,1)}else this.fieldsModByUser.push(a)};a.prototype.isAutonamingEnabled=function(){return this.anPrefix&&0<this.anPrefix.length};a.prototype.hasAutonameSuffix=function(){return this.anSuffix&&-1<this.anSuffix.toLowerCase().indexOf("[editfield]")};a.prototype.updateDocumentType=function(a,b){var c=
a.docTypeList;if(c&&this.docTypeID)for(var f=0;f<c.length;f++){var e=c[f];if(this.docTypeID==e.id){this.docType=e;this.anPrefix=e.anPrefix;this.anSuffix=e.anSuffix;this.anCounterLength=e.anCounterLength;this.selDocTemplate&&(this.aCatID=this.selDocTemplate.categoryID);!this.hasAttrCat()&&this.useDocTypeDefaultACat&&(this.aCatID=this.docType.categoryID);b&&(this.view.repaintRow(),this.showDocAttributeCategory(!1,!0));break}}};a.prototype.updateDocTemplates=function(a){this.docTemplates=[];if(a&&!(0==
a.length||this.isInConfigPreview()))if(!this.docTempType||"AnyDocTemplate"==this.docTempType)this.docTemplates=a;else if("NoDocTemplate"!=this.docTempType)if("FixedDocTemplate"==this.docTempType){var b=this.docTempNames[0];if(b){for(var c=0;c<a.length;c++){var f=a[c];if(f&&f.name&&f.name.toLowerCase()==b){this.docTemplates.push(f);break}}1==this.docTemplates.length&&this.updateDocTemplateSelection(0)}}else if("ListDocTemplate"==this.docTempType)for(c=0;c<a.length;c++)(f=a[c])&&(f.name&&0<=this.docTempNames.indexOf(f.name.toLowerCase()))&&
this.docTemplates.push(f)};a.prototype.preselectDocTemplate=function(){if(!this.docTempType||!("NoDocTemplate"==this.docTempType||"FixedDocTemplate"==this.docTempType)){var a=this.origFileExt;a||(a=this.fileExt);a=this._matchDocTemplate("default."+a);0>a&&(a=this._matchDocTemplate("default"));this.updateDocTemplateSelection(a)}};a.prototype._matchDocTemplate=function(a){if(this.docTemplates)for(var b=0;b<this.docTemplates.length;b++)if(this.docTemplates[b].name.toLowerCase()==a)return b;return-1};
a.prototype.updateDocTemplateSelection=function(a){var b=this.aCatID;-1==a?(this.selDocTemplate=null,this.docType&&this.useDocTypeDefaultACat&&(this.aCatID=this.docType.categoryID)):this.docTemplates&&(0<=a&&a<this.docTemplates.length)&&(this.selDocTemplate=a=this.docTemplates[a],this.aCatID=a.categoryID,!this.hasAttrCat()&&(this.docType&&this.useDocTypeDefaultACat)&&(this.aCatID=this.docType.categoryID));this.aCatID!=b&&(this.aCatObj&&this.aCatObj.destroy(),this.aCatObj=null);this.preselectTargetFolder()};
a.prototype.updateTargetFolders=function(a){a&&0<a.length&&!this.isInConfigPreview()?this.targetFolders=a:(this.targetFolders=[],this.selTargetFolder=null)};a.prototype.preselectTargetFolder=function(){if(!this.targetFolders||0==this.targetFolders.length)this.selTargetFolder=null;else if(!this.isModifiedByUser("targetFolder")){var a=this._findTargetFolderByName(this.targetFolderName);this.setSelectedTargetFolder(a,!a)}};a.prototype._findTargetFolderByName=function(a){if(this.targetFolders&&a)for(var a=
a.toLowerCase(),b=0;b<this.targetFolders.length;b++){var c=this.targetFolders[b];if(c&&c.name.toLowerCase()==a)return c}return null};a.prototype.setSelectedTargetFolder=function(a,b){this.selTargetFolder&&(this.selTargetFolder.isDefaultFromDocTempl=!1);if(!this.targetFolders||0==this.targetFolders.length)this.selTargetFolder=null;else{if(b){if(this.selDocTemplate&&(this.selTargetFolder=this._findTargetFolderByName(this.selDocTemplate.folderName)))this.selTargetFolder.isDefaultFromDocTempl=!0}else this.selTargetFolder=
a;this.selTargetFolder||(this.selTargetFolder=this.targetFolders[0],b&&(this.selTargetFolder.isDefaultFromDocTempl=!0))}};a.prototype.convertToXML=function(a){var c="";try{if(this.isInErrorStatus())return c;c+="<dr>";this.origDocRow?(this.origDocRow.drID&&(c+=b.ElementEncode("id",this.origDocRow.drID)),this.origDocRow.docVerID&&(c+=b.ElementEncode("dv",this.origDocRow.docVerID))):this.drID&&(c+=b.ElementEncode("id",this.drID));a&&0<a.length&&(c+=a);c+=this.convertRefPropertiesToXML();this.canUserEditAttributes()&&
(c+=b.ElementEncode("daprefix",this.aCatPrefix));c+="</dr>"}catch(e){j.log("Problem in StaticDocumentRow.convertToXML:\n"+e),c=""}return c};a.prototype.validateDocRow=function(b,c){var e=!0,f=$("#"+this.getRowPrefix()+" div.DocumentNameRow > input:first");1==f.length&&(!f.val()&&!this.isAutonamingEnabled())&&(e={isBlocking:!0,level:c,msg:l.t("DocRowDocNameRequired"),element:f,docRowObj:this},b.errors.push(e),e=!1);a.prototype.parent.validateDocRow.call(this,b,c)||(e=!1);return e};a.prototype.validateDocRowUniqueName=
function(a){if(!this.isAutonamingEnabled()&&this.isEditable&&!this.isInactive()){var b=$("#"+this.getRowPrefix()+" div.DocumentNameRow > input:first");a.addDoc(b,this.project.id)}};a.prototype.docNameChanged=function(a){this.docName!=a&&(this.docName=a,this.setIsChanged(),this.setFieldModByUser("docName",!a))};a.prototype.docNameSuffixChanged=function(a){this.docNameSuffix!=a&&(this.docNameSuffix=a,this.setIsChanged(),this.setFieldModByUser("docNameSuffix",!a))};a.prototype.docDescChanged=function(a){this.docDesc!=
a&&(this.docDesc=a,this.setIsChanged(),this.setFieldModByUser("docDescription",!a))};a.prototype.docTemplateSelected=function(a){this.setIsChanged();this.setFieldModByUser("docTemplate",-1==a);this.resetDocumentAttrCategory();this.updateDocTemplateSelection(a);this.view.repaintRow();this.showDocAttributeCategory(!1,!0)};a.prototype.targetFolderSelected=function(a){this.setIsChanged();this.setFieldModByUser("targetFolder",-1==a);-1==a?this.setSelectedTargetFolder(null,!0):this.setSelectedTargetFolder(this.targetFolders[a]);
this.showDocAttributeCategory(!1,!1)};return a});
define("doctablex/DocumentRowSearchView",["doctablex/DocumentRowView","doctablex/DocTableXUtils","utils/webi18n!DocRefStrings","wcr/webcenter_xml"],function(g,c,j,b){var h=function(b,c,a){if(!b&&!c&&!a)return this;g.call(this,b,c,a);return this};h.prototype=new g;h.prototype.constructor=h;h.prototype.parent=g.prototype;h.prototype.renderDocumentSpec=function(g){try{var e="",a="Copy"==this.dm.docOperation,d="Move"==this.dm.docOperation,h="Link"==this.dm.docOperation,e=e+("<"+this.itemRootElemStr+">"),
e=e+'<div class="form-docref">',e=this.dm.origDocRow?e+('<span class="form-label">'+b.xmlencode(j.t("DocRowLocalRemoteMakeLocal"))+":</span>"):e+('<span class="form-label">'+b.xmlencode(this.dm.dlsName)+" ("+b.xmlencode(this.dm.docOperation)+"):</span>"),e=e+('<span class="form-inline-field">'+b.xmlencode(this.dm.selDocName)+"</span>"),e=e+'<div class="DocumentNameRow">';if(a||d)if(this.dm.isAutonamingEnabled())if(this.dm.hasAutonameSuffix())var i="javascript: "+this.dm.getThisInDOM()+".docNameSuffixChanged(this.value);",
f=this.dm.docNameSuffix?this.dm.docNameSuffix:"",e=e+('<input type="text" class="form-control form-field-medium" placeholder="'+b.xmlencode(j.t("DocRowDocumentSuffix"))),e=e+('" maxlength="250" size="40" onchange="'+i+'" value="'+b.xmlencode(f)+'"/>');else e+='<input type="text" class="form-control form-field-medium" placeholder="'+b.xmlencode(j.t("DocRowDocumentName")),e+='" maxlength="250" size="40" disabled="disabled"/>';else var n=this.dm.docName?this.dm.docName:"",m="javascript: "+this.dm.getThisInDOM()+
".docNameChanged(this.value);",e=e+('<input type="text" class="form-control form-field-medium" placeholder="'+b.xmlencode(j.t("DocRowDocumentName"))),e=e+('" maxlength="250" size="40" onchange="'+m+'" value="'+b.xmlencode(n)+'"/>');var p="javascript: "+this.dm.getThisInDOM()+".docDescChanged(this.value);",o=this.dm.docDesc?this.dm.docDesc:"";a?e+='<input type="text" class="form-control form-field-medium" placeholder="'+b.xmlencode(j.t("DocRowDocumentDescription"))+'" maxlength="250" size="40" onchange="'+
p+'" value="'+b.xmlencode(o)+'"/>':0<o.length&&(d||(e+='<div class="DocumentDescriptionRow">'),e+="<span>"+b.xmlencode(j.t("DocRowDocumentDescription"))+":</span>",e+='<span class="form-inline-field-indent">'+b.xmlencode(o)+"</span>",d||(e+="</div>"));e+="</div>";if(a||d||h)e+='<div id="'+(this.phElemID+"_docTempFolderSelPHID")+'" class=DocumentTemplateAndFolderRow">',a&&(e+=this.renderDocTemplateSelector()),e+=this.renderDocFolderSelector(),e+="</div>";e+="</div>";e+="</"+this.itemRootElemStr+">";
g.append(e)}catch(r){c.log("Problem in DocumentRowSearchView.renderDocumentSpec:\n"+r)}};h.prototype.renderLocalRemoteButton=function(g){try{var e="",e=e+("<"+this.itemRootElemStr+' class="center">');if(this.dm.origDocRow)var a="javascript: "+this.dm.getParentInDOM()+".localRemoteButtonClicked("+this.rowIndex+");",d=b.xmlencode(j.t("DocRowLocalRemoteResetButtonTooltip")),e=e+('<img border="0" src="'+window.webcenterConfig.jspBaseUrl+'images/round_button_reset.png"'),e=e+(' title="'+d+'" onclick="'+
a+'"/>');e+="</"+this.itemRootElemStr+">";g.append(e)}catch(h){c.log("Problem in StaticDocumentRowView.renderLocalRemoteButton:\n"+h)}};return h});
define("doctablex/DocumentRowSearch","doctablex/DocumentRow doctablex/DocTableXUtils doctablex/DocumentRowSearchView doctablex/AJAXDataCache wcr/webcenter_xml jquery".split(" "),function(g,c,j,b,h,l){var e=function(a){if(!a)return this;a.viewClass||(a.viewClass=j);g.call(this,a);this.dlsName=a.dlsName||"Search";this.docOperation||(this.docOperation="Copy");if(!this.project||!this.project.id)this.project={id:this.getParentDocTable().projectID};this.fileExt=c.getFileExtension(this.docName,!0);this.selDocName=
this.docName;this.hasOrigDocACat=!1;this.constructor==e.prototype.constructor&&this._initializeFromServer();return this};e.prototype=new g;e.prototype.constructor=e;e.prototype.parent=g.prototype;e.prototype._initializeFromServer=function(){this.setStatus("loading");var a=this.updateDocInfoFromServer(!1);a.done(function(){this.docDesc="";"Copy"==this.docOperation&&(this.docVerIdx="1",this.docRevLetter="");var a=b.getInstance().getEffectiveDocTypesSettingsByProjID(this.project.id),c=null,e=null;"Copy"==
this.docOperation&&(c=b.getInstance().getDocTemplatesByProjID(this.project.id));var f=null;"Reference"!=this.docOperation&&(f=b.getInstance().getFoldersByProjID(this.project.id));e=this.updateDocAttrCategoryFromServer();l.when(a,c,f,e).done(function(a,b,d){this.useDocTypeDefaultACat=this.hasNoAttrCat()&&"Copy"==this.docOperation;this.hasOrigDocACat=this.hasAttrCat();this.updateDocumentType(a,!1);b&&(this.updateDocTemplates(b),this.preselectDocTemplate());this.updateTargetFolders(d);this.preselectTargetFolder();
this.setStatus("ready");this.view.repaintRow();this.showDocAttributeCategory(!0,!0)}.bind(this)).fail(function(a){this.setStatus("error");alert("Failed to load document configuration from the server.\n"+a)}.bind(this))}.bind(this));a.fail(function(a){this.setStatus("error");c.log("Failed to process basic info about document loaded from the server.\n"+a)}.bind(this))};e.prototype.isAutonamingEnabled=function(){return this.anPrefix&&0<this.anPrefix.length&&"Copy"==this.docOperation};e.prototype.canUserEditAttributes=
function(){var a=!1,a=this.userPerms?this.userPerms.change:!1,b=this.selTargetFolder?this.selTargetFolder.changePropPerm:!1,a="Reference"==this.docOperation?a:"Link"==this.docOperation?a||b:b;return this.isEditable&&!this.isInErrorStatus()&&this.isLatestDocVersion()&&!this.dependsOnItself&&a};e.prototype.generateDocAttributeValuesAJAXURL=function(){var a=window.webcenterConfig.jspBaseUrl;this.selDocTemplate&&this.selDocTemplate.docVerID&&c.isValidID(this.selDocTemplate.categoryID)?(a=a+"GetAttributes.jsp?doctemplate=1"+
("&projectid="+this.project.id),a+="&documentid="+this.selDocTemplate.id,a+="&docverid="+this.selDocTemplate.docVerID,a+="&categoryid="+this.selDocTemplate.categoryID):this.hasOrigDocACat&&this.docVerID?a+="GetAttributes.jsp?docverid="+this.docVerID:c.isValidID(this.aCatID)?a+="GetAttributes.jsp?categoryid="+this.aCatID:c.log("Cannot generate URL in DocumentRowSearch.generateDocAttributeValuesAJAXURL().");return a};e.prototype.convertToXML=function(){var a="";try{if(this.isInErrorStatus())return a;
var b="<ds>",b=b+h.ElementEncode("action",this.docOperation);this.docVerID&&(b+=h.ElementEncode("source_dv_id",this.docVerID));this.project.id&&(b+=h.ElementEncode("project_id",this.project.id));this.selTargetFolder&&(b+=h.ElementEncode("target_folder_name",this.selTargetFolder.name));this.isAutonamingEnabled()?b+=h.ElementEncode("doc_name_suffix",this.docNameSuffix?this.docNameSuffix:""):this.docName&&(b+=h.ElementEncode("doc_name",this.docName));this.docDesc&&(b+=h.ElementEncode("doc_description",
this.docDesc));this.hasAttrCat()&&(b+=h.ElementEncode("doc_attr_cat_id",this.aCatID));this.selDocTemplate&&(b+=h.ElementEncode("doc_temp_id",this.selDocTemplate.id),b+=h.ElementEncode("doc_temp_folder_name",this.selDocTemplate.folderName));a=e.prototype.parent.convertToXML.call(this,b+"</ds>")}catch(g){c.log("Problem in DocumentRowSearch.convertToXML:\n"+g),a=""}return a};e.prototype.getAttCatView=function(){var a=!1,b=c.getRenderItem(this.renderOptions.columns,"AttributeFlapout");b&&!1===b.useCreationView&&
(a=!0);return!a&&"Copy"==this.docOperation?"Creation":this.aCatView||"Default"};return e});
define("doctablex/DocumentRowBrowseView",["doctablex/DocumentRowView","doctablex/DocTableXUtils","utils/webi18n!DocRefStrings","wcr/webcenter_xml"],function(g,c,j,b){var h=function(b,c,a){if(!b&&!c&&!a)return this;g.call(this,b,c,a);return this};h.prototype=new g;h.prototype.constructor=h;h.prototype.parent=g.prototype;h.prototype.render=function(b){var e=c.preserveFileInputs(this.phElemID);h.prototype.parent.render.call(this,b);0<e&&c.reinsertPreservedFileInputs(this.dm.fileInputName)};h.prototype.renderThumbnail=
function(b,e){try{var a="",a=a+("<"+this.itemRootElemStr+">"),a=a+this.customThumbnailHTML("thumbnails/other.gif",e.thumbnailSize),a=a+("</"+this.itemRootElemStr+">");b.append(a)}catch(d){c.log("Problem in DocumentRowBrowseView.renderThumbnail:\n"+d)}};h.prototype.renderDocumentSpec=function(g){try{var e=this.dm.fileInputName,a="",a=a+("<"+this.itemRootElemStr+">"),a=a+'<div class="form-docref">',a=a+('<label for="'+e+'" class="form-label">'+this.dm.dlsName+":</label>"),d="javascript: "+this.dm.getThisInDOM()+
".fileChanged(this);",a=a+('<input type="file" name="'+e+'" size="30" onchange="'+d+'"/>'),a=a+'<div class="DocumentNameRow">';if(this.dm.isAutonamingEnabled())if(this.dm.hasAutonameSuffix())var h="javascript: "+this.dm.getThisInDOM()+".docNameSuffixChanged(this.value);",i=this.dm.docNameSuffix?this.dm.docNameSuffix:"",a=a+('<input type="text" class="form-control form-field-medium" placeholder="'+b.xmlencode(j.t("DocRowDocumentSuffix"))),a=a+('" maxlength="250" size="40" onchange="'+h+'" value="'+
i+'"/>');else a+='<input type="text" class="form-control form-field-medium" placeholder="'+b.xmlencode(j.t("DocRowDocumentName")),a+='" maxlength="250" size="40" disabled="disabled"/>';else var f="javascript: "+this.dm.getThisInDOM()+".docNameChanged(this.value);",n=this.dm.docName?this.dm.docName:"",a=a+('<input type="text" class="form-control form-field-medium" placeholder="'+b.xmlencode(j.t("DocRowDocumentName"))),a=a+('" maxlength="250" size="40" onchange="'+f+'" value="'+n+'"/>');var m="javascript: "+
this.dm.getThisInDOM()+".docDescChanged(this.value);",p=this.dm.docDesc?this.dm.docDesc:"",a=a+('<input type="text" class="form-control form-field-medium" placeholder="'+b.xmlencode(j.t("DocRowDocumentDescription"))+'" maxlength="250" size="40" onchange="'+m+'" value="'+p+'"/>'),a=a+"</div>",a=a+('<div id="'+(this.phElemID+"_docTempFolderSelPHID")+'" class="DocumentTemplateAndFolderRow">'),a=a+this.renderDocTemplateSelector(),a=a+this.renderDocFolderSelector(),a=a+"</div>",a=a+("</"+this.itemRootElemStr+
">");g.append(a)}catch(o){c.log("Problem in DocumentRowBrowseView.renderDocumentSpec:\n"+o)}};return h});
define("doctablex/DocumentRowBrowse","doctablex/DocumentRow doctablex/DocumentRowBrowseView doctablex/AJAXDataCache doctablex/DocTableXUtils doctablex/DocumentTypeUtils utils/webi18n!DocRefStrings wcr/webcenter_xml jquery".split(" "),function(g,c,j,b,h,l,e,a){var d=function(a){if(!a)return this;a.viewClass||(a.viewClass=c);g.call(this,a);this.isValidFileSelected=!1;this.fileInputName=this.getRowPrefix()+"_fileForm";this.dlsName=a.dlsName||"Upload";this.docOperation="Upload";this.allowedFileExts=a.allowedFileExts||
[];this.origFileExt=null;this.project={id:this.getParentDocTable().projectID};this.useDocTypeDefaultACat=!0;this.constructor==d.prototype.constructor&&this._initializeFromServer();return this};d.prototype=new g;d.prototype.constructor=d;d.prototype.parent=g.prototype;d.prototype._initializeFromServer=function(){if(!this.docTemplates&&this.project.id){this.setStatus("loading");var b=j.getInstance().getDocTemplatesByProjID(this.project.id),d=j.getInstance().getFoldersByProjID(this.project.id);a.when(b,
d).done(function(a,b){this.updateDocTemplates(a);this.preselectDocTemplate();this.updateTargetFolders(b);this.preselectTargetFolder();this.setStatus("ready");this.view.repaintRow();this.showDocAttributeCategory(!0,!0)}.bind(this)).fail(function(a){this.setStatus("error");alert("Problem with retrieving document templates:\n"+a)}.bind(this))}else this.docTemplates?this.setStatus("ready"):this.setStatus("error")};d.prototype.getIsValidFileSelected=function(){return this.isValidFileSelected};d.prototype.resetDocument=
function(b){this.isValidFileSelected=!1;a(b).removeClass("docTableFileInputToPreserve");this.docType=this.docTypeID=null;d.prototype.parent.resetDocument.call(this,!1)};d.prototype.convertToXML=function(){var a="";try{if(this.isInErrorStatus()||!this.getIsValidFileSelected())return a;var c="<ds>",c=c+e.ElementEncode("action",this.docOperation);this.fileInputName&&(c+=e.ElementEncode("file_form_field",this.fileInputName));this.project.id&&(c+=e.ElementEncode("project_id",this.project.id));this.selTargetFolder&&
(c+=e.ElementEncode("target_folder_name",this.selTargetFolder.name));this.isAutonamingEnabled()?c+=e.ElementEncode("doc_name_suffix",this.docNameSuffix?this.docNameSuffix:""):this.docName&&(c+=e.ElementEncode("doc_name",this.docName));this.docDesc&&(c+=e.ElementEncode("doc_description",this.docDesc));this.hasAttrCat()&&(c+=e.ElementEncode("doc_attr_cat_id",this.aCatID));this.selDocTemplate&&(c+=e.ElementEncode("doc_temp_id",this.selDocTemplate.id),c+=e.ElementEncode("doc_temp_folder_name",this.selDocTemplate.folderName));
a=d.prototype.parent.convertToXML.call(this,c+"</ds>")}catch(f){b.log("Problem in DocumentRow.convertToXML:\n"+f),a=""}return a};d.prototype.validateDocRow=function(b,c){var f=!0,e=a("input[name="+this.fileInputName+"]");1==e.length&&!e.val()&&(f={isBlocking:!0,level:c,msg:l.t("DocRowFileNotChosen"),element:e,docRowObj:this},b.errors.push(f),f=!1);d.prototype.parent.validateDocRow.call(this,b,c)||(f=!1);return f};d.prototype.fileChanged=function(d){if(this.isInConfigPreview())alert(l.t("DocSrcHdlNoProjectInConfig"));
else{this.setStatus("loading");var c=d.value;c&&(this.resetDocument(d),-1!=c.lastIndexOf("\\")?c=c.substring(c.lastIndexOf("\\")+1):-1!=c.lastIndexOf("/")?c=c.substring(c.lastIndexOf("/")+1):-1!=c.lastIndexOf(":")&&(c=c.substring(c.lastIndexOf(":")+1)),this.origFileExt=b.getFileExtension(c,!0),this.allowedFileExts&&0<this.allowedFileExts.length&&-1==this.allowedFileExts.indexOf(this.origFileExt)?(alert(l.t("notAllowedDocExtension")+this.allowedFileExts.toString()),this.view.repaintRow()):(this.docName=
c,this.setIsChanged(),a(d).addClass("docTableFileInputToPreserve"),this.isValidFileSelected=!0,c=j.getInstance(),d=c.getEffectiveDocTypesSettingsByProjID(this.project.id),c=c.getDocTemplatesByProjID(this.project.id),a.when(d,c).done(function(a,b){this.docTypeID=h.getDocTypeIDByExtension(this.origFileExt);this.updateDocumentType(a,!1);this.updateDocTemplates(b);this.isModifiedByUser("docTemplate")||this.preselectDocTemplate();this.preselectTargetFolder();this.setStatus("ready");this.view.repaintRow();
this.showDocAttributeCategory(!1,!0)}.bind(this)).fail(function(a){this.setStatus("error");alert("Failed to process document configuration from the server.\n"+a)}.bind(this))))}};d.prototype.getAttCatView=function(){var a=b.getRenderItem(this.renderOptions.columns,"AttributeFlapout");return a&&!1===a.useCreationView?this.aCatView||"Default":"Creation"};return d});
define("doctablex/DocumentRowNewView",["doctablex/DocumentRowView","doctablex/DocTableXUtils","utils/webi18n!DocRefStrings","wcr/webcenter_xml","jquery"],function(g,c,j,b,h){var l=function(b,a,d){if(!b&&!a&&!d)return this;g.call(this,b,a,d);return this};l.prototype=new g;l.prototype.constructor=l;l.prototype.parent=g.prototype;l.prototype.getDocTemplateDialogPlaceholder=function(){var c=h("#"+this.dm.docTempDialogPHID);0==c.length&&(c=h('<div id="'+this.dm.docTempDialogPHID+'"></div>').appendTo("body"),
c.attr("style","display: none; background-color: #F7F7F7; border-collapse: collapse; border-bottom: 1px solid #dfdfdf;"),c.attr("title",b.xmlencode(j.t("SELECTDOCTEMPLATE"))));return c};l.prototype.renderDocTemplateDialog=function(){var c=h("#"+this.dm.docTempDialogPHID);if(!this.dm.docTemplates||0==this.dm.docTemplates.length||1!=c.length)return null;h("#docTemplateDialogFilter").off();h(".docTemplatesList").off();c.empty();var a=h('<div class="docTemplatesFilterRow darktext_darklink_11"></div>'),
d="<span>"+b.xmlencode(j.t("PROJDETAILSTOTALDOCS_TAG"))+": "+this.dm.docTemplates.length+"</span>",d=d+('<span class="form-inline-field-indent">'+b.xmlencode(j.t("FILTER"))+":</span>");a.html(d+'<input class="form-field-small form-inline-field-indent" id="docTemplateDialogFilter" name="docTemplateDialogFilter"/>');a.find("#docTemplateDialogFilter").on("keyup",function(){var a=h(this).val().toLowerCase();0<a.length?h("div.docTemplateRow").each(function(b,d){-1!=h(d).find("div.docTemplateName").text().toLowerCase().indexOf(a)?
h(d).show():h(d).hide()}):h("div.docTemplateRow").show()});c.append(a);a=h('<div class="docTemplatesList" style="overflow: auto; height: 350px; background-color: #FFFFFF;"></div>');a.on("click",function(a){h('input[name="docTemplateSelectOption"]:checked').attr("checked",!1);a.target.checked=!0});for(var d="",g=0;g<this.dm.docTemplates.length;g++){var i=this.dm.docTemplates[g],d=d+'<div class="docTemplateRow">',d=d+('<input type="radio" value="'+g+'" name="docTemplateSelectOption"');0==g&&(d+=" checked");
d+="/>";d+='<img class="form-inline-field-indent" src="'+i.thumbnailURL+'" width="50" height="50" border="0" align="middle">';d+='<div class="docTemplateName form-inline-field-indent">'+b.xmlencode(i.name)+"</div>";d+="</div>"}a.html(d);c.append(a);h("#popitmenu").css("z-index",1200);return c};l.prototype.renderDocumentSpec=function(e){try{var a="",a=a+("<"+this.itemRootElemStr+">"),a=a+'<div class="form-docref">',a=a+('<span class="form-label">'+b.xmlencode(this.dm.dlsName)+":</span>"),a=a+('<span class="form-inline-field">'+
b.xmlencode(this.dm.selDocTemplate.name)+"</span>"),a=a+'<div class="DocumentNameRow">';if(this.dm.isAutonamingEnabled())if(this.dm.hasAutonameSuffix())var d="javascript: "+this.dm.getThisInDOM()+".docNameSuffixChanged(this.value);",g=this.dm.docNameSuffix?this.dm.docNameSuffix:"",a=a+('<input type="text" class="form-control form-field-medium" placeholder="'+b.xmlencode(j.t("DocRowDocumentSuffix"))),a=a+('" maxlength="250" size="40" onchange="'+d+'" value="'+b.xmlencode(g)+'"/>');else a+='<input type="text" class="form-control form-field-medium" placeholder="'+
b.xmlencode(j.t("DocRowDocumentName")),a+='" maxlength="250" size="40" disabled="disabled"/>';else var i=this.dm.docName?this.dm.docName:"",f="javascript: "+this.dm.getThisInDOM()+".docNameChanged(this.value);",a=a+('<input type="text" class="form-control form-field-medium" placeholder="'+b.xmlencode(j.t("DocRowDocumentName"))),a=a+('" maxlength="250" size="40" onchange="'+f+'" value="'+b.xmlencode(i)+'"/>');var h="javascript: "+this.dm.getThisInDOM()+".docDescChanged(this.value);",l=this.dm.docDesc?
this.dm.docDesc:"",a=a+('<input type="text" class="form-control form-field-medium" placeholder="'+b.xmlencode(j.t("DocRowDocumentDescription"))+'" maxlength="250" size="40" onchange="'+h+'" value="'+b.xmlencode(l)+'"/>'),a=a+"</div>",a=a+('<div id="'+(this.phElemID+"_folderSelPHID")+'" class="FolderRow">'),a=a+this.renderDocFolderSelector(),a=a+"</div>",a=a+"</div>",a=a+("</"+this.itemRootElemStr+">");e.append(a)}catch(p){c.log("Problem in DocumentRowNewView.renderDocumentSpec:\n"+p)}};return l});
define("doctablex/DocumentRowNew","doctablex/DocumentRow doctablex/DocumentRowNewView doctablex/AJAXDataCache doctablex/DocTableXUtils utils/webi18n!DocRefStrings wcr/webcenter_xml jquery".split(" "),function(g,c,j,b,h,l,e){var a=function(b){if(!b)return this;b.viewClass||(b.viewClass=c);g.call(this,b);this.dlsName=b.dlsName||"New";this.docOperation="New";if(!this.project||!this.project.id)this.project={id:this.getParentDocTable().projectID};this.docTempDialogPHID=b.docTempDialogPHID;this.docTempDialogPHID||
(this.docTempDialogPHID="docTemplateDialogPHID");this.isDocTempDialogInitialized=!1;this.constructor==a.prototype.constructor&&this._initializeFromServer();return this};a.prototype=new g;a.prototype.constructor=a;a.prototype.parent=g.prototype;a.prototype._initializeFromServer=function(){this.setStatus("loading");var a=j.getInstance().getDocTemplatesByProjID(this.project.id,!0),b=j.getInstance().getFoldersByProjID(this.project.id);e.when(a,b).done(function(a,b){this.updateDocTemplates(a);this.updateTargetFolders(b);
this.showDocTemplateDialog()}.bind(this)).fail(function(a){this.isInConfigPreview()?alert(h.t("DocSrcHdlNoDocTempInConfig")):(this.setStatus("error"),alert("Failed to load document templates from the server.\n"+a))}.bind(this))};a.prototype.showDocTemplateDialog=function(){if(this.docTemplates)if(0==this.docTemplates.length)alert(h.t("DocSrcHdlNoDocTempComplyFilter"));else if(1==this.docTemplates.length)this.updateDocTemplateSelection(0),this.preselectTargetFolder(),this.parentDocTable.addDocTemplateRow(this),
this.setStatus("ready"),this.showDocAttributeCategory(!0,!0);else{var a=this.view.getDocTemplateDialogPlaceholder();if(!this.isDocTempDialogInitialized){var b={};b[h.t("CANCEL")]=function(){a.dialog("close")}.bind(this);b[h.t("OK")]=function(){this.setStatus("loading");var b=e('input[name="docTemplateSelectOption"]:checked:visible');0==b.length?alert(h.t("SELECTDOCTEMPLATE")+"."):(this.updateDocTemplateSelection(b.val()),this.preselectTargetFolder(),a.dialog("close"),this.parentDocTable.addDocTemplateRow(this),
this.setStatus("ready"),this.showDocAttributeCategory(!0,!0))}.bind(this);a.dialog({autoOpen:!1,modal:!1,draggable:!0,resizable:!0,overflow:scroll,width:500,buttons:b});null!=this.view.renderDocTemplateDialog()&&(this.isDocTempDialogInitialized=!0)}a.dialog("open");this.setStatus("wait4user")}};a.prototype.updateDocTemplateSelection=function(b){a.prototype.parent.updateDocTemplateSelection.call(this,b);this.selDocTemplate&&(this.docName=this.selDocTemplate.name,this.thumbnailURL=this.selDocTemplate.thumbnailURL,
this.docTypeID=this.selDocTemplate.docTypeID);var b=j.getInstance().getEffectiveDocTypesSettingsByProjID(this.project.id),c="resolved"==b.state();b.done(function(a){this.updateDocumentType(a,!c)}.bind(this));b.fail(function(a){alert("Failed to load document templates from the server.\n"+a)})};a.prototype.convertToXML=function(){var d="";try{if(this.isInErrorStatus())return d;var c="<ds>",c=c+l.ElementEncode("action",this.docOperation),c=c+l.ElementEncode("template_dv_id",this.selDocTemplate.docVerID);
this.project.id&&(c+=l.ElementEncode("project_id",this.project.id));this.selTargetFolder&&(c+=l.ElementEncode("target_folder_name",this.selTargetFolder.name));this.isAutonamingEnabled()?c+=l.ElementEncode("doc_name_suffix",this.docNameSuffix?this.docNameSuffix:""):this.docName&&(c+=l.ElementEncode("doc_name",this.docName));this.docDesc&&(c+=l.ElementEncode("doc_description",this.docDesc));this.hasAttrCat()&&(c+=l.ElementEncode("doc_attr_cat_id",this.aCatID));c+=l.ElementEncode("doc_temp_id",this.selDocTemplate.id);
c+=l.ElementEncode("doc_temp_folder_name",this.selDocTemplate.folderName);d=a.prototype.parent.convertToXML.call(this,c+"</ds>")}catch(e){b.log("Problem in DocumentRowNew.convertToXML:\n"+e),d=""}return d};a.prototype.getAttCatView=function(){var a=b.getRenderItem(this.renderOptions.columns,"AttributeFlapout");return a&&!1===a.useCreationView?this.aCatView||"Default":"Creation"};return a});
define("doctablex/DocumentRowLinkView",["doctablex/DocumentRowView","doctablex/DocTableXUtils","utils/webi18n!DocRefStrings","wcr/webcenter_xml"],function(g,c,j,b){var h=function(b,c,a){if(!b&&!c&&!a)return this;g.call(this,b,c,a);return this};h.prototype=new g;h.prototype.constructor=h;h.prototype.parent=g.prototype;h.prototype.renderDocumentSpec=function(g,e){try{var a="",a=a+("<"+this.itemRootElemStr+">"),a=a+this.renderInlineLabel(e);if(this.dm.isInErrorStatus())a=this.dm.isInConfigPreview()?
a+("<span>"+j.t("DocSrcHdlNoProjectInConfig")+"</span>"):a+("<span>"+j.t("DocRowLoadingDocsError")+"</span>");else{a+='<div class="form-docref">';a+='<div class="DocumentNameRow">';if(this.dm.docsInCurrentProject)if(0==this.dm.docsInCurrentProject.length)a+="<span>"+j.t("DocRowNoDocsAvailable")+"</span>";else{for(var d="javascript: "+this.dm.getThisInDOM()+".docVersionSelected(this.value);",a=a+('<select class="form-control form-field-medium form-dropdown-field" onChange="'+d+'">'),a=a+('<option value="">'+
b.xmlencode(j.t("DocRowPleaseSelect"))+"</option>"),d=0;d<this.dm.docsInCurrentProject.length;d++)var h=this.dm.docsInCurrentProject[d].id,i=this.dm.docsInCurrentProject[d].name,a=a+('<option value="'+h+'"'+(this.dm.docVerID==h?' selected="selected"':"")+">"),a=a+(b.xmlencode(i)+"</option>");a+="</select>"}else a+="<span>"+j.t("DocRowLoadingDocs")+"</span>";a+="</div>";a+="</div>"}a+="</"+this.itemRootElemStr+">";g.append(a)}catch(f){c.log("Problem in DocumentRowLinkView.renderDocumentSpec:\n"+f)}};
h.prototype.renderThumbnail=function(b,e){try{if(this.dm.docVerID)h.prototype.parent.renderThumbnail.call(this,b,e);else{var a="<"+this.itemRootElemStr+">",a=a+this.customThumbnailHTML("thumbnails/other.gif",e.thumbnailSize),a=a+("</"+this.itemRootElemStr+">");b.append(a)}}catch(d){c.log("Problem in DocumentRowLinkView.renderThumbnail:\n"+d)}};return h});
define("doctablex/DocumentRowLink","doctablex/DocumentRow doctablex/DocumentRowLinkView doctablex/AJAXDataCache doctablex/DocTableXUtils utils/webi18n!DocRefStrings wcr/webcenter_xml jquery".split(" "),function(g,c,j,b,h,l,e){var a=function(b){if(!b)return this;b.viewClass||(b.viewClass=c);g.call(this,b);this.dlsName=b.dlsName||"Link";this.docOperation="Reference";this.project={id:this.getParentDocTable().projectID};this.docsInCurrentProject=null;this.constructor==a.prototype.constructor&&this._initializeFromServer();
return this};a.prototype=new g;a.prototype.constructor=a;a.prototype.parent=g.prototype;a.prototype._initializeFromServer=function(){if(this.project.id){this.setStatus("loading");var a=j.getInstance().getDocVersionsByProjID(this.project.id);a.done(function(a){this.initDocsInCurrentProject(a);this.setStatus("ready");this.view.repaintRow();this.showDocAttributeCategory(!0,!0)}.bind(this));a.fail(function(a){this.setStatus("error");alert(h.t("DocRowLoadingDocsError")+":\n"+a)}.bind(this))}else this.setStatus("error")};
a.prototype.resetDocument=function(){a.prototype.parent.resetDocument.call(this,!0)};a.prototype.initDocsInCurrentProject=function(a){this.docsInCurrentProject=!a||0==a.length?[]:a};a.prototype.canUserEditAttributes=function(){var a=this.userPerms?this.userPerms.change:!1;return this.isEditable&&!this.isInErrorStatus()&&this.isLatestDocVersion()&&!this.dependsOnItself&&a};a.prototype.generateDocAttributeValuesAJAXURL=function(){return a.prototype.parent.parent.generateDocAttributeValuesAJAXURL.call(this)};
a.prototype.convertToXML=function(){var c="";try{if(this.isInErrorStatus()||!this.docVerID)return c;var e="<ds>",e=e+l.ElementEncode("action",this.docOperation);this.docVerID&&(e+=l.ElementEncode("source_dv_id",this.docVerID));c=a.prototype.parent.convertToXML.call(this,e+"</ds>")}catch(g){b.log("Problem in DocumentRowLink.convertToXML:\n"+g),c=""}return c};a.prototype.validateDocRow=function(b,c){var g=!0,f=e("#"+this.getRowPrefix()+" div.DocumentNameRow > select:first");1==f.length&&!f.val()&&(g=
{isBlocking:!0,level:c,msg:h.t("DocRowDocNotSelected"),element:f,docRowObj:this},b.errors.push(g),g=!1);a.prototype.parent.validateDocRow.call(this,b,c)||(g=!1);return g};a.prototype.docVersionSelected=function(a){this.docVerID!=a&&(this.resetDocument(),this.setStatus("loading"),this.docVerID=a,this.getParentDocTable().isDocDependentOnItself(this)&&(confirm(h.t("DocRowDocDependentOnItself"))?this.setDependsOnItself(!0):this.docVerID=""),""==this.docVerID?(this.setStatus("ready"),this.view.repaintRow(),
this.hideDocAttributeCategory()):(a=this.updateDocInfoFromServer(!1),a.done(function(){this.setStatus("ready");this.view.repaintRow();this.showDocAttributeCategory(!0,!0)}.bind(this)),a.fail(function(a){this.setStatus("error");b.error("Failed to load document information from the server:\n"+a)})))};return a});
define("doctablex/DocTableX","wcr/webcenter_xml doctablex/DocTableXView doctablex/DocTableXUtils doctablex/AJAXDataCache doctablex/DocumentRowSearch doctablex/DocumentRowBrowse doctablex/DocumentRowNew doctablex/DocumentRowLink utils/webi18n!DocRefStrings jquery wcr/search wcr/extpopup".split(" "),function(g,c,j,b,h,l,e,a,d,k){var i=function(a){if(!a)return this;this.isInConfigPreview=a.isInConfigPreview||!1;this.currentUser=a.currentUser||null;this.onChangeCallback=a.onChangeCallback||null;this.docRows=
[];this.isChanged=!1;this.parentDocVerIDs=a.parentDocVerIDs||[];this.phElemID=a.phElemID;this.saveXMLRootTag="dtval";a.saveXMLRootTag&&(this.saveXMLRootTag=g.xmlencode(a.saveXMLRootTag));this.thisInDOM="document.getElementById('"+this.phElemID+"').docTable";this.greenLinksPrefix;this._setPrefix(a.prefix);this.dshObj=a.dshObj;if(!this.dshObj)return alert("Document table cannot be created without DocumentSourceHandler reference!"),null;this.isEditable=a.isEditable||!1;this.currentUser&&!1==this.currentUser.canEditAttributes&&
(this.isEditable=!1);this.isInactive=a.isInactive||!1;this.parentACatNotExpandedYet=a.parentACatNotExpandedYet||!1;this.clearValues=a.clearValues||!1;this.allowMultiple=a.allowMultiple||!1;this.projectID=a.projectID||null;this.canUserAddDocuments=this.hasDocumentTemplates=this.isInConfigPreview;this.aCatView=a.aCatView;var b={renderMethod:"list",showGreenLinksOnTop:!0,showGreenLinksAtBottom:!1};this.renderOptions=a.renderOptions||b;this.propsACatID=a.propsACatID||null;null==j.getRenderItem(this.renderOptions.columns,
"ReferenceProperty")&&(this.propsACatID=null);this.constructor==i.prototype.constructor&&(this.view=new c(this,this.phElemID,this.renderOptions),this._initializeFromServer());return this};i.prototype._initializeFromServer=function(){if(!this.isInConfigPreview)if(this.projectID){var a=b.getInstance().getDocTemplatesByProjID(this.projectID,!0),c=b.getInstance().getFoldersByProjID(this.projectID);k.when(a,c).done(function(a,b){var c=this.hasDocumentTemplates,d=this.canUserAddDocuments;this.hasDocumentTemplates=
a&&0<a.length;this.canUserAddDocuments=b&&0<b.length;if(this.hasDocumentTemplates!=c||this.canUserAddDocuments!=d)this.view.renderDocSourceLinks(),this.canUserAddDocuments!=d&&this.view.repaintRemoteDocRows()}.bind(this)).fail(function(a){alert("Failed to load data needed to initialize DocTableX instance from the server.\n"+a)})}else j.log("DocTableX._initializeFromServer(): There is no project ID to load configuration for.")};i.prototype.setIsChanged=function(){if(this.onChangeCallback)this.onChangeCallback();
this.isChanged=!0};i.prototype.getIsChanged=function(){if(this.isChanged)return!0;for(var a=0;a<this.docRows.length;a++){var b=this.docRows[a];if(b&&b.getIsChanged())return!0}return!1};i.prototype._setPrefix=function(a){a||(a="");this.prefix=a;this.greenLinksPrefix=a+"_greenLinks"};i.prototype.getTablePrefix=function(){return this.prefix};i.prototype.getThisInDOM=function(){return this.thisInDOM};i.prototype.getRowByID=function(a){for(var b=0;b<this.docRows.length;b++){var c=this.docRows[b];if(c.rowID==
a)return c}return null};i.prototype.getDocumentSourceOptions=function(a){return{docTable:this,hasDocumentTemplates:this.hasDocumentTemplates,canUserAddDocuments:this.canUserAddDocuments,linksId:a}};i.prototype.hasLocalRemoteButton=function(){return null!=j.getRenderItem(this.renderOptions.columns,"LocalRemote")};i.prototype.reset=function(){this.docRows=[];this.parentDocVerIDs=[];this.isChanged=!1};i.prototype.setCustomView=function(a,b){a&&(a.dm=this,a.phElemID||(a.phElemID=this.phElemID),a.renderOptions||
(a.renderOptions=this.renderOptions),this.view=a,b&&this.displayTable())};i.prototype.setIsEditable=function(a,b){if(void 0!==a&&a!=this.isEditable){this.isEditable=a;for(var c=0;c<this.docRows.length;c++)this.docRows[c].setIsEditable(a)}b&&this.displayTable()};i.prototype.setIsInactive=function(a){void 0!==a&&a!=this.isInactive&&(this.isInactive=a)};i.prototype.hasSameContentAs=function(a){if(this.docRows&&!a||!this.docRows&&a||this.docRows&&this.docRows.length!=a.length)return!1;for(var b=0;b<this.docRows.length;b++){var c=
this.docRows[b],d=a[b];if(c&&!d||!c&&d||c&&c.docVerID!=d.docVerID)return!1;var e=c.props?c.props:[];if(e.length!=(d.props?d.props:[]).length)return!1;for(var g=0;g<e.length;g++){var h=e[g];if(h&&h.id){var i=d.findPropertyByID(h.id);if(!i)return!1;if(c.propsACatObj&&c.propsACatObj.loaded){if((h=c.propsACatObj.findAttribute(h.id,h.name))&&h.value!=i.value)return!1}else if(h.value!=i.value)return!1}}}return!0};i.prototype.initWithDocRows=function(a,b){if(!a)return!1;for(var c=0;c<a.length;c++){var d=
a[c];if(d){if(this!==d.getParentDocTable())return!1;this.isDocDependentOnItself(d)&&d.setDependsOnItself(!0);this.docRows.push(d)}}b&&this.displayTable();return!0};i.prototype._insertRow=function(a,b,c){this.isDocDependentOnItself(a)&&a.setDependsOnItself(!0);if(this.allowMoreToAdd())null!=b&&b<this.getNumberOfRows()?(0>b&&(b=0),this.docRows.splice(b,0,a)):this.docRows.push(a);else if(confirm(d.t("DocTableReplaceSingleValueQ")))this.docRows[this.getNumberOfRows()-1]=a;else return!1;c&&this.displayTable();
return!0};i.prototype.appendDocRow=function(a,b,c){a.parentDocTable=this;a=new b(a);return this._insertRow(a,null,c)};i.prototype.addDocRow=function(a,b,c,e,g){a.parentDocTable=this;a=new b(a);if(e&&this.isDocDependentOnItself(a)&&!confirm(d.t("DocTableCycleDependencyWarning")))return!1;g||(g=0);return this._insertRow(a,g,c)};i.prototype.addDocRows=function(a,b,c){for(var d=!1,e=0;e<a.length;e++)this.addDocRow(a[e],b,e==a.length-1,c,e)&&(d=!0);d&&c&&this.setIsChanged()};i.prototype.addSearchDocRows=
function(a,b){this.addDocRows(a,h,b)};i.prototype.addBrowseRow=function(a){a=a.dlsObj;a={parentDocTable:this,dlsName:a.label.getLabel(),targetFolderName:a.targetFolder,allowedFileExts:j._getFileExtensionsList(a.documentType),docTempType:a.docTemplateType,docTempNames:j._getDocTemplateNameList(a.docTemplateName)};this.addDocRow(a,l,!0,!0)&&this.setIsChanged()};i.prototype.addLinkRow=function(b){b={parentDocTable:this,dlsName:b.dlsObj.label.getLabel()};this.addDocRow(b,a,!0,!0)&&this.setIsChanged()};
i.prototype.addDocTemplateRow=function(a){a&&this._insertRow(a,0,!0)&&this.setIsChanged()};i.prototype.openDocTemplateDialog=function(a){a=a.dlsObj;a={parentDocTable:this,dlsName:a.label.getLabel(),targetFolderName:a.targetFolder,docTempType:a.docTemplateType,docTempNames:j._getDocTemplateNameList(a.docTemplateName)};new e(a)};i.prototype.getDocTemplateNameList=function(a){return j._getDocTemplateNameList(a)};i.prototype.isDocDependentOnItself=function(a){var b=this.parentDocVerIDs;return a.docVerID&&
b&&-1!=b.indexOf(a.docVerID)};i.prototype.getNumberOfRows=function(){return this.docRows.length};i.prototype.allowMoreToAdd=function(){return this.allowMultiple||1>this.getNumberOfRows()};i.prototype.displayTable=function(){var a=this.view.render();a&&1==a.length&&(a[0].docTable=this)};i.prototype.convertToXML=function(){var a="";try{a+="<"+this.saveXMLRootTag+">";this.isEditable||(a+=g.ElementEncode("readonly","1"));for(var b=0;b<this.docRows.length;b++)a+=this.docRows[b].convertToXML();a+="</"+
this.saveXMLRootTag+">"}catch(c){j.log("Problem in DocTableX.convertToXML:\n"+c),a=""}return a};i.prototype.validateDocTable=function(a,b){if(!this.isInactive)for(var c=0;c<this.docRows.length;c++)this.docRows[c].validateDocRow(a,b)};i.prototype.onSubmit=function(){this.clearValues&&(this.docRows=[]);if(!this.isInactive||this.clearValues){var a=this.getTablePrefix(),a=k("#"+a);0<a.length&&a.val(this.convertToXML())}if(!this.isInactive)for(a=0;a<this.docRows.length;a++)this.docRows[a]._onSubmit()};
i.prototype.localRemoteButtonClicked=function(a){if(!(0>a)){var b=this.docRows[a];b.deleteItself(!0);b.origDocRow?this.docRows[a]=b.origDocRow:(b={parentDocTable:this,docVerID:b.docVerID,docID:b.docID,docName:b.docName,dlsName:d.t("DocRowMakeLocalAction"),targetFolderName:b.targetFolderName,projectID:this.projectID,operation:"Copy",docTempType:b.docTempType,docTempNames:b.docTempNames,properties:b.props,origDocRow:b},this.docRows[a]=new h(b));this.docRows[a].displayRow()}};i.prototype.deleteButtonClicked=
function(a){if(!(0>a))if(this.docRows[a].deleteItself(),this.docRows.splice(a,1),this.setIsChanged(),0<this.getNumberOfRows())for(a=0>a-1?0:a-1;a<this.getNumberOfRows();a++)this.docRows[a].view.repaintRow();else this.displayTable()};i.prototype.moveUpButtonClicked=function(a){if(0<a){var b=this.docRows[a-1];this.docRows[a-1]=this.docRows[a];this.docRows[a]=b;this.docRows[a].swapWith(this.docRows[a-1]);this.setIsChanged()}};i.prototype.moveDownButtonClicked=function(a){if(a<this.getNumberOfRows()-
1){var b=this.docRows[a+1];this.docRows[a+1]=this.docRows[a];this.docRows[a]=b;this.docRows[a+1].swapWith(this.docRows[a]);this.setIsChanged()}};i.prototype.expandCollapseAllClicked=function(a){a=k(a);a.hasClass("expandAll")?this.expandAllRows():a.hasClass("collapseAll")&&this.collapseAllRows()};i.prototype.expandAllRows=function(){for(var a=0;a<this.docRows.length;a++)this.docRows[a].showDocAttributeCategory(!1,!0)};i.prototype.collapseAllRows=function(){for(var a=0;a<this.docRows.length;a++)this.docRows[a].collapseAllDescendants()};
i.prototype.destroy=function(){for(var a=0;a<this.docRows.length;a++)this.docRows[a].destroy()};i.prototype.reconstruct=function(){for(var a=0;a<this.docRows.length;a++)this.docRows[a].reconstruct()};return i});