/**
 * (The MIT License)
 * Copyright (c) 2011 hij1nx http://www.twitter.com/hij1nx
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the 'Software'), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
 * The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
 * THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 * 
 * See https://github.com/hij1nx/EventEmitter2
 */

define("pages/wctaskexecution/PageSection",["wcr/webcenter_html","jquery","wcr/AddDocument","wcr/DocumentsTable","wcr/validate"],function(i,e){function b(a,d,f,c){try{if(!c||0==c.length)c="SHOW";this.setState(c);this.parent=null;this.modified=!1;this.sectionID=a;this.expandToggleID=d;this.bodyID=f;this.expand="COLLAPSE"!=this.state;this.dynamicContentReady=!1}catch(h){alert("Problem in PageSection constructor: "+h)}}b.prototype.initialize=function(a){this.name=a};b.prototype.show=function(){var a=
e("#"+this.sectionID),d=e("#"+this.bodyID);a.hide();"COLLAPSE"!=this.state&&("SHOW"==this.state||"REQUIRED"==this.state?this.generateDynamicContent():d.html("Error in section "+this.bodyID+"."));"HIDE"!=this.state&&(a.show(),this.slide(!1))};b.prototype.setState=function(a){try{"SHOW"!=a&&("HIDE"!=a&&"COLLAPSE"!=a&&"REQUIRED"!=a&&"ERROR"!=a)&&(a="HIDE"),this.state=a}catch(d){alert("Problem in PageSection.setState() method: "+d)}};b.prototype.setModified=function(a){try{if("undefined"==typeof a||null==
a)a=!0;if(this.modified=a)this.dynamicContentReady=!1}catch(d){alert("Problem in PageSection.setModified() method: "+d)}taskExPage.checkIfModifiedAndUpdateButtons()};b.prototype.isModified=function(){return this.modified};b.prototype.slide=function(a){try{if(this.expandToggleID&&0!=this.expandToggleID.length){var d=e("#"+this.expandToggleID),f=e("#"+this.bodyID);if(null==a||a)this.expand=!this.expand;this.expand?(this.generateDynamicContent(),d[0]&&(d[0].src="images/expand.png"),f.slideDown("fast")):
(d[0]&&(d[0].src="images/collapse.png"),f.slideUp("fast"))}}catch(c){alert("Problem in PageSection.slide() method: "+c)}};b.prototype.reset=function(){this.dynamicContentReady=!1};b.prototype.setSectionData=function(){alert("PageSection.setSectionData() should be implemented in subclass")};b.prototype.validateFormParams=function(){return!0};b.prototype.generateDynamicContent=function(){};return b});
define("utils/ConvertUtils",["jquery","underscore"],function(i){return{getLangFormattedDate:function(e,b){var a=[];a[0]=e.t("MONTH1");a[1]=e.t("MONTH2");a[2]=e.t("MONTH3");a[3]=e.t("MONTH4");a[4]=e.t("MONTH5");a[5]=e.t("MONTH6");a[6]=e.t("MONTH7");a[7]=e.t("MONTH8");a[8]=e.t("MONTH9");a[9]=e.t("MONTH10");a[10]=e.t("MONTH11");a[11]=e.t("MONTH12");null==b&&(b=new Date);var d=b.getMonth(),f=b.getDate(),c=b.getFullYear();return""+a[d]+" "+f+", "+c},getLangFormattedDateAndTime:function(e,b){var a=[];a[0]=
e.t("MONTH1");a[1]=e.t("MONTH2");a[2]=e.t("MONTH3");a[3]=e.t("MONTH4");a[4]=e.t("MONTH5");a[5]=e.t("MONTH6");a[6]=e.t("MONTH7");a[7]=e.t("MONTH8");a[8]=e.t("MONTH9");a[9]=e.t("MONTH10");a[10]=e.t("MONTH11");a[11]=e.t("MONTH12");null==b&&(b=new Date);var d=b.getMonth(),f=b.getDate(),c=b.getFullYear(),h=b.getHours();10>h&&(h="0"+h);var g=b.getMinutes();10>g&&(g="0"+g);return e.t("DateAndTimeString",a[d],f,c,h,g)},capitaliseFirstLetter:function(e){return e.charAt(0).toUpperCase()+e.slice(1)},getCharacterLineCount:function(e){var b=
1,a=0;if(e){for(var e=this.convertHTMLStringToRaw(e),e=e.replace(/\r\n/g,"\n"),a=0,d=e.indexOf("\n",0);-1!=d;)b++,a++,d=e.indexOf("\n",d+1);a=e.length-a}return{lineCount:b,charCount:a}},convertHTMLStringToRaw:function(e,b){void 0===b&&(b="\n");var a=e.replace(/>[\f\n\r\t\v\u00a0\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u2028\u2029\u202f\u205f\u3000]*([ ]*)[\f\n\r\t\v\u00a0\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u2028\u2029\u202f\u205f\u3000]*</g,
">$1<"),a=a.replace(/.*<body>((\r\n|\n|.)*)<\/body>.*/i,"$1"),a=a.replace(/^<(blockquote|body|center|dd|dir|div|dl|dt|form|h1|h2|h3|h4|h5|h6|head|hr|html|isindex|li|menu|noframes|ol|p|pre|td|th|title|ul)[^>]*>/,""),a=a.replace(/<(blockquote|body|br|center|dd|dir|div|dl|dt|form|h1|h2|h3|h4|h5|h6|head|hr|html|isindex|li|menu|noframes|ol|p|pre|td|th|title|ul)[^>]*>/g,b),a=a.replace(/<[^>]*>/g,""),a=a.replace(/&nbsp;|&#160;/gi," ");return a=this.decodeHtmlEntities(a)},convertRawStringToHTML:function(e){e=
this.encodeHtmlEntities(e);return e=e.replace(/(\r)?\n/g,"<br />")},decodeHtmlEntities:function(e){return i("<textarea>").html(e).text()},encodeHtmlEntities:function(e){return i("<div>").text(e).html()}}});
define("utils/HTTPUtils",["jquery","underscore","utils/ConvertUtils"],function(i,e,b){return{constructURL:function(a,d,f){var c="";f&&(c+=f);var c=c+a,a="?",h;for(h in d){if(d.hasOwnProperty(h))if(e.isArray(d[h]))for(f=0;f<d[h].length;f++)c+=a+encodeURIComponent(h)+"="+encodeURIComponent(b.decodeHtmlEntities(d[h][f]));else c+=a+encodeURIComponent(h)+"="+encodeURIComponent(b.decodeHtmlEntities(d[h]));a="&"}return c}}});
define("utils/XMLUtils",[],function(){var i=null;return i={attributeValue:function(e,b){var a=e.attributes.getNamedItem(b);return a?a.nodeValue:null},nodeTextContent:function(e,b){var a=e.getElementsByTagName(b)[0];return a?i.textContent(a):null},textContent:function(e){var b=e.textContent;void 0===b&&(b=e.nodeTypedValue);return b},xml2obj:function(e,b){for(var a={},d=e.childNodes,f=0;f<d.length;f++){var c=d[f],h=c.nodeName;if("#text"!=h){var g=this.numberOfChildren(c),m=void 0,m=0<g?this.xml2obj(c,
g):this.textContent(c);void 0!==a[h]?("[object Array]"!==Object.prototype.toString.call(a[h])&&(c=a[h],a[h]=[],a[h].push(c)),a[h].push(m)):a[h]=m}}if((void 0!==b||0<this.numberOfChildren(e))&&e.attributes){a.attributes={};for(d=0;d<e.attributes.length;d++)a.attributes[e.attributes[d].name]=e.attributes[d].value}return a},numberOfChildren:function(e){var b=0;if(e.childNodes&&0<e.childNodes.length)for(var a=0;a<e.childNodes.length;a++)1==e.childNodes[a].nodeType&&b++;return b}}});
define("utils/I18n",["utils/HTTPUtils","utils/XMLUtils","underscore","jquery"],function(i,e,b,a){var d=function(a,c,h){this._locale=a?a:"en";this._timestamp=h?h:0;this.wcrInstanceUrl=c;this.bundles={};this.loading={};this.bundleOrder=[];this.bundleLoadedListeners={}};d.prototype.setLocale=function(a){this._locale=a;this.bundles={};for(var a=function(){},c=0;c<this.bundleOrder.length;c++)this.loadBundle(this.bundleOrder[c],a)};d.prototype.getLocale=function(){return this._locale};d.prototype.loadBundle=
function(a,c,h){c&&h&&(c=b.bind(c,h));if(b.isArray(a)){var g=b.after(a.length,b.once(c));b.each(a,b.bind(function(c){this.loadSingleBundle(c,g)},this))}else this.loadSingleBundle(a,c)};d.prototype.loadSingleBundle=function(f,c){if(this.bundles[f])c&&c(this.bundles[f]);else if(c&&this.whenBundleLoaded(f,c),!this.loading[f]){this.bundleOrder.push(f);this.loading[f]=1;var h=this;a.ajax(i.constructURL("DownloadLocKeys.jsp",{scope:f,t:this._timestamp,lk:this._locale},this.wcrInstanceUrl),{dataType:"xml",
success:function(c){if(c){var a=c.getElementsByTagName("code");if(a[0]&&"001"===e.textContent(a[0]))return}for(var a={},c=c.documentElement.getElementsByTagName("lang_string"),d=0;d<c.length;d++){var b=c[d];a[b.getAttribute("key")]=b.getAttribute("value")}h.bundles[f]={};delete h.loading[f];a&&(h.bundles[f]=a);h.fireBundleLoaded(f,h.bundles[f])},error:function(){},cache:!0,type:"GET"})}};d.prototype.whenBundleLoaded=function(a,c){this.bundleLoadedListeners[a]||(this.bundleLoadedListeners[a]=[]);this.bundleLoadedListeners[a].push(c)};
d.prototype.fireBundleLoaded=function(a,c){this.bundleLoadedListeners[a]&&(b.each(this.bundleLoadedListeners[a],function(a){a(c)}),delete this.bundleLoadedListeners[a])};d.prototype.findByKey=function(a){for(var c=this.bundleOrder.length-1;0<=c;c--)if(this.bundles[this.bundleOrder[c]]&&this.bundles[this.bundleOrder[c]][a])return this.bundles[this.bundleOrder[c]][a]};d.prototype.findByKeyInBundle=function(a,c){if(this.bundles[c]&&this.bundles[c][a])return this.bundles[c][a]};d.prototype.t=function(a){var c=
this.findByKey(a);if(void 0!==c){for(var h=1;h<arguments.length;h++)c=c.replace("{"+(h-1)+"}",arguments[h]);return c}return a};d.prototype.d=function(a,c){var h=this.findByKey(a);if(void 0!==h)return c.toString(h)};return d});
define("utils/webi18n",["utils/I18n","jquery"],function(i,e){var b;return b={getInstance:function(){if(!window.webI18n){var a=window,d=function(c,a){void 0===a||null===a||(a instanceof jQuery||(a=e(a)),a.text(c))},f=new i(window.webcenterConfig.userLang,window.webcenterConfig.jspBaseUrl,window.webcenterConfig.languageLoadTimestamp);a.webI18n={loadSingleBundle:function(c,a){f.loadSingleBundle(c,a)},whenBundleLoaded:function(c,a){f.whenBundleLoaded(c,a)},t:function(c,a){var g=f.findByKeyInBundle(c,
a);if(void 0!==g){for(var d=2;d<arguments.length;d++)g=g.replace("{"+(d-2)+"}",arguments[d]);return g}return c},tIn:function(c,a,g){var m=arguments,e=f.findByKeyInBundle(c,a);if(void 0===e)f.whenBundleLoaded(a,function(){e=f.findByKeyInBundle(c,a);if(void 0!==e){for(var b=3;b<m.length;b++)e=e.replace("{"+(b-3)+"}",m[b]);d(e,g)}else d(c,g)}),d(c,g);else{for(var b=3;b<m.length;b++)e=e.replace("{"+(b-3)+"}",m[b]);d(e,g)}},getLocale:function(){return f.getLocale()}}}return window.webI18n},load:function(a,
d,f,c){if(c.isBuild)f();else{var h=b.getInstance();h.loadSingleBundle(a,function(c){f({t:function(c){var g=[c,a].concat(Array.prototype.slice.call(arguments).slice(1));return h.t.apply(h,g)},tFallback:function(c,g){var f=[c,a].concat(Array.prototype.slice.call(arguments).slice(2)),f=h.t.apply(h,f);return f===c?g:f},asMap:function(){return c}})})}}}});
!function(i){function e(){this._events={};this._conf&&b.call(this,this._conf)}function b(c){c&&(this._conf=c,c.delimiter&&(this.delimiter=c.delimiter),c.maxListeners&&(this._events.maxListeners=c.maxListeners),c.wildcard&&(this.wildcard=c.wildcard),c.newListener&&(this.newListener=c.newListener),this.wildcard&&(this.listenerTree={}))}function a(c){this._events={};this.newListener=!1;b.call(this,c)}function d(c,a,g,f){if(!g)return[];var e=[],b,i,k,l;k=a.length;l=a[f];var o=a[f+1];if(f===k&&g._listeners){if("function"===
typeof g._listeners)c&&c.push(g._listeners);else{a=0;for(f=g._listeners.length;a<f;a++)c&&c.push(g._listeners[a])}return[g]}if("*"===l||"**"===l||g[l]){if("*"===l){for(b in g)"_listeners"!==b&&g.hasOwnProperty(b)&&(e=e.concat(d(c,a,g[b],f+1)));return e}if("**"===l){(l=f+1===k||f+2===k&&"*"===o)&&g._listeners&&(e=e.concat(d(c,a,g,k)));for(b in g)"_listeners"!==b&&g.hasOwnProperty(b)&&("*"===b||"**"===b?(g[b]._listeners&&!l&&(e=e.concat(d(c,a,g[b],k))),e=e.concat(d(c,a,g[b],f))):e=b===o?e.concat(d(c,
a,g[b],f+2)):e.concat(d(c,a,g[b],f)));return e}e=e.concat(d(c,a,g[l],f+1))}(i=g["*"])&&d(c,a,i,f+1);if(g=g["**"])if(f<k)for(b in g._listeners&&d(c,a,g,k),g)"_listeners"!==b&&g.hasOwnProperty(b)&&(b===o?d(c,a,g[b],f+2):b===l?d(c,a,g[b],f+1):(k={},k[b]=g[b],d(c,a,{"**":k},f+1)));else g._listeners?d(c,a,g,k):g["*"]&&g["*"]._listeners&&d(c,a,g["*"],k);return e}var f=Array.isArray?Array.isArray:function(a){return"[object Array]"===Object.prototype.toString.call(a)};a.prototype.delimiter=".";a.prototype.setMaxListeners=
function(a){this._events||e.call(this);this._events.maxListeners=a;this._conf||(this._conf={});this._conf.maxListeners=a};a.prototype.event="";a.prototype.once=function(a,f){this.many(a,1,f);return this};a.prototype.many=function(a,f,g){function e(){0===--f&&d.off(a,e);g.apply(this,arguments)}var d=this;if("function"!==typeof g)throw Error("many only accepts instances of Function");e._origin=g;this.on(a,e);return d};a.prototype.emit=function(){this._events||e.call(this);var a=arguments[0];if("newListener"===
a&&!this.newListener&&!this._events.newListener)return!1;if(this._all){for(var f=arguments.length,g=Array(f-1),b=1;b<f;b++)g[b-1]=arguments[b];b=0;for(f=this._all.length;b<f;b++)this.event=a,this._all[b].apply(this,g)}if("error"===a&&!this._all&&!this._events.error&&(!this.wildcard||!this.listenerTree.error)){if(arguments[1]instanceof Error)throw arguments[1];throw Error("Uncaught, unspecified 'error' event.");}var j;this.wildcard?(j=[],f="string"===typeof a?a.split(this.delimiter):a.slice(),d.call(this,
j,f,this.listenerTree,0)):j=this._events[a];if("function"===typeof j){this.event=a;if(1===arguments.length)j.call(this);else if(1<arguments.length)switch(arguments.length){case 2:j.call(this,arguments[1]);break;case 3:j.call(this,arguments[1],arguments[2]);break;default:f=arguments.length;g=Array(f-1);for(b=1;b<f;b++)g[b-1]=arguments[b];j.apply(this,g)}return!0}if(j){f=arguments.length;g=Array(f-1);for(b=1;b<f;b++)g[b-1]=arguments[b];j=j.slice();b=0;for(f=j.length;b<f;b++)this.event=a,j[b].apply(this,
g);return 0<j.length||this._all}return this._all};a.prototype.on=function(a,b){if("function"===typeof a)return this.onAny(a),this;if("function"!==typeof b)throw Error("on only accepts instances of Function");this._events||e.call(this);this.emit("newListener",a,b);if(this.wildcard){a:{for(var g=a,g="string"===typeof g?g.split(this.delimiter):g.slice(),d=0,j=g.length;d+1<j;d++)if("**"===g[d]&&"**"===g[d+1])break a;d=this.listenerTree;for(j=g.shift();j;){d[j]||(d[j]={});d=d[j];if(0===g.length){d._listeners?
"function"===typeof d._listeners?d._listeners=[d._listeners,b]:f(d._listeners)&&(d._listeners.push(b),d._listeners.warned||(g=10,"undefined"!==typeof this._events.maxListeners&&(g=this._events.maxListeners),0<g&&d._listeners.length>g&&(d._listeners.warned=!0,console.error("(node) warning: possible EventEmitter memory leak detected. %d listeners added. Use emitter.setMaxListeners() to increase limit.",d._listeners.length),console.trace()))):d._listeners=b;break a}j=g.shift()}}return this}this._events[a]?
"function"===typeof this._events[a]?this._events[a]=[this._events[a],b]:f(this._events[a])&&(this._events[a].push(b),this._events[a].warned||(g=10,"undefined"!==typeof this._events.maxListeners&&(g=this._events.maxListeners),0<g&&this._events[a].length>g&&(this._events[a].warned=!0,console.error("(node) warning: possible EventEmitter memory leak detected. %d listeners added. Use emitter.setMaxListeners() to increase limit.",this._events[a].length),console.trace()))):this._events[a]=b;return this};
a.prototype.onAny=function(a){this._all||(this._all=[]);if("function"!==typeof a)throw Error("onAny only accepts instances of Function");this._all.push(a);return this};a.prototype.addListener=a.prototype.on;a.prototype.off=function(a,b){if("function"!==typeof b)throw Error("removeListener only takes instances of Function");var g,e=[];if(this.wildcard)g="string"===typeof a?a.split(this.delimiter):a.slice(),e=d.call(this,null,g,this.listenerTree,0);else{if(!this._events[a])return this;g=this._events[a];
e.push({_listeners:g})}for(var j=0;j<e.length;j++){var i=e[j];g=i._listeners;if(f(g)){for(var n=-1,k=0,l=g.length;k<l;k++)if(g[k]===b||g[k].listener&&g[k].listener===b||g[k]._origin&&g[k]._origin===b){n=k;break}if(0>n)break;this.wildcard?i._listeners.splice(n,1):this._events[a].splice(n,1);0===g.length&&(this.wildcard?delete i._listeners:delete this._events[a])}else if(g===b||g.listener&&g.listener===b||g._origin&&g._origin===b)this.wildcard?delete i._listeners:delete this._events[a]}return this};
a.prototype.offAny=function(a){var f=0,b=0,d;if(a&&this._all&&0<this._all.length){d=this._all;f=0;for(b=d.length;f<b;f++)if(a===d[f]){d.splice(f,1);break}}else this._all=[];return this};a.prototype.removeListener=a.prototype.off;a.prototype.removeAllListeners=function(a){if(0===arguments.length)return!this._events||e.call(this),this;if(this.wildcard)for(var f="string"===typeof a?a.split(this.delimiter):a.slice(),f=d.call(this,null,f,this.listenerTree,0),b=0;b<f.length;b++)f[b]._listeners=null;else{if(!this._events[a])return this;
this._events[a]=null}return this};a.prototype.listeners=function(a){if(this.wildcard){var b=[],a="string"===typeof a?a.split(this.delimiter):a.slice();d.call(this,b,a,this.listenerTree,0);return b}this._events||e.call(this);this._events[a]||(this._events[a]=[]);f(this._events[a])||(this._events[a]=[this._events[a]]);return this._events[a]};a.prototype.listenersAny=function(){return this._all?this._all:[]};"function"===typeof define&&define.amd?define("lib/EventEmitter2",[],function(){return a}):i.EventEmitter2=
a}("undefined"!==typeof process&&"undefined"!==typeof process.title&&"undefined"!==typeof exports?exports:window);define("utils/WCEvent",["lib/EventEmitter2"],function(i){if(!window.WCEvent){var e=window,b=new i({wildcard:!0,delimiter:"."});e.WCEvent={on:function(){b.on.apply(b,arguments)},emit:function(){b.emit.apply(b,arguments)}}}return window.WCEvent});
define("utils/EventBasedValidator",["utils/webi18n!validatorStrings","jquery","utils/WCEvent"],function(i,e,b){return{getInstance:function(){window.eventBasedValidator||(window.eventBasedValidator={onValidateUniqueDocName:function(a){b.on("validation.uniqueDocName",a)},createUniqueNamesObj:function(){return{errors:[],newDocs:[],newDocsDOMElems:{},excludedProjects:{},localClashFound:!1,addDoc:function(a,b){if(a.val()){var f=a.val().toLowerCase();this.newDocsDOMElems[b+"_"+f]?(this.newDocsDOMElems[b+
"_"+f].push(a[0]),this.localClashFound||(f={msg:i.t("PROJ_CREATION_SPECIFY_UNIQUE_DOCNAMES"),element:this.newDocsDOMElems[this.projectID+"_"+f],docRowObj:this},this.errors.splice(0,0,f),this.localClashFound=!0)):(this.newDocsDOMElems[b+"_"+f]=a,b&&!this.excludedProjects[b]&&this.newDocs.push({docName:f,projectId:b}))}},excludeProject:function(a){this.excludedProjects[a]=!0},isOk:function(){return 0==this.errors.length}}},validateNamesGlobally:function(a){a||(a=this.createUniqueNamesObj());b.emit("validation.uniqueDocName",
a);0<a.newDocs.length&&e.ajax({url:"GetDocumentsByNameAndProjectID.jsp",dataType:"json",method:"POST",async:!1,data:{data:JSON.stringify({docs:a.newDocs})}}).done(function(f){if(f.docs&&0<f.docs.length)for(var b=0;b<f.docs.length;b++){var c={msg:i.t("NAMECONFLICTEXCEPTION_ADV_TAG",f.docs[b].docName,f.docs[b].projectName),element:a.newDocsDOMElems[f.docs[b].projectId+"_"+f.docs[b].docName.toLowerCase()]};a.errors.push(c)}});for(var d="",f=0;f<a.errors.length;f++){var c=a.errors[f];c.msg&&(d+=c.msg+
"\n");c.element&&c.element.addClass("validationHighlight")}d&&alert(d)}});return window.eventBasedValidator}}});
define("pages/wctaskexecution/WcTaskExecutionPage","wcr/webcenter_html ./PageSection utils/EventBasedValidator jquery wcr/AddDocument wcr/DocumentsTable wcr/validate".split(" "),function(i,e,b,a){function d(a,b){try{if(!a.taskID||0==a.taskID.length)alert("No task to process.");else{this.taskID=a.taskID;this.projectID=a.projectID;this.loggedInUserID=a.loggedInUserID;this.loggedInUserFullName=a.loggedInUserFullName;this.isProjectActive=a.isProjectActive;this.isTaskEditable=a.isTaskEditable;this.isChangeable=
a.isChangeable;this.isStatusEditable=a.isStatusEditable;this.canChangeAssignee=a.canChangeAssignee;this.isTaskStarted=a.isTaskStarted;this.isTaskCompleted=a.isTaskCompleted;this.taskExecution=a.taskExecution;this.pageSections={};this.langArr=[];this.setLanguageStrings(b);this.exitConfirmNeeded=!0;this.changeBtnEnabled=this.downloaDoc=!1;this.eventNames="change.changeDetect select.changeDetect keyup.changeDetect";this.eventSourceSelector="textarea, select, input, div";this.eventName_Img="click.changeDetect";
this.eventSourceSelector_Img="img";var d=this;window.onbeforeunload=function(){return d.confirmExit()}}}catch(e){alert("Problem in WcTaskExecutionPage constructor: "+e)}}d.prototype.setLanguageStrings=function(a){try{if(a)for(var b in a)this.langArr[b]=a[b]}catch(d){alert("Problem in WcTaskExecutionPage.setLanguageStrings() method: "+d)}};d.prototype.addSection=function(a,b){try{a.parent=this,a.initialize(b),this.pageSections[b]=a}catch(d){alert("Problem in WcTaskExecutionPage.addSection() method: "+
d)}};d.prototype.removeSection=function(a){try{this.pageSections[a]&&delete this.pageSections[a]}catch(b){alert("Problem in WcTaskExecutionPage.removeSection() method: "+b)}};d.prototype.show=function(){try{var b=0,c;for(c in this.pageSections){var d=this.pageSections[c];d&&(d.show(),"HIDE"!=d.state&&b++)}1<b?a("#lowerButtonRow").show():a("#lowerButtonRow").hide()}catch(e){alert("Problem in WcTaskExecutionPage.show() method: "+e)}};d.prototype.reset=function(){try{for(var a in this.pageSections){var b=
this.pageSections[a];b&&b.reset()}}catch(d){alert("Problem in WcTaskExecutionPage.reset() method: "+d)}};d.prototype.isModified=function(){try{for(var a in this.pageSections)if(this.pageSections[a].isModified())return!0}catch(b){alert("Problem in WcTaskExecutionPage.isModified() method: "+b)}return!1};d.prototype.checkIfModifiedAndUpdateButtons=function(a){var b=!1;"undefined"!=typeof a&&("target"in a&&"defaultValue"in a.target&&"value"in a.target&&a.target.defaultValue!==a.target.value)&&(b=!0);
(this.isModified()||b)&&!this.changeBtnEnabled&&this.updateButtons()};d.prototype.updateButtons=function(){a(this.eventSourceSelector).off(this.eventNames);a("[name='cancelButton']").val(this.langArr.cancel);var b=a("[name='createWCTask']");b.prop("disabled",!1);b.show();this.changeBtnEnabled=!0};d.prototype.registerEventToDetectChanges=function(){a(this.eventSourceSelector).on(this.eventNames,this.checkIfModifiedAndUpdateButtons.bind(this));a(this.eventSourceSelector_Img).on(this.eventName_Img,this.checkIfModifiedAndUpdateButtons.bind(this));
this.pageSections.attributes.myAttrCat&&this.pageSections.attributes.myAttrCat.valueChangedListeners.push(function(){this.updateButtons()}.bind(this));require(["utils/WCEvent"],function(a){a.on("btnClicked.UploadNewVersion.*",function(){this.updateButtons()}.bind(this))}.bind(this))};d.prototype.confirmExit=function(){try{if(this.exitConfirmNeeded&&this.isModified()&&!this.downloaDoc)return this.langArr.PAGE_EXIT_CONFIRM}catch(a){alert("Problem in WcTaskExecutionPage.confirmExit() callback method: "+
a)}this.downloaDoc=!1};d.prototype.changeButtonClicked=function(d){try{var c="",e=!0,g;for(g in this.pageSections){var i=this.pageSections[g];if(i&&i.isModified()&&(c+=i.name+" ",!i.validateFormParams(d))){e=!1;break}}0==c.length&&(alert(this.langArr.NO_CHANGES_MADE),e=!1);if(e){var j=b.getInstance(),p=j.createUniqueNamesObj();j.validateNamesGlobally(p);if(!p.isOk())return!1;a("#modifiedSections").val(c);a("#actionValId").val("ChangeTaskOnExecutionPage");this.exitConfirmNeeded=!1;a("#actionformId").submit()}}catch(n){alert("Problem in WcTaskExecutionPage.changeButtonClicked() method: "+
n)}};d.prototype.cancelButtonClicked=function(){try{a("#actionValId").val("GoBackFromTaskExecutionPage"),this.exitConfirmNeeded=!1,a("#pageModifiedId").val(this.isModified()?"1":"0"),a("#actionformId").submit()}catch(b){alert("Problem in WcTaskExecutionPage.cancelButtonClicked() method: "+b)}};d.prototype.startButtonClicked=function(){try{confirm(this.langArr.SAVE_AND_START_WCTASK_CONFIRM)&&(a("#taskStatusInput option")[1].selected=!0,this.pageSections.genTaskInfo.modified=!0,this.changeButtonClicked())}catch(b){alert("Problem in WcTaskExecutionPage.startButtonClicked() method: "+
b)}};d.prototype.completeButtonClicked=function(){try{if(confirm(this.langArr.SAVE_AND_COMPLETE_WCTASK_CONFIRM)){for(var b=a("#taskStatusInput option"),c=0;c<b.length;c++)if("00001_0000000003"==b[c].value){b[c].selected=!0;break}this.pageSections.genTaskInfo.modified=!0;this.changeButtonClicked(!0)}}catch(d){alert("Problem in WcTaskExecutionPage.completeButtonClicked() method: "+d)}};d.prototype.editTaskDetailsClicked=function(){try{if(a("input[name=projectTaskID]").val(this.taskID),a("#actionValId").val("ViewTaskDetails"),
0<a("#actionformId").length)try{a("#actionformId").submit()}catch(b){}}catch(c){alert("Problem in WcTaskExecutionPage.editTaskDetailsClicked() method: "+c)}};d.prototype.showTaskWorkflowClicked=function(){try{a("input[name=projectTaskID]").val(this.taskID),a("#actionValId").val("ViewTaskWorkflow"),a("#actionformId").submit()}catch(b){alert("Problem in WcTaskExecutionPage.showTaskWorkflowClicked() method: "+b)}};return d});